2.7.22
===
ba8c021 [packaging] Update mocks for rpmbuilder mock format
7f40007 (packaging) Update debian build-depends to be ruby1.8 so that the shebang is correct after install and ruby1.9.1 isn't used on newer debians.
96be982 (packaging) Update build_defaults to remove EOL platforms (natty, f15, f16).
fea3cb6 Improve CVE 2013 1654 SSLv2 Downgrade Master test
fd758ad Remove acceptance test for yaml parsing that was no longer valid
5926d1a (#20584) Only deserialize expected objects from YAML
e8c30cb Vendor safe_yaml 0.9.2
ee741eb Fix installation of vendored libs
2333fa4 Add vendoring system into puppet
535da9b Add acceptance test for report processing
788fdaf Don't keep Gemfile.lock checked in.

2.7.21
===
570e4d2 Update CHANGELOG, PUPPETVERSION for 2.7.21
4b0a7e2 Add missing 2.7.20 CHANGELOG entries
3ecd376 (#19391) Find the catalog for the specified node name
c240299 (#19392) Don't validate key for certificate_status
a1c4abd Don't assume master supports SSLv2
60eebed Don't require openssl client to return 0 on failure
12728c0 Display SSL messages so we can match our regex
70cdc63 Don't assume puppetbindir is defined
9cbfb9d Remove unnecessary rubygems require
0f4ac20 Run openssl from windows when trying to downgrade master
7d62aa0 Separate tests for same CVEs into separate files
61109fa Fix order-dependent test failure in rest_authconfig_spec
a3d3c95 Always read request body when using Rack
79b875e Acceptance tests for CVEs 2013 (1640, 1652, 1653, 1654, 2274, 2275)
632e12d (#19531) (CVE-2013-2275) Only allow report save from the node matching the certname
7df884b Fix module tool acceptance test
4a272ea Updating module tool acceptance tests with new expectations.
0a7d61f (#19392) (CVE-2013-1653) Validate instances passed to indirector
be920ac (#19151) Reject SSLv2 SSL handshakes and ciphers
516142e (#19391) (CVE-2013-1652) Disallow use_node compiler parameter for remote requests
bd942ec (#14093) Restore access to the filename in the template
cf6cf81 (#14093) Remove unsafe attributes from TemplateWrapper
f2a3d5c (#19393) Safely load YAML from the network

2.7.20
===
cb9696d Update lib/puppet/version.rb for 2.7.20
1d01f2a Update lib/puppet/version.rb for 2.7.20-rc1
d16d357 (#17458) Add acceptance test for executing external subcommands
fd92eb1 (#17458) Partial revert of "don't rebuild regexp every time"
28229d7 Revert "(#17458) Load 'puppet' at the right time"
b5ed15b (#17458) Load 'puppet' at the right time
0524a0a (#7422) Support arrow syntax with metaparams
fc6571e rm packaging artifacts in rpm spec, debian rules
b1adcd2 Fix build targets for 2.7.x
0cc80ad Preserve timestamps when installing files
6da5aa8 Replace dashes with dots for gem version
5c61f32 (#17260) Include link to information about deprecation
858e4b4 Update Rakefile to make rspec optional
0c1991f Remove the asc file from the source of spec file
bd0caf5 (#17260) Warn when variables contain hyphens
35b9ff2 Edit description of hyphenated variables compatibility setting
5ee2558 (#10146) `-` in variable names should be deprecated!
d892859 (#16791) Remove tests for unused behavior
aba3c67 (#16791) Re-instate deprecated symbolize and symbolizehash!
65b5c5c Eliminate `symbolize` everywhere, and remove it.
3cda4f4 (#16791) Revert "Merge branch 'feature/2.7.x/json-terminus-backport' of https://github.com/daniel-pittman/puppet into 2.7.x"
1e5baee (#16791) Revert "Maint: Fix intermittently failing spec test"
13ab956 (#16791) Revert "Merge branch 'perf/2.7.x/backport-activesupport-hook-disabling' of https://github.com/daniel-pittman/puppet into 2.7.x"
5c96254 (#16581) Fix mis-stubbed test
c305a32 (#11042) indirect via the property to convert group names to numbers
f08fc39 (#16581) Refactor code for sid validation
92f0688 (#16798) Add more tests to cover revoke by serial number
b55d885 (#16798) Update revocation by serial number documentation
5e8236f (#16798) Fix certificate revocation by serial number
c60a82d (#16581) Deprecate sid_for_account
c86e685 (#16581) Use native Win32 APIs to resolve SIDs in file provider
9291ae2 (#16581) Use native Win32 APIs to resolve SIDs in providers
3d360e7 (#16581) Documentation changes
be848e6 (#16581) Use win32-security gem to resolve SIDs
da3aea4 (#16581) Refactor code for converting string and binary sids
e6865c4 (maint) Update mailmap for git shortlog
dc50ec7 (#16922) Quote strings that contain ":"
b2e31b5 fail better in package repo rake tasks
5e7cce5 Disable ActiveSupport::Dependencies hooks.
68dea3d zaml: handle multi-line map keys and array values correctly.
67e5957 zaml: don't use backreferences on strings
fbca3b0 zaml: avoid calling emit when we don't have anything to output
4f6289b zaml: add whitespace for readability.
83defc0 zaml: rework strings for correctness and speed
e45961f Maint: Fix intermittently failing spec test
69315c2 Implement `Fixnum#ord` for Ruby 1.8.5
f60e402 tagging: use a static regexp rather than rebuilding it
314c3da file_serving: avoid rewriting paths if possible.
b54f8cd log_paths: memoize the entire value, not just part of it.
33c127b zaml: speed micro-optimization for Time output
e70273b whit: cache the `to_s` result.
9099a42 zaml: don't sort object attributes for output
20efe94 util: don't rebuild regexp every time we invoke absolute_file?
58f6ca1 parser/files: use a cheaper test for "is this path absolute?"
275c94d Eliminate remaining uses of FileCollection.
912ed34 FileCollection is a memory loss, not a memory win.
89e0f14 type: support implicit "identity" transformation
397dfa8 monkey_patch: cache Symbol to_proc result.
54c4f0a lexer: remove some unused stats collection
9176f5c tagging: document why fixing this horror is hard.
aca7959 type: memoize key_attributes for types.
8173a6e Avoid object creation/destruction when possible.
5e3fbca (Maint) Remove fragile test
fd8343a zaml: unify on a single definition of `to_zaml` for Symbol
4d4a75a zaml: statically determine the to_ascii8bit implementation.
fbd5105 Use `intern` rather than `symbolize` it Puppet::Type
c0e5f4d Implement Symbol#intern when it is missing.
141c83b Add catalog JSON terminus to improve performance.
a0287bf Implement a JSON file terminus to mirror YAML.
61a34d3 (#2888) Fix race condition with puppetdlockfile
315ebad (#2888) Add settings catalog info to README_DEVELOPER
fe1f4a2 (#4680) Reject CA network operations when master CA is disabled
312b467 Git ignore an .rvmrc file in the root of the project
f0ef301 (#16330) Update ZAML to latest upstream.
f8a4ddc (#16376) Fix rails compatibility layer for activerecord < 3.0
a1c4467 Fixup apple package plist for use with packaging repo
e84f448 (#16347) Qualify references to windows-pr gem
68c61fa (#16347) Replace \x92 character with apostrophe
0e7fc8d Update copyright years in LICENSE
81c8afa Skip symbolic link demanding test on Windows
d260b90 RSpec 3 is deprecating `expect {}.should` - respect that.
dff6e53 (maint) Confine pty-based test to non-Windows hosts.
b48a172 (Maint) Fix syntax and semantic erros in test
da24d54 (#15959) Fix groupadd/useradd spec when run on non-linux systems
bd875f5 (#16208): Correct spec test to match new failed parameter message
a753b86 Maint: Fix inconsistent expect-should usage
1a9d122 Maint: Fix leaked tempfile handle
d9ab06f (#16208) fix tests
f30af22 (#16208) use #{ref} instead of #{type} #{title} as suggested by dpittman
cb3c912 (#16208) Better error messages for failed parameter validation
294fae2 Port the SemVer test from Test::Unit to RSpec.
14d1fdc Don't make executables in /tmp in posix_spec
ca36893 Backport fix for commandline spec
6f556ef Don't pollute Functions namespace in shellquote function
13cb623 (#8714) Don't follow symlinks in SELinux FS detection
8fa6575 Make SELinux internal helper functions private.
0a72c5c Fix yum repo path in yaml file
0620497 (#15797) Update chkconfig test to reflect reality
775d0dc Revert "(#15797) Change the argument to chkconfig from 'on' to 'reset'"
f9463ea (#15731) Add clarifying comments to host.rb
82ebe28 Remove version check regex from puppet
67f8b0b Remove broken dual build-requires of facter in redhat spec
2ea1e98 Add in manpage listings that should have been there
b1648b2 Fixup Rakefile to use packaging repo
a670a4f Move and template all apple pkging artifacts to ext/osx
302248b Add debian packaging artifacts and template
5dc896b Move redhat spec file to erb template in ext/redhat
b67e4dc (#16019) Don't add Unix paths to Windows search path
489352b (#16119) Recognize carriage return escape sequence
db74432 Switch off building gem for 2.7.x
77afeba Add yaml files
2b06b7e (#15193) Fix windows failing on unix style paths
5e84c97 (#15560) Delete user's profile after deleting account
94aaf15 (#15193) Fix StaticCompiler#store_content
58f9679 (#15193) Add spec test coverage for static compiler
2bbc4e4 Document the different forms of catalogs to help test writers
1a432fd (#15193) Document how to use the static compiler
1820927 (Maint) Stop watchr from reading non-existent spec.opts
576fd56 Whitespace only cleanup
67b9227 (#15560) Create the user's profile if managehome is true
1075b74 (#15560) Refactor LogonUser
7efbfc6 Maint: Large or complex HEREDOC strings w/ no interpolation should be single-quote type
13e0109 (#15591) Skip test that causes segfault on Windows
f10d364 maint: remove .rspec entirely
7b4ac10 (#15731) Move explicit fingerprints to hash
4ffc02d (Maint) Enable colorized rspec output on Windows
700caba (#15739) Bump report_version since #10064 change its format
1a2e8fc (#14822) Use feature confine for feature tests during run
c6e1aa3 (#14822) Re-evaluate features if they previously were false
65dbdea (#15797) Disable RedHat services in all run levels
5ef0df0 (Maint) Whitespace only cleanup
7ca6b70 (#15797) Add test coverage for redhat service provider
d2012ae (#15797) Change the argument to chkconfig from 'on' to 'reset'
b2c3675 Fix typo in create_resources function's description string
48a9cc2 (#15464) Exclude gem command from bundler
54ea4fe Revert "Revert "Merge branch 'ticket/2.7.x/15464_a_gemfile_would_improve_contributor_on-boarding' into 2.7.x""
76ef99b Revert "Merge branch 'ticket/2.7.x/15464_a_gemfile_would_improve_contributor_on-boarding' into 2.7.x"
6350e6c (#15959) Do not support system group on Solaris and HP-UX
c404d99 maint: Reduce stubbing in groupadd spec
c50f552 maint: Rearrange tests in groupadd unittests
5e64c1f (#15959) Do not support system user on Solaris and HP-UX
03c7ddf1 maint: Reduce stubbing in useradd spec
e111f56 maint: Rearrange tests in useradd unittests
d7cb3c7 (#15464) Make Puppet.version settable via Puppet.version=
f9cfec7 (#15912) Make function access consistent
e067c2a (#15693) Allow restart command to be specified
07f0b0e (#15464) Make Puppet usable as a Gem from source
b33d517 Move Puppet version into lib/puppet/version.rb
1c1a383 (#15464) Make contributing easy via bundle Gemfile
83cfe9d (Maint) Fix rspec options file
86dac63 (Maint) Skip crontab filetype tests on Windows
dd25c9e (#15346) Add spec test for --source when checking latest
e9d10ca (#15346) add --source to the gem list command
1d80007 (#14283) Call Tempfile#close and #unlink separately
7a72361 (#14283) Raise an error when crontab returns non-zero on AIX
d9c7698 (maint) Refactor filetype specs
bbdbb06 (maint) Consolidate flat file tests
5ceb55c (Maint) Add logging for when Puppet is enabled/disabled.
07aeef3 (#15940) Add test coverage for rdoc exclude option
f08dd53 (#15940) Update puppet doc to ignore files and templates in modules
08c62da (#7442) solaris: return "-1" for password_max_age when password aging is disabled
e0b1e40 (#7442) solaris: add tests for password_max_age attribute
0a41053 Always set log functions on root environment
b47e910 Use TestHelper in old unit tests
9815de4 Convert expect..should to expect..to in configurer spec
f2a4cca (maint) Remove spurious `puts` line
c95bda7 (maint) Whitespace cleanup
ed22b06 (maint) Include backtrace in re-raised exception
c8152d4 (#15920) Make forward-sexp ignore comments in puppet-mode.el
4cd6686 (#14283) Fix suntab filetype when run as normal user
d2b4f08 maint: Refactor suntab and aixtab filetype
a7d6c3d Add Puppet::Parser::Functions::clear for specs
279c323 Clear Environment.current when calling Environment.clear
536b68c Check that function loading worked correctly.
abc7885 Avoid stubbing Thread::new due to issues in newer mocha
fdb8ca3 Rename specs to end in _spec.rb
9c361f1 Don't require mocha in spec_helper
6d3d591 Fix stubbing on nil in some specs
60a6a2a (#14515) Tests fail with mocha 0.11.4
d2e5268 (#10915) Add test for provider throwing NoMethodError
9e26fe0 (#10915) Fix tests to work with new parameter checking
da7cd8e Don't mask NoMethodErrors
fcd4957 (#15521) Convert to using host stub wrapper
fbede51 Fixed #11686 - Updated documentation for exec timeout
6f7303a Mark git diff --check as inline code
cf04e5e Make the example in CONTRIBUTING imperative and concrete
9862940 Add HOWTO hint on topic branches in CONTRIBUTING
9c60ed3 (Maint) Whitespace cleanup of CONTRIBUTING.md
65b35a8 (Maint) Simplify CONTRIBUTING.md
b61d041 (#15731) explicit fingerprint digest for pson
6dcf122 (#15731) Full certificate metadata for pson
31fac81 (#15665) Fix issue with eix-update on newer eix (>=0.25.2).
adfc27e Maint: Fix borked help/man output for node clean
367926a (#15264) Custom title patterns can fail cryptically.
b8ca748 (#11727) Support STDIN for `puppet parser validate`
04ba8e2 Add stdin parsing to puppet parser validate
368a1cb Fix for #3984 -- SELinux warns about changes it doesn't actually make

2.7.19
===
85f5543 Ruby 1.9.3 has a different error when `require` fails.
b2d08a4 (#15291) Add Vendor tag to Puppet spec file
7611753 Add packaging support for fedora 17
b540aa0 (#15471) Fix setting mode of last_run_summary
7c7cffe (#15471) Ensure non-root can read report summary
a257105 Use Win32 API atomic replace in `replace_file`
a619bfd Add additional commits to CHANGELOG missed in 2.7.19rc1
1dd660a (Maint) Remove reference to Patchwork
a26d1ee Replace "the short version" with outline
b73d0dd (#15595) Improve message on SSL errors
9567ec8 (#15595) Clear up tests around ssl errors
ccca77f use error_message instead of error
3809b59 updates as requested
e7b3049 (#15595) Offer better errors for certificate validation errors
6a43e96 Update CONTRIBUTING.md
c44973c (Maint) Remove some more ambiguity
c236001 Use rspec 2.11 compatible block syntax
b504ab7 Fix buggy resource title tests
00b563d (Maint) Be more honest about submission methods
b90c92b (Maint) Clarify that Redmine tickets are mandatory
62c14bd (Maint) Clarify which branches changes should be based on
c0a0a45 tidy.rb: Added info about the default value of 'type' to the doc.
2d994c2 Switch Rakefile off deprecated rake/gempackagetask
7324f54 Update main readme to have links to contrib and dev docs
57a74f7 (13070) Mark files as loaded before we load
a23cf6e (Maint) Don't assume paths are absolute
dd96d84 Determine packaging version with git describe
04fbccd Try again to avoid circular dependency in file indirections
3e23686 Avoid circular requirement in FileMetadata indirection
125ecec (Maint) Spec test wasn't testing anything
4c18d08 (#14964) Unlink Tempfiles consistently across different ruby versions
690c39b (Maint) Require the right file for md5
44ada58 Extract host validation in store report processor
91df2f3 Use cross-platform absolute paths in file_serving tests
c7e4ca7 (#15221) Create /etc/puppet/modules directory for puppet module tool
c05489b (Maint:) Fix bad doc strings for two settings ("wether")
33fce73 Try again to avoid circular dependency in file indirections
b227aa1 Remove useless tests for Envelope
86ccca4 Clear deprecation warnings between tests
d7078c3 Avoid circular requirement in FileMetadata indirection
03d546e (Maint) Document common Windows issues
761b48f (#11868) Use `Installer` automation interface to query package state
cc4d8d2 Don't allow resource titles which aren't strings
37742db Eliminate require calls at runtime.
be5fcf4 Fix broken TransBucket transformation tests.
8f99187 Fix broken ability to remove resources from the catalog.
9bd4fd3 Fix type check when transforming catalog.
825b80d Fix all trivial "should to must" errors in our tests.
7a7bea7 Enforce "must not should" on Puppet::Type instances in tests.
39f0bf4 (#14962) PMT doesn't support setting a relative modulepath
39f425f (#15078) Document USR2 log rotation signal
300fce9 (#14909) Update createpackage.sh to resolve permissions issues
0d5a46a (#14600) Fix cleanup of tempfiles in file_spec
2141905 (maint) Add --test to puppet run
ddf8358 Update logrotate config to not restart puppetmasterd
da771cb (maint) Add symlink stub to gentoo service provider spec
0e87fe1 Add comment to upstart provider explaining exclusion of 'wait-for-state'
0219818 (#14531) Change default ensure value from symlink to link
0cab9ee Upstart code cleanup, init provider improvement
91628be Add spec test for network-interface-security
b60ad19 Add basic service resource test to upstart acceptance
a6245f9 Handle network-interface-security in upstart
60e37b6 Add exclude list to upstart provider
2911fec (#15027, #15028, #15029) Fix upstart version parsing
8efc492 (#13489) Use let to memoize instance variables
dc5f57c (#13489) Synchronously start and stop services
3ada851 (#14964) Don't fail if we can't unlink the Tempfile on Windows
0b01bb3 (#14860) Fix puppet cert exit status on failures
d7e77eb (#14749) Clear reference to invalid task after saving
a2d9597  (#13008) Allow scheduled task arguments to be specified
c6af946 (#13009) Compare scheduled task commands using backslashes
b572810 (#14599) Handle ENOTDIR in file type
2fc7191 (#9160) Change logging facility to debug for not supported provider features
0859364 (#13880) Add openrc spec - service with extreme long name
af6f7ba (#13880) Add openrc service provider for Gentoo and Funtoo
5146397 (#13379) Add path of pluginsync'd lenses to Augeas load_path automatically
087d5ae (#7285) Add spec for Augeas initialisation and file loading
06eb9a9 Fixes for #10915 and #11200 - user provider for AIX
ed73845 (#10354) added delete command to fix missing userdel flag in useradd provider

2.7.18
===
d804782 Reject directory traversal in store report processor
fd44bf5 Tighten permissions on classfile, resourcefile, lastrunfile, and lastrunreport.
4d7c9fd Use "inspect" when listing certificates
bd2820e Don't allow the creation of SSL objects with invalid certnames
f341962 Validate CSR CN and provided certname before signing
38c5a4e Add specs for selector terminuses of file_{content,metadata}
9e920a8 Fix whitespace inside parentheses
2d01c2b Use head method to determine if file is in file bucket
40ee670 Always use the local file_bucket on master
d881b4b Fail more gracefully when finding module files if no file is specified
20ab0e9 Reject file requests containing ..
10f6cb8 Add Selector terminus for file_content/file_metadata
ab9150b Deprecate IP-based authentication

2.7.17
===
30d89d3 (maint) Add symlink stub to gentoo service provider spec
ff1b37a Add comment to upstart provider explaining exclusion of 'wait-for-state'
6b854f7 Upstart code cleanup, init provider improvement
0f81d9a Add spec test for network-interface-security
a2c1e23 Add basic service resource test to upstart acceptance
2c85d4d Handle network-interface-security in upstart
ed00e74 Add exclude list to upstart provider
17cc177 (#15027, #15028, #15029) Fix upstart version parsing
b0ee6ad (maint) Add --test to puppet run

2.7.16
===
99fecc3 Update facter dep to reflect epoch 1
3a06246 (#8858) Explicitly set SSL peer verification mode.
cd4bee8 Test SSL setup code, not our stubbing of it.
ff052b8 (maint) Add mailmap to identify contributors
8dda6c2 (#14723) Fix http report description
ebf5386 Remove EL-related test changes from this commit.
2aea708 Revert changes to symbolic_modes.rb -- this test should indeed be pending (it should eventually work on Windows).
b601bb4 Update acceptance tests to use confine instead of skip_test loops
e619304 (#14761) Add boot, reboot to excludes list for redhat provider
7c1d8c2 (maint) Disable upstart spec test on windows
37df5c4 (#14615) Final stub fixes for the tests.
f11dfd6 (#14615) Fix provider spec tests to work on non gentoo systems
060810e maint: Make it easier to test the service provider
c0cb0fa (Maint) Close filehandles after read in upstart
0788ea2 (#14615) Exclude helperscripts in gentoo service provider
be6062c Apply commit from master that varies ports during tests
a45942b (#14297) Don't remove tty1 or rsyslog during upstart acceptance
466ab49 (#14297) Define agent in upstart acceptance test
f5d1f74 (#14297) Update upstart provider acceptance tests
3c5ef40 (#14297) Clean up upstart provider and tests
36c41e1 (#14343) Test cases for more forms of variable lookup
6cca061 (#14297) Add acceptance test for upstart provider
b9ed026 (#14297) Update spec tests for upstart provider
91827e8 (#14297) Handle upstart services better
3541db6 (#14343) Lookup in correct inherited scope
2d83e22 (Maint) Added test for fully qualified variable
c6e006e (#8174) Allow defines to reference topscope
e27adf4 Evaluate node classes either in top or node scope
a3d51b2 Removed topscope being overridden by node
53e0057 Use internal domain name for module tool tests
f4ba59e Use absolute_path in module install spec
ead9d25 (Maint) Color console output when the win32console gem is installed
a76d873 (#14424) Expand path of the target directory
95b75e1 Fix unit test failure in fileserver due to modules
da5361d Maint: De-genericize Puppet Forge references in module face
3b144bf Revert "maint: use relative paths to fixtures."
dae5539 (#14440) Hack to allow help faces to be used as API
e862cad Fix broken man page rake task
b26699a (#10146) `-` is not legal in variable names.
7ce9e17 maint: use relative paths to fixtures.
a7a532c Significantly improve compilation performance when using modules
12c5bda Fix a stub of ansicolor that I missed
ea740f6 Add Puppet::Util::Platform to abstract platform checks
91a4a7d Don't use features to check for color in logging
80fe59d Remove a bad test that can lead to random hangs...
0efb4c2 (#14296) Improve template function error message.
d5e0cdd (#14288) gem provider should tolerate bad lines.
d2b3ba0 Revert "Fix incorrect argument handling for expire in NodeExpirer"
7c7d4b6 Fix #14123 for Windows
1c9bec0 Fix incorrect argument handling for expire in NodeExpirer
7e92a7c Fix filebucket specs on Windows
a713f07 (#8778) Make '' == undef commutative in the DSL
24d4bb5 Revert "(#11004) Fix regex for pkg provider line matching"
34da6f7 (#13651) Use magenta, not purple in Facter::Util::Colors
e37b536 (#11004) Fix regex for pkg provider line matching
9b47110 (#13956) Fix failing spec tests
ca313dc (maint) Fix destinations_spec failure on windows
cde3bee Just change Puppet settings in tests, rather than stubbing.
6aa8441 (#11004) Support Solaris 11 output in pkg package provider
61e7d3c maint: Fix pkg_spec test
603b368 (#14173) Enforce that filebucket paths must be absolute
b7828ed (#3452) Autorequire user for cron
402a425 (#14127) Add integration tests for ssh_authorized_key
85ee441 maint: refactor integration specs for ssh_authorized_key
b4d1c65 (#14127) ssh_authorized_keys grammer fails on blank lines.
36d959a (#14123) Puppet shouldn't explode if PATH contains ~nonexistent_user
a281c48 (#13645) Add test cases to tagmail_spec
f6ac1bb (#13645) Do not open a smtp connection if nothing to report
f40cc71 (#12392): Colorize console output on Windows

2.7.14
===
42b20be (#13682) Fix acceptance test failures
dce3c32 (#13682) Rename Puppet::Module::Tool to Puppet::ModuleTool
5117e12 (maint) Ensure every file has a trailing newlines
c255414 (#14036) Add upstart tests
dc3bb9f (#14036) Handle upstart better
74e462f (#14060) Fix quoting of commands to interpolate inside the shell.
796a072 Modernize the style of the shell exec provider tests.
934ec89 Improve deprecation warning for dynamic lookup
0d9e852 Removed duplication of compiling a catalog
d67711d Cleaner test for create_resources doing nothing
2d3cc63 Fixing problem caused by activerecord
f1331ba Put back require 'puppet' in Puppet::Util
79bf4fa (#13299) Fix error message when agent is disabled
5178adc Update puppet.spec for rpm packaging
fb96747 Fixed old log test to match new autoflush behavior
878127f Make sure the log file writable
72d3b56 Default autoflushing of log files to true
9711d50 Created test that shows enc warning problem
d54100d (Maint) Fix order-dependent test failure
f531400 (Maint) Don't assume eventlog gem is installed on Windows
2957ffe Fix tempfile cleanup in specs
e2d6915 Fix communication_error acceptance test
27a5eb7 options[:ca_location] is a string not a symbol. Safer to pull Puppet::SSL::Host.ca_location since it is already set correctly.
c01cac9 (#13204) Don't ignore missing PATH.augnew files
7d27cd2 Use :as_platform in the smf service spec
876785a Use :as_platform in the redhat service spec
a7181c8 (#13640) Only agents should use next_agent_run
9aa302f Increased test coverage of scoping rules
163ab8c Use more descriptive terms for the differing scopes
2ddb3d6 Make new scoping look through inherited scopes
b519e24 Add tests for mixed inheritence/inclusion
48bce6b Remove dynamic option for lookupvar
2e78aad Implement newlookupvar() to replace dynamic scope
9c94586 Tests for deprecation warnings for dynamic scoping
2ff6fe4 (#13690) add comments to spec_helper
100f42c (#12392) Don't require eventlog gem on non-Windows platforms
b6ee08a (#13690) Update 2.7.x for spec_helper compatibility with external projects
1306611 (maint) Remove unnecessary step from puppet module build help
7afcb04 (#9167) Do not send email when nothing changes
a26ff16 [#13686] Fix directoryservices ShadowHashData code
b85cdc9 Fixup tests to work on CentOS 5
7e78094 (#13659) Convert fact values to string when searching database
fc2964f fix bug in Util#symbolizehash!
46d8973 (#13567) Fix create_resources name parameter bug
8d2ff89 (#12392) Add eventlog destination and log to it by default on Windows
bca4849 (#13636) Update Module Face copyright date
e7d3911 (#13649) Restrict module name matching
9cbda49 (#13643) Make the use of FileUtils.rm_rf secure
6819cf3 (#13642) Move search notice message
28531f8 (#13639) Don't send errors directly to stderr
45f8009 (#13638) Add SemVer#pre function
a2990a8 (#13737) Swap build_tree and format_tree method names
f0625ef (#12392) Created Windows eventlog message resource dll
245c6b7 (#9167) Do not send email when nothing changes
1b810b1 (#3581) Stop forking around: Add fork helper method
1de8bd7 Add Module Tool
e24755d (#13397) fix gem provider ensure=>latest bug
271c7f2 Make core changes needed for the puppet module tool
7994400 (#13367) Patch SemVer to permit ranges including pre-release components.
1342558 Monkey patch FileUtils.mv in Ruby 1.8.5
3f28268 (#12101) Make Puppet::Util::absolute_path? usable in autoloader
772f756 (#12101) Add shared context for specs to imitate windows or posix
8f84207 (#12466) unset X-Forwarded-For header
49eabd4 Quote strings containing hex numbers when generating ZAML
f5487bd (#13439) refactor spec helper for spec compatibility between 2.7 and master
db17d7c (#13380) Cron acceptance tests don't ensure cron actually installed
0498d55 (#13204) Workaround duplicate Augeas save events
7048e88 (#3022) File type's force attribute's description is incomplete
43003f5 (Maint) Consistently use the same agent fqdn
95c2b90 Stub execpipe using StringIO
ca32364 (#13117) Fix selmodule error on each_lines
bdb5922 (Maint) Don't change permissions on /etc/hosts
40ee256 Finally, stop using the `foo` name in the type_spec test.
245f1b9 Clean up the "foo" name in create_resources_spec.
eb2c71b Clean up "foo" name in global resource state.
ec5c4bf Document the problem with the `apply_to_device` and related methods.
d6da1b7 Fix hash comparison under RSpec with 1.8.5
0b7841a (#12960) Fix puppet resource <type> if type has no providers
6a31287 (#12981) Fix external subcommand exit status
a2208d0 (#10722) Add spec to verify that an error is logged on bad http
7207b68 (#10722) Refactor http_spec to use expectations
54e5d18 (#7986) Modify pkg provider to handle publisher
2e32924 (#7986) Cleanup pkg provider #2
113fc54 (#7986) Cleanup pkg provider #1
452e2c4 (#7592) Remove redundant call to String#to_s
ee554eb (#10722) Display errors on HTTP report submission failures
2973d5c (#11988) Work around Augeas reload bug when changing save modes
dfefc23 (#11988) Don't overwrite symlinks in augeas provider
d27af92 Stubbing time is risky, better an approximate compare.
01c8623 Don't stub the database in Puppet::Rails tests.
c4b3c84 (#9491) Preserve trailing slashes in FileSettings
27bd6bc (#8312) Fix zypper provider so ensure => 'latest' now works
c6d656a (#1076) Show warning if an empty group is specified
e1f9957 Maint: Remove unused mock objects in user spec
bc64d9b Maint: Use real objects in user spec
7eb4f5b Maint: Add a real provider class to user spec
d28c62a Maint: Remove unused variable in user spec
dba27c9 (#4862) Finally remove the event-loop library.
8e11766 (#4862) define_method is not a public method in Ruby.
11501a7 (#4862) `returning` is not a standard Ruby method.
30a23ac (#4862) Stop using EventLoop in the Puppet daemon.
a61c785 Updating CHANGELOG and lib/puppet.rb for 2.6.14
60b7aa5 Prior to this commit we hard coded paths in two tests that depended on our CI system directory structure. This made it hard to use our acceptance suite without also includin
600a6e7 Clean up and unify scratch database setup logic.
17a5302 Make PuppetSpec::Files methods available at module level.
3857e2b Fix stubbing of ActiveRecord that doesn't work in AR 3.2.*
dd6d36c Fix Rails compatibility code to be less stupid.
ade5965 Remove unnecessary fallbacks in change_{user,group}
0a09a64 Document uid/gid-related methods in Puppet::Util
2599d56 Copy owner/group in replace_file
ead36ff (#12463) eliminate `secure_open` in favour of `replace_file`
1469538 (#12460) use `replace_file` for the .k5login file
8461203 (#12462) user_role_add: use `replace_file` for /etc/shadow
0ad532a (#12463) add secure `replace_file` to Puppet::Util
76d0749 (#12459) drop supplementary groups when permanently dropping UID
50909b9 (#12458) default to users primary group, not root, in `asuser`
d00c5cc (#12457) add users primary group, not Process.gid, in initgroups
2732f25 (#12479) Don't make undef regexp match as the string undef.
a62f711 (#8193) Add support for new ssh keytypes in authorized_key provider
0efc65d (#8193) Add unit tests for new ssh keytypes
5dfc436 (#8193) Support new keytypes for sshkey
36e6642 (#8193) Support new keytypes for ssh_authorized_key

2.7.13
===
1f58ea6 Stub mktmpdir and remove_entry_secure in os x package providers
b7553a5 (#13260) Spec test to verify that mktmpdir is used
46e8dc0 (#13260) Use mktmpdir when downloading packages
b36bda9 Refactor pkgdmg specs
91e7ce4 Remove telnet Output_log parameter
0d6d299 Fix for bucket_path security vulnerability
19bd30a Removed text/marshal support

2.7.12
===
36ca299 Update packaging spec files for 2.7.12
ea116f5 Updating puppet.spec for 2.7.11-1, 2.7.11-2
6cb0690 Updating CHANGELOG for 2.7.12rc2
21cdab1 (#7592) Remove redundant call to String#to_s
5474941 (#11988) Work around Augeas reload bug when changing save modes
f4d9753 (#11988) Don't overwrite symlinks in augeas provider
c085327 (#8312) Fix zypper provider so ensure => 'latest' now works
28d5d9b (#12844) Fix a unit test relating to lockfiles
1d058ce (#12914) Allow puppet to be interrupted while waiting for child
8f626d0 (#12933) Better error message when agent is administratively disabled
30855bd (#12844) Agent lockfiles: backwards compatibility with 2.7.10/2.7.11
bcbe2a3 Revert "Merge remote-tracking branch 'masterzen/tickets/2.7.x/3757' into 2.7.x"
95810ad Revert "(#12844) Backwards compatibility for 'puppet agent --enable'"
2d8d9ce (#12881) Fix cron type default name error on windows
fcac8f7 (#12844) Backwards compatibility for 'puppet agent --enable'
5f0f269 Updating CHANGELOG and lib/puppet.rb for 2.7.12rc1
90fb5c8 Maint: Fix bad copy and paste
aa8a00b (#12725) Fix puppet agent --listen on Windows
c5d3825 (#11740) Wait on the handle from the PROCESS_INFORMATION structure
4f493a3 (#12564) Stub CHILDSTATUS in all test cases, not just failure cases.
0a7d05a Fix spec ordering failure on environment
8be0882 Typo: "Seperated" -> "separated"
86f2876 (#11408): Don't add execute bit to newly created files on Windows
673c425 (#11408) Skip default file permissions for sync'ed files on Windows
94f5f53 (#11408) Allow POSIX paths for files served to Windows agents
e323bce Fix a test that tries to create a dir with '*' in the name
03bd20b (#12631) Remove puppet module face
edf13c1 Fix range intersection monkey patch :& alias
f903c41 (#12256) Fix SemVer's range behavior to work with Ruby 1.9
bbff8d0 (#12256) module_requirements should include versions
7156e9c Update module and environment with functionality for the module tool
b6d052e (#12424) Update SemVer to use ranges and new comparison operators
2e98bd1 (#12645) Face actions should be able to set exit codes
50082e3 (#6663) Raise default key lengths in Puppet.
6fc9ccd (#12403) Always create a default log destination
babe7e4 Maint: Remove duplicate code from bad merge conflict
27476f6 (#12403) Refactor duplicate log setup
4720a94 (#12080) Implement a rich console logging prototype.
7f6947a (#12564) Paste execpipe commands together with spaces.
9e672a3 Add tests for the OpenBSD package provider.
74cc1eb Whitespace cleanup on OpenBSD package provider.
3d1c687 Possible fix for #8435 - remote package installation broken
25bbecf (#12310) Remove process_name instrumentation listener
0eab682 (#5454) add "autosign" argument
1e54190 (#10299) Use CheckTokenMembership to see if user has admin rights
44af10f (#10299) Refactor Windows administrator detection
a195717 (#12412) Don't assume the `root` user exists
2dd0f55 (#12106) Enhance the uninstall PMT action for UX
9ff4d1f Improve guidance for getting `puppet kick` to work.
6e39e58 Revert "(#12106) Enhance the uninstall PMT action for UX"
bad1d31 (#5454) Acceptance test to verify that pluginsync works properly with "features"
b222cd5 (#12106) Enhance the uninstall PMT action for UX
b8d77a6 Revert "(#12339) Adding basic search output formatting."
c01571a Revert "(#12339) Improving documentation around Puppet::Util::Terminal.width."
00685a2 Revert "(#12339) Clarifying source attribution."
3d518b0 (#12454) device_spec.rb fails with ruby 1.8.7-p357 and mocha v.0.9.12
6569af3 (#12244) All forge interactions should be centralized
15de31a (#11535) Edit scheduled_task type docs
163da19 (#11535) Update Windows exec provider docs
44bd741 (#11535) Update package type docs w/ Windows-specific quirks
4ec0bc8 (#11535) Update service type w/ Windows-specific quirks
7cfcbda (#11535) Update group type's docs w/ Windows-specific quirks
27aa560 Maint: Kill bogus allowdupe compatibility warning for FreeBSD
675ddbb (#11535) Update user type docs w/ Windows-specific quirks
3b0e359 (#12452) Make Puppet::Util::SELinux#read_mounts work on Ruby 1.9
e32a39c (#12464) Avoid unnecessarily reloading facts when node_name_fact is not set
f5067ed (#11535) Update file type with Windows-specific quirks
f16881f (#2927) Document symbolic modes in mode parameter
ba6b8b5 (#7485) Support zypper 0.6 with zypper package provider
0b95f3a (#12412) Mark symbolic file modes test as pending on Windows
8ae9247 (#12412) Skip ca acceptance test on Window agents
104192d (#12412) Refactor execution of echo in acceptance tests
dce3d58 (#12412) Use host-specific methods for generating tmp file/dir
75d484e (#12412) Warn when running hostname -f on Windows agents
e1f1f41 (#12412) Skip symlink tests on Windows
6201ecd (#12412) Refactor puppet_resource('exec')
1d1f687 (#12412) Refactor puppet_resource('host')
612f945 (#12412) Refactor puppet_resource('tidy')
0544ca7 (#12412) Skip cron on Windows
41e91d8 (#12412) Refactor puppet_resource('file')
fb28ce0 (#12412) Refactor puppet_resource('group') tests
85fd690 (#12412) Refactor puppet_resource('user') tests
9b4c97d Maint: General improvement of file type parameter doc strings
2a9562a Maint: Improve documentation of file type's source parameter
8b87452 Maint: Clarify ancient text about directories of symlinks
3365c85 (#12349) Order stderr output to fix acceptance test for `module list`
bfcb775 (#12339) Clarifying source attribution.
2575417 (#12405) Remove obsolete storeconfig purging code.
f73a741 (#7485) Support zypper 0.6 with zypper package provider
0e7d2f0 (#12339) Improving documentation around Puppet::Util::Terminal.width.
64abee3 (#11535) Call out differing config defaults on Windows
99e6708 (#11535) Platform agnosticism: Desc strings should refer to path separator instead of ':'
de58c0b (#12349) Order module list output
77f5a48 Symbolic file mode test fixes when no mode change happens.
9e2705b Maint: Update external_nodes setting description for changes from 2.6.5
d14ee6a Maint: Configuration settings shouldn't be referred to as "parameters"
5225d39 (#12386) Disable puppet kick on windows
984997f (#12372) Remove duplicate methods from certificate_request
a7bd569 (#12339) Adding basic search output formatting.
0578737 (#12356) Mention the expected exit codes in the hasstatus parameter doc
8fd54b1 Restore compatible `insync?` behaviour for matching arrays.
5520726 Fix bugs around the finer-grained insync? protocol.
7c9f861 Finer-grained protocol for property `insync?`.
c0e28b0 Add unit tests for the `insysc?` method of a property.
7f84c49 Property Spec cleanup: eliminate stubbing of resource and provider.
d66bb00 Property Spec cleanup: last let method extraction.
2775dd7 Property Spec cleanup: extract more let methods.
cd536ab Property Spec cleanup: remove unused instance variable.
a5d7bd6 Property Spec cleanup: remove some pointless extra stubs.
f17dbf7 Property Spec cleanup: extract property instance to a let method.
4157102 Property Spec cleanup: extract mock resource to let method.
8f9214e Property Spec cleanup: extract mock provider to let method.
47510b0 Property Spec cleanup: extract new subclass to let method.
03e3756 (#2927) Acceptance test for symbolic file modes.
51fa666 (#12363) Use Tempfile to generate temp files
7da2c58 Alternate, and portable, stubbing of execution for upstart spec.
a6c196f (#12349) Add module dependency errors to module list output
17d3e31 (#12268) Fix upstart test to work with String#each_line
2303a81 Revert "Merge pull request #396 from jeffmccune/feature/2.7.x/12088_windows_build_tasks"
a116726 (#12329) Allow faces when_rendering blocks to take options
a8a0f5f (#12268) String#each is not available in Ruby 1.9
20e03a9 (#11423) Better error when imported resources overlap.
f8d4be6 (#12296) Acceptance test for cycle detection in graphs.
d89423f Use natural ordering of Puppet::Provider.
83ca48d Make `Puppet::Provider` ordered.
3f88882 (#12296) Now that `Puppet::Type` is ordered, use that.
316de58 (#12296) Make `Puppet::Type` ordered.
37a3e82 (#12296) Test cycle detection on real Puppet::Type instances.
289dddc (#12188) Handle Win32 as well as Unix in pidfile tests.
25a0a69 (#10064) Add the Puppet environment to reports
3310470 (#12188) Better handling of PID file cleanup warnings.
744dfa4 Revert "Finer-grained protocol for property `insync?`."
4911faf (#12195) Fix future ruby warning messaves in process_name
f11201e (#12169) Correct redhat spec changelog chronology issue
5c97173 (#8855) Follow HTTP redirects is {app,pkg}dmg providers.
e81de1e (#6771) Check for ActiveRecord::Base instead of Puppet.features.rails?
3892875 (#6771) Stop other AR connection handling.
80ecd88 (#6771) Stop stubbing some feature tests.
ed24b80 (#6771) Disconnect any ActiveRecord connection after every test.
dd0e405 Document why we disable GC during the test runs.
afe93b7 Allow storeconfigs collector to accept parser resources
b0c8d2c (#12114) Qualify usages of `::File` to avoid conflict with file face
8ec0b6c Revert "(#12101) Add shared context for specs to imitate windows or posix"
33420a6 Revert "(#12101) Make Puppet::Util::absolute_path? usable in autoloader"
85e8cea (#12101) Make Puppet::Util::absolute_path? usable in autoloader
edc544d (#12101) Add shared context for specs to imitate windows or posix
60c6150 (#11804) Enhance PMT search action output
e415daa (#2279) Handle providers with multiple installed versions - ruby gems
e56dd9a (#2279) Convert package specs to not use mocks
d28768a (#10417) Disable `diff` on Windows by default
1c9e68c (#12088) Add windows:build task to build MSI package
1cb8462 (#12088) Add rake download and unpack handlers
d937ae3 (#6541) Use the same filebucket for backup and restore
e4f6bc9 Revert "(#11600) Remove module face"
f56a09a (#11955) Refactor to use IO.binread
d3cc7d6 (#12081) ensure user deletes respect managehome
8202729 (#11955) Monkey patch IO.binread and IO.binwrite
3abfa67 (#10296) Switch schedule tests from should to must
72a2fe0 (#5445) Create /var/lib/puppet in OS X Package
0f2bb27 (#6710) Fix Ruby 1.9.2 failures due to Array#to_s changes.
0f19cbe (#11990) Puppetdoc rdoc should also parse README.rdoc
a6255d2 (6404) Failing when no file is specified to backup
9345497 (2056) Launchd now supports overriding stop/start
11dc062 Removing resource stubbing from launchd tests
17ac2c1 (#11826) Fix error when no certs were printed to console from ca face
ad83422 (#5353) Change agent default to graph=true
5f5e103 (#11961) Apply and catch a timeout when contacting PyPI over XMLRPC
f2c407a (#12051) Send exec onlyif/unless command output to debug log
9e6a01f (#12070) Fix crontab value munging
b1eda36 maint: Add expected error messages to cron spec
c86c97d maint: Use a real provider class in cron spec
01e7200 maint: Remove unused vars in cron spec
38f386f maint: Fix indention in cron spec
d60a88e (#11930) Add validation of Windows paths in the generate function
aa48965 (#11930) Use Puppet::Util.absolute_path? to validate paths
1ffbeb1 (#11930) Use FileUtils.mkdir_p to recursively create directories
eee3511 (Maint) Remove dead code
64446ac (maint) Fix test 3360 to use per host cfg data
5d1b7fe (#11057) Add spec, should notify why a run is skipped
9e7ce16 (#11057) Note why a scheduled run was skipped in Puppet.
b26e03a Fix stage inheritance between multiple included classes
4f295f3 (#11451) Fix improper use of "defined" in the duplicate declaration error
132dca4 (#6710) Support relationships for resources defined by other constructs
982564e (#6710) Support relationship arrows between resource refs with title arrays
0e6d0a4 maint: Unify 'type' and 'classref' non-terminals in the grammar

2.7.11
===
01b57e9 (#12188) Better handling of PID file cleanup warnings.
a8b6088 (#12572) Add acceptance test to make sure no last_run_summary diff is printed
40480ed (#12572) Revert fix for #7106 and implement a more minimal fix
0486462 (#12412) Mark symbolic file modes test as pending on Windows
115ba71 Symbolic file mode test fixes when no mode change happens.
dde3945 Disable specs that use replace_file on Windows
4272d1f Disable replace_file on Windows
4bcbad4 Remove unnecessary fallbacks in change_{user,group}
ff372fb Document uid/gid-related methods in Puppet::Util
5f8f3ba Copy owner/group in replace_file
f0c9995 (#12463) eliminate `secure_open` in favour of `replace_file`
0c96703 (#12460) use `replace_file` for the .k5login file
7900a66 (#12462) user_role_add: use `replace_file` for /etc/shadow
f9f9961 (#12463) add secure `replace_file` to Puppet::Util
db0f872 (#12459) drop supplementary groups when permanently dropping UID
7f26d28 (#12458) default to users primary group, not root, in `asuser`
a96babf (#12457) add users primary group, not Process.gid, in initgroups
2f21546 Restore compatible `insync?` behaviour for matching arrays.
6ffe25b Fix bugs around the finer-grained insync? protocol.
133b739 Add unit tests for the `insysc?` method of a property.
908bfbd Property Spec cleanup: eliminate stubbing of resource and provider.
0d95eb7 Property Spec cleanup: last let method extraction.
5394413 Property Spec cleanup: extract more let methods.
f919e17 Property Spec cleanup: remove unused instance variable.
7bb261b Property Spec cleanup: remove some pointless extra stubs.
e81f02c Property Spec cleanup: extract property instance to a let method.
4fc4dd4 Property Spec cleanup: extract mock resource to let method.
9083fc6 Property Spec cleanup: extract mock provider to let method.
25d7c99 Property Spec cleanup: extract new subclass to let method.
3638651 (#2927) Acceptance test for symbolic file modes.
daa247e (#12296) Acceptance test for cycle detection in graphs.
1f0f40e Use natural ordering of Puppet::Provider.
3c1604a Make `Puppet::Provider` ordered.
50dc35d (#12296) Now that `Puppet::Type` is ordered, use that.
9962ac0 (#12296) Make `Puppet::Type` ordered.
b28d4ce (#12296) Test cycle detection on real Puppet::Type instances.
103a554 (#12310) Remove process_name instrumentation listener
f11ee44 (#12464) Avoid unnecessarily reloading facts when node_name_fact is not set

2.7.10
=======
e31369a (#6541) Use the same filebucket for backup and restore
0d8a22a (#11767) No longer necessary to delete ssl directory in each test
e1828ba Updated CHANGELOG for 2.7.10rc1
8da947f (#11996) Fix file content test after hash changes.
884fe75 (#11996) Fix file server recursion test after hash changes.
3fb0938 (#11996) Fix graph cycle reporting order after hash changes.
a758066 (#11996) Fix test failures due to hash processing order changes.
d6d6e60 (#11600) Remove module face
1847228 (#11499) Better validation for IPv4 and IPv6 address in host type.
a406a2e (#11802) Fix module list specs on Windows
13238af (#11803) Fix broken tests for uninstall action on module face
7fdd8a1 (#11888) Revert 483a1d9 for 2.7.x only
97fffa8 (#11803) Add uninstall action for the module face
2d4af0e (#11958) Improve error msg for missing pip command
032043e (#11046) Add support for user expiry in pw user provider
9b8829d (#11046) Improve pw group provider on FreeBSD
fb111ef (#10962) Make sure managehome is respected on FreeBSD
884381f (#11318) Add password management on FreeBSD
acd2f91 (Maint) Fix time-dependent certificate factory test failures
69dfb34 (#5246) Fix spec test expectations in 2.7.x branch
cd56926 (#11802) Add module list action
fecf5d6 (#11803) Add modules_by_path method to environments
dad8697 (#11802) Make Puppet::Module able to find module in specific path
520ac07 maint: Cleanup environment_spec
b27f3cc maint: Fix Puppet::Node::Environment::Helper specs
dfa539a maint: Remove unused method requires
b967da2 maint: Remove Module.modulepath
e1f2f37 (#11929) Always serve files in binary mode
24f2a65 (#2927) Support symbolic file modes.
48726b6 Finer-grained protocol for property `insync?`.
d3a33af Whitespace damage cleanup on property.rb
c58bfbc (#8341) Only load facts once per puppet run
2b0d3b8 (#3419) Fix OS X Ruby supplementary group handling
2ca9f9d (#11888) Switch up2date,systemd,redhat providers to osfamily fact
e0e31d5 (#5246) Puppetd does not remove it's pidfile when it exits
90bdef6 (#4855) Fix group resource in OS X
6c14a28 Build a Rake task for building Apple Packages
d5bef5e (#2773) Use launchctl load -w in launchd provider
5accc69 (#11714) Use `%~dp0` to resolve bat file's install directory
c865a80 Clean up launchd spec tests
24af732 (#11714) Add envpuppet batch file to run Puppet from source on Windows
7edaed5 (#11847) Don't hard code ruby install paths in Windows batch files
1978f52 Match old slightly different version of "hostname was not match"
ed9da67 Fixed #11844 - Typo in exec documentation
0ab4597 (#11764) Fix failing cron test
0f0aa1e Fixup two space merge conflict from 2.7.x => master
d092860 Retry inventory ActiveRecord transaction failure
a966eb3 (#11717) Set password before creating user on Windows
018f36d (#11293) Add password get/set behavior for 10.7
073ca03 (#11764) Fix cron jobs for passing block to method
4807c6d (#11740) Disable failing test on Windows
c751e01 Revert "Access user password hash in OS X 10.7"
11b8c5a Access user password hash in OS X 10.7
1e4bc59 (#11741) Use dns_alt_names instead of certdnsnames in acceptance tests
ca73283 (#11641) Properly track blockers when generating additional resources
31eef75 (#7296) Make the Debian service provider handle services that don't conform to the debain policy manual.
0ffe1ac (#4836) - Agent --disable should allow to put a message
7777d91 (#3757) - Refactor enable/disable to its own module
b434e3b (#3757) - Move enable/disable to its own lock
f7c2ea4 Fix failing tests with ruby 1.9.2 in the instrumentation framework
b2411b6 Use all lower-case file name for Puppet::Util::Instrumentation::Instrumentable
c560f71 Maint: Fix typo in usage example for create_resources function
751ef88 Set of faces to manage instrumentation listeners, data and probes
493a1b7 Example probes for the indirector
fc43694 Add probe indirection for probe management
2bf6105 Process name instrumentation listener
6c138d7 Add the 'performance' instrumentation listener
782f341 Add the example 'log' listener
ff36deb Add a way to add probe to puppet code
6b7fcf6 Add indirection (REST usable) to manipulate instrumentation
b743b4d Instrumentation foundation layer
b1af29b (#8119) Write reports to a temporary file and move them into place
735acad (#11414) Test Augeas versions correctly with versioncmp
3239ab3 (#11414) Save/execute changes on versions of Augeas < 0.3.6
8ec6086 Account for Windows file mode translation for lastrunfile
b28cac8 (#7106) Obey specified owner, group, and permissions for last run summary file
b8c5ee2 (#11408) Fix fact and plugin sync on Windows
d4d3cb3 (#10586) Don't copy owner and group when sourcing files from master
1519d30 (#7428) Fix option parsing for ruby 1.9 in cert application
213cecc Revert "(#11423) Clearer error message about duplicate imported resources."
e8e1f57 (#11423) Clearer error message about duplicate imported resources.
ff396bf Maint: Fix redhatfedorasusecentosslesoelovm in type reference
6682fe7 Maint: Padding should be added when dochook strings are consumed, not hardcoded into them
b569c7e (#11404) Fix broken and unreliable indentation in provider lists in type reference
c15d997 Maint: Make indentation for markdown definition lists more readable and reliable
e80ca2d (#11404) Move markdown_header and markdown_definitionlist to Puppet::Util::Docs
471fb58 (#11333) Make Puppet::Type.ensurable? false when exists? is undefined
31cef94 Add config and puppet version to the last run summary file
f71af6f (#10676) Include all resource statuses in reports regardless of count
2be44d4 (#8062) Consider package epoch version when comparing yum package versions
e9a5116 (#6412) Return :undef when accessing non-existing hash/array elements
fc3f8b9 Updated CHANGELOG for 2.6.13
cbd78da (#4865) Log when we start evaluating resources at the info level
e8f1407 maint: Add tap to fix Ruby 1.8.5 failures
ddde61e (#10321) Fix array support in schedule's range parameter
87f6f05 Update CHANGELOG for 2.7.9 release
da11dc7 Fix Ruby 1.8.5-incompatible code in FileBucket::Dipper spec
737c2f6 Fix Ruby 1.8.5-incompatible code in Transaction#eval_generate
042925d Fix Ruby 1.8.5-incompatible code in spec setup
0022f47 Revert "Build a Rake task for building Apple Packages"
3265b2c Updating CHANGELOG for 2.7.8 release
8d83c4e (maint) Fix grammar mistakes in README_DEVELOPER
8cca377 Build a Rake task for building Apple Packages
4275fd4 (#11291) Update description of show_diff setting to match behavior as of 2.7.8
901a6b2 (#11291) Update description of show_diff setting to match behavior as of 2.7.8
84fdf6f (#10109) Make resourcefile work with composite namevars
15f7a1c (#11246) Add README_DEVELOPER describing UTF-8 in Puppet
1e8e34b (#11276) Fix module install specs that fail on windows
c78d17e (#7110) Better SSL error message certificate doesn't match key
00c76f6 (#11276) Mark module tool tests as failing on Windows
599a146 (#11273) Updates init.pp.erb for style guide.
80e5d03 (#11198) Modulefiles should have a default license
eec7495 (#11246) Fix UTF-8 String#to_yaml exception
a01aab2 (#11246) Add UTF-8 String#to_yaml spec tests
a89fe49 (#9768) Add a defaults argument to create_resources
eb7be18 (#6830) Fix create_resources spec for ruby 1.9
b2cfe28 (#7656) Rename module_tool face to module
c658e72 (#7656) Add details about module testing to templates
61d894e Merge pull request #61 from jblaine/patch-1
62f89c4 (#7656) Use core Puppet semver.rb lib
e2a9ab9 (#7656) Replace SystemExit with better exceptions
5bc5c50 (#7656) Remove redundant uri module
22ac5b6 (#7656) Encourage documenting license, and contact
e9538af (#7656) Cleanup repository_spec tests
c79f157 (#7656) Update comment string in the metadata module
7a45cc7 (#7656) Rename `Modulefile` to `ModulefileReader`
f463d90 (#7656) Rename full_name to full_module_name
0843c9e (#7656) Removed spec.opts template
47e7b60 (#7656) Use rspec 2.x in generator templates
5a8dc51 (#7656) Rename contact to make_http_request
90b1fcd (#7656) Use a Puppet setting for default module repo
a44aef9 (#7656) Use Metadata fully qualified module name
27d26ae (#7656) Show the default install-dir in help output
24557b9 (#7656) Code cleanup for the generate action
bad0112 (#7656) Show the format of the status hash for build
6d0e88a (#7656) Add output to action examples
5220af5 (#7656) Fix inaccurate comment in the build action
f33c2e4 (#7656) Refactor the module face build action
62b59c1 (#7656) Bump module face to version 1.0.0
feeecc4 (#7656) Remove unnecessary require of puppet/face
e45f5a7 Fix the targets in autorequire tests to use expand_path
b22df54 Fix tests for autorequiring links to work on windows
0200629 Fix arity of blocks to validate for file properties
94e9863 (#7004) Correctly form singular for indirections ending in 'es'
6641938 Updating CHANGELOG for 2.6.13rc1
db962a5 (#5421) Link should autorequire target
bdeb3b7 (#7656) Add search action to module_tool face
41d1034 (#7656) Add install action to module_tool face
6d2fc99 (#7656) Add generate action to module_tool face
626d876 (#7656) Add clean action to module_tool face
5e77157 (#7656) Add changes action to module_tool face
da4a236 (#7656) Add build action to module_tool face
7df5303 (#7656) Port PMT to faces, bundle in Puppet core
bf9e847 (#7656) Port PMT integration test into Puppet core
bce8e43 (#7656) Port PMT unit test into Puppet core
ee4dbf4 (#7656) Port PMT test fixtures into Puppet core
eb617e5 (#7656) Add new PMT settings to core Puppet
ce218ef (#7656) Port PMT generator templates into core
0c61186 (#7656) Port PMT codebase into Puppet core
bb5386c Updated CHANGELOG for 2.7.8rc1
3eff60a Readying for 2.7.8rc release
e4ee794 (#10739) Provide default subjectAltNames while bootstrapping master
2dedee6 (#2744) Don't automatically enable show_diff in noop mode
ef78358 Give variables more descriptive names
cd3d4ea maint: Rename xgenerate to add_dynamically_generated_resources
000a2d8 (#6907) Prefetch unsuitable providers
70114e9 (#6907) Allow providers to be selected in the run they become suitable
a0ee5c7 maint: Fix incorrect whitespace
4e8a73c Fix description in service provider test for FreeBSD
a2eab4f (#6697) Set service provider default path to /etc/rc.d on Archlinux
da75795 (#6335) Allow optional trailing comma in argument lists.
05b3cac (#10940) Deprecate `--apply` in favor of `--catalog`
47c786e Update CHANGELOG and packaging for 2.7.7 final
8030428 (#8255) Always use string modes when creating resources from FileSetting settings
c804346 (#7274) Output 4-digit file modes in File type
220f2ba (#10799) Regexp escaping too much
4462eb5 Merged 2.6.x into 2.7x
67e048b Updated CHANGELOG for 2.7.7rc2
93aca5a maint: Fix failing specs for Windows exec provider
4f1f7e4 (#10807) Use SMF's svcadm -s option to wait for errors
3ab4d63 Fix #10066 - when fingerprinting, agent should not daemonize
7f3a1bb (#9617) Use an RbTreeMap to store ready resources
9eff0f4 (#9671) Implement RbTreeMap#each recursively, and #first/#last explicitly
5f7f467 (#9671) Return nodes from internal RbTreeMap recursion
1dc9c72 (#9671) Stop tracking size and height of nodes in RbTreeMap
f180f9b (#9617) Add a red-black tree map
c62e949 (#9617) Keep track of blockers for resources when traversing
2cb6d72 (#9671) Generated resources should not depend on the completed_ whit
a5845b7 (#9671) Exit early from #eval_generate if nothing is created
7002eff (#9617) Be smarter about finding parents when eval_generating
11fda78 maint: Don't File#expand_path when unmunging file paths
ad4316a (#9671) Use Array#concat rather than +=
20260f3 maint: Correct the spelling of sentinel
4d9e0c0 Added missing RequestHeader entries to ext/rack/files/apache2.conf
4f03384 (#10614) Detect when trying to managing ACLs on a non-ACL volume
37b9f0f (#10614) Provide default metadata values for Windows ACLs
1cb37c9 (#10614) Add method for detecting Windows volumes that support ACLs
c9ee5a0 (#10614) Fix setting and clearing read-only attribute on Windows
ed27a90 (#10614) Fix error checking for Windows BOOL return values
7f0756d (#10727) Don't rely on Kernel#Pathname
23379d0 (#10614) Detect when trying to managing ACLs on a non-ACL volume
374fee5 (#10614) Provide default metadata values for Windows ACLs
f60e889 (#10614) Add method for detecting Windows volumes that support ACLs
1371dbd (#10614) Fix setting and clearing read-only attribute on Windows
a6996ba (#4865) Debug logging when we start evaluating resources.
7eb0197 (#10614) Fix error checking for Windows BOOL return values
cd2d2f1 (#9158) Support old and new versions of STOMP gem.
9dfd011 (#5617)  Puppet queue logging
0a34697 (#2744) Display file diffs through the Puppet log system.
0c28238 (#9508) Be explicit is setting `auth any` for default ACLs.
f140eca Updated CHANGELOG for 2.7.7rc1
057cda6 (#9508) Default ACL of `auth any` makes sense where we had `auth no`
78670ed (#9983) Checksum file in binary mode when storing to filebucket
da11a78 (#9983) Serve file content in binary mode
13f1054 (#9983) Read file content from disk using binary mode
4b4bb8b (#9983) Use binary mode when reading and writing FileBucketFiles
899833b (#9983) Read file content in binary mode when backing up
dc8bcf8 (#9983) Restore files in binary mode
489a679 (#9983) Checksum files in binary mode
f7bfa05 (#9983) Add method for reading binary files
674068a (#10269) Make directories executable so they can be cleaned up
fd747cc (#10365) Add pending test when file overwrites an executable directory
fe30d8f (#10315) Add pending tests when following symlinks
a22c7aa Maint: Fix test breakage
8576e86 (#10269) Search bit not set on newly created directories
a91cfa1 maint: Fix failing spec on old version of rspec
428e08c Stub File.open to not touch the disk
aa2a762 (#10289) Add an ext script to upload facts to inventory server
a97337f (#10346) Fix storeconfigs spec failures when run alone
5129d38 (#10289) Add a safe alternative to REST for inventory service
5c4daa4 (#7601) Use definition lists in indirection references
7df46a2 (#7601) Use definition lists in type references
ad97dc9 (#7601) Add markdown_definitionlist method to reference.rb
455c9aa Maint: Revise reference text for most types and providers
ced8e19 (#7601) Remove unnecessarily abstracted paramwrap method
a6957ac (#7601) Rename "h" method to "markdown_header"
7a0ade6 (#7601) Use << instead of += in references
7d65796 (#9109) Retrieve request parameters from the request body for POSTs
5a2952c (maint) Fix CA-related specs failing on Windows
42fb76e Fix typo in report debug message
65086c4 (#9544) Stub command in package spec that needs root priviledges
eab5965 missing includes in network XML-RPC handlers
7514d32 missing includes in network XML-RPC handlers
614526a (#10244) Restore Mongrel XMLRPC functionality
397a506 (#10244) Restore Mongrel XMLRPC functionality
fcaf7c5 Updated CHANGELOG for 2.6.12
f51d221 Improve the error message when a CSR is rejected
d551747 Allow a master to bootstrap itself with dns_alt_names and autosign
0405196 (maint) Remove ssl dir before starting a master with DNS alt names
3ed6499 Backport Enumerable#count to Rubies < 1.8.7
5f44c23 More 1.8.5 compatibility fixes.
ef1b960 Better 1.8.5 compatible implementation of `lines`.
246e875 (#2848) Config options require '_', not '-'.
3bdeb3a Ruby 1.8.5 compatibility changes in tests and code.
6866d4b Add `lines` alias for `each_line` in Ruby 1.8.5.
2f9ec3c s/not_to/should_not/ for older versions of RSpec 2.
56320ea (#2848) Eliminate redundant `master_dns_alt_names`.
de19861 (#2848) Remove the legacy SSLCertificates code
cf008a6 (#2848) Rework the xmlrpc CA handler to use the modern SSL code
32be180 (#2848) Remove unused xmlrpc code
5f2a44d (#2848) Consistent return values from `subject_alt_names` accessors.
5e507f2 (#2848) Consistently use `subject_alt_names` as accessor name.
5ac2417 (#2848) Don't strip the subjectAltName label when listing.
44cf3a2 (#2848) Don't enable `emailProtection` for server keys.
d66def9 (#2848) Only mark `subjectAltName` critical if `subject` is empty.
8174047 (#2848) Migrate `dns-alt-names` back to settings.
f18df2b Wire up the `setbycli` slot in Puppet settings.
efa61f2 (#2848) rename subject-alt-name option to dns-alt-names
f103b20 (#2848) Rename `certdnsnames` to match new behaviour.
363b47b (#2848) Use `certdnsnames` when bootstrapping a local master.
49334ff (#2848) CSR subjectAltNames handling while signing.
5f2af93 (#2848) List subject alt names in output of puppet cert --list
bb475ec (#7224) Add a helper to Puppet::SSL::Certificate to retrieve alternate names
bab9310 (#2848) Rewrite SSL Certificate Factory, fixing `subjectAltName` leak.
fca1ff0 (#2848) Reject unknown (== all) extensions on the CSR.
443a756 (#2848) extract the subjectAltName value from the CSR.
66101f1 (#2848) Set `certdnsnames` values into the CSR.
77b814f (#6928) Don't blow up when the method is undefined...
5427f1e (#6928) backport Symbol#to_proc for Ruby < 1.8.7
6ef1d3a (#6371) Update lastchg field in shadow file on Solaris.
c343615 (#10161) Parenthesize method arguments
1912c19 (#8547) Update storeconfigclean script to read puppet.conf
5721ab9 Maint: Remove duplicate path extension code
edc721e (#9636) Always set $CHILD_STATUS when executing on Windows
448d5db (#9636) Fix PATHEXT resolution for paths other than system32
424379d (#9996) Restore functionality for multi-line commands in exec resources
ad98d47 (#9831) Standardize Windows provider confining
0366789 (#9997) Add mysql2 gem support
cf8fae2 (#9832) General StoreConfigs regression.
1e8a2cd (#9607) Only validate package source when it is set or needed
0258096 (#9461) Resolve executables using PATHEXT on Windows
d78afda (#9938) Allow directory sticky-ness to be set
23b4864 Maint: Document tag metaparameter's ability to take an array
b3c0f1d Stub method for getting roles from the user provider
006a128 Set vardir so that msi package provider runs on Windows
4185b4e Add Windows-specific tests when user parameter specified in exec
aab6b40 Disable mount provider tests on Windows
58f97e3 Update test due to lack of 'true' on Windows
1fd90c3 Change tests to not use 'mount' provider
220f5e0 Added 'touch' method enabling tests to run on Windows
ca0bc4f Change test to not call 'rm -rf'
1883455 Remove 'fails_on_windows' tag for passing tests
0d7c797 (#8414) Create scheduled_task type for use with Windows scheduled tasks
4ddef89 (#8414) Require win32-taskscheduler gem on Windows
0ecf3ab Add ability to look up fully qualified local accounts using Puppet::Util::Adsi.sid_for_account
23d5aeb Add support for displaying hashes to Puppet::Parameter.format_value_for_display
f0c3414 Move parameter formatting rules into helper method
845e05b Wrap long lines in Type::Package
18d65ec Whitespace cleanup in Type::SshAuthorizedKey
b2e2175 Include necessary Facter stubs
f5bc897 Remove test dependencies on QUANTITY of calls
51adf31 Reset the @macosx_version_major variable
4b9dfdd Reset the @job_list variable between tests
446a5bf Remove use of defined?()
0e4079d Use memoization instead of 'unless'
9d504ff (#9796) ssh_authorized_key supports whitespace again
122b8c2 (#9459) Fix problems with Windows 'user' and 'group' providers.
ee107cf Use instance variable for job_list
d1e0fa1 Refactor launchd provider spec tests
3440c10 Refactor status method
62b8d6b Deprecation Warning if using Facter <= 1.5.5
8a50c3a Test prefetching
f09d264 Stub call to Facter
a6bc5a5 Optimize @product_version variable
af42ff8 Documentation Commit
55610bf Whitespace Commit
cf3d378 Change method used to get Fact Value
ce776b0 Revert launchd_spec
f65b111 Rearrange launchd provider
ed90957 First attempt at launchd spec
637b57b Implement Caching
60482f4 Whitespace and Alignment Commit
5b52bd6 Bring up to date with topic branch
27057a6 Maint: Fix the "provider" parameter documentation
747ffd2 (#8341) Remove duplicate loading of facter files.
c88d22b Fix tests for #1886 with ActiveRecord 3.x
723cd92 Revert "(Maint.) Disable cleaning of storeconfigs."

2.7.9
===
da11dc7 Fix Ruby 1.8.5-incompatible code in FileBucket::Dipper spec
737c2f6 Fix Ruby 1.8.5-incompatible code in Transaction#eval_generate
042925d Fix Ruby 1.8.5-incompatible code in spec setup

2.7.8
===
3eff60a Readying for 2.7.8rc release
e4ee794 (#10739) Provide default subjectAltNames while bootstrapping master
2dedee6 (#2744) Don't automatically enable show_diff in noop mode
ef78358 Give variables more descriptive names
cd3d4ea maint: Rename xgenerate to add_dynamically_generated_resources
000a2d8 (#6907) Prefetch unsuitable providers
70114e9 (#6907) Allow providers to be selected in the run they become suitable
a0ee5c7 maint: Fix incorrect whitespace
4e8a73c Fix description in service provider test for FreeBSD
a2eab4f (#6697) Set service provider default path to /etc/rc.d on Archlinux
da75795 (#6335) Allow optional trailing comma in argument lists.
47c786e Update CHANGELOG and packaging for 2.7.7 final
8030428 (#8255) Always use string modes when creating resources from FileSetting settings
c804346 (#7274) Output 4-digit file modes in File type
220f2ba (#10799) Regexp escaping too much
4462eb5 Merged 2.6.x into 2.7x
67e048b Updated CHANGELOG for 2.7.7rc2
93aca5a maint: Fix failing specs for Windows exec provider
7f3a1bb (#9617) Use an RbTreeMap to store ready resources
9eff0f4 (#9671) Implement RbTreeMap#each recursively, and #first/#last explicitly
5f7f467 (#9671) Return nodes from internal RbTreeMap recursion
1dc9c72 (#9671) Stop tracking size and height of nodes in RbTreeMap
f180f9b (#9617) Add a red-black tree map
c62e949 (#9617) Keep track of blockers for resources when traversing
2cb6d72 (#9671) Generated resources should not depend on the completed_ whit
a5845b7 (#9671) Exit early from #eval_generate if nothing is created
7002eff (#9617) Be smarter about finding parents when eval_generating
11fda78 maint: Don't File#expand_path when unmunging file paths
ad4316a (#9671) Use Array#concat rather than +=
20260f3 maint: Correct the spelling of sentinel
4f03384 (#10614) Detect when trying to managing ACLs on a non-ACL volume
37b9f0f (#10614) Provide default metadata values for Windows ACLs
1cb37c9 (#10614) Add method for detecting Windows volumes that support ACLs
c9ee5a0 (#10614) Fix setting and clearing read-only attribute on Windows
ed27a90 (#10614) Fix error checking for Windows BOOL return values
7f0756d (#10727) Don't rely on Kernel#Pathname
23379d0 (#10614) Detect when trying to managing ACLs on a non-ACL volume
374fee5 (#10614) Provide default metadata values for Windows ACLs
f60e889 (#10614) Add method for detecting Windows volumes that support ACLs
1371dbd (#10614) Fix setting and clearing read-only attribute on Windows
7eb0197 (#10614) Fix error checking for Windows BOOL return values
9dfd011 (#5617)  Puppet queue logging
0a34697 (#2744) Display file diffs through the Puppet log system.
0c28238 (#9508) Be explicit is setting `auth any` for default ACLs.
f140eca Updated CHANGELOG for 2.7.7rc1
057cda6 (#9508) Default ACL of `auth any` makes sense where we had `auth no`
78670ed (#9983) Checksum file in binary mode when storing to filebucket
da11a78 (#9983) Serve file content in binary mode
13f1054 (#9983) Read file content from disk using binary mode
4b4bb8b (#9983) Use binary mode when reading and writing FileBucketFiles
899833b (#9983) Read file content in binary mode when backing up
dc8bcf8 (#9983) Restore files in binary mode
489a679 (#9983) Checksum files in binary mode
f7bfa05 (#9983) Add method for reading binary files
674068a (#10269) Make directories executable so they can be cleaned up
fd747cc (#10365) Add pending test when file overwrites an executable directory
fe30d8f (#10315) Add pending tests when following symlinks
a22c7aa Maint: Fix test breakage
8576e86 (#10269) Search bit not set on newly created directories
a91cfa1 maint: Fix failing spec on old version of rspec
428e08c Stub File.open to not touch the disk
aa2a762 (#10289) Add an ext script to upload facts to inventory server
a97337f (#10346) Fix storeconfigs spec failures when run alone
5129d38 (#10289) Add a safe alternative to REST for inventory service
5c4daa4 (#7601) Use definition lists in indirection references
7df46a2 (#7601) Use definition lists in type references
ad97dc9 (#7601) Add markdown_definitionlist method to reference.rb
455c9aa Maint: Revise reference text for most types and providers
ced8e19 (#7601) Remove unnecessarily abstracted paramwrap method
a6957ac (#7601) Rename "h" method to "markdown_header"
7a0ade6 (#7601) Use << instead of += in references
7d65796 (#9109) Retrieve request parameters from the request body for POSTs
5a2952c (maint) Fix CA-related specs failing on Windows
42fb76e Fix typo in report debug message
eab5965 missing includes in network XML-RPC handlers
7514d32 missing includes in network XML-RPC handlers
614526a (#10244) Restore Mongrel XMLRPC functionality
397a506 (#10244) Restore Mongrel XMLRPC functionality
fcaf7c5 Updated CHANGELOG for 2.6.12
f51d221 Improve the error message when a CSR is rejected
d551747 Allow a master to bootstrap itself with dns_alt_names and autosign
0405196 (maint) Remove ssl dir before starting a master with DNS alt names
3ed6499 Backport Enumerable#count to Rubies < 1.8.7
5f44c23 More 1.8.5 compatibility fixes.
ef1b960 Better 1.8.5 compatible implementation of `lines`.
246e875 (#2848) Config options require '_', not '-'.
3bdeb3a Ruby 1.8.5 compatibility changes in tests and code.
6866d4b Add `lines` alias for `each_line` in Ruby 1.8.5.
2f9ec3c s/not_to/should_not/ for older versions of RSpec 2.
56320ea (#2848) Eliminate redundant `master_dns_alt_names`.
de19861 (#2848) Remove the legacy SSLCertificates code
cf008a6 (#2848) Rework the xmlrpc CA handler to use the modern SSL code
32be180 (#2848) Remove unused xmlrpc code
5f2a44d (#2848) Consistent return values from `subject_alt_names` accessors.
5e507f2 (#2848) Consistently use `subject_alt_names` as accessor name.
5ac2417 (#2848) Don't strip the subjectAltName label when listing.
44cf3a2 (#2848) Don't enable `emailProtection` for server keys.
d66def9 (#2848) Only mark `subjectAltName` critical if `subject` is empty.
8174047 (#2848) Migrate `dns-alt-names` back to settings.
f18df2b Wire up the `setbycli` slot in Puppet settings.
efa61f2 (#2848) rename subject-alt-name option to dns-alt-names
f103b20 (#2848) Rename `certdnsnames` to match new behaviour.
363b47b (#2848) Use `certdnsnames` when bootstrapping a local master.
49334ff (#2848) CSR subjectAltNames handling while signing.
5f2af93 (#2848) List subject alt names in output of puppet cert --list
bb475ec (#7224) Add a helper to Puppet::SSL::Certificate to retrieve alternate names
bab9310 (#2848) Rewrite SSL Certificate Factory, fixing `subjectAltName` leak.
fca1ff0 (#2848) Reject unknown (== all) extensions on the CSR.
443a756 (#2848) extract the subjectAltName value from the CSR.
66101f1 (#2848) Set `certdnsnames` values into the CSR.
77b814f (#6928) Don't blow up when the method is undefined...
5427f1e (#6928) backport Symbol#to_proc for Ruby < 1.8.7
6ef1d3a (#6371) Update lastchg field in shadow file on Solaris.
c343615 (#10161) Parenthesize method arguments
5721ab9 Maint: Remove duplicate path extension code
edc721e (#9636) Always set $CHILD_STATUS when executing on Windows
448d5db (#9636) Fix PATHEXT resolution for paths other than system32
424379d (#9996) Restore functionality for multi-line commands in exec resources
ad98d47 (#9831) Standardize Windows provider confining
cf8fae2 (#9832) General StoreConfigs regression.
1e8a2cd (#9607) Only validate package source when it is set or needed
0258096 (#9461) Resolve executables using PATHEXT on Windows
d78afda (#9938) Allow directory sticky-ness to be set
23b4864 Maint: Document tag metaparameter's ability to take an array
b3c0f1d Stub method for getting roles from the user provider
006a128 Set vardir so that msi package provider runs on Windows
4185b4e Add Windows-specific tests when user parameter specified in exec
aab6b40 Disable mount provider tests on Windows
58f97e3 Update test due to lack of 'true' on Windows
1fd90c3 Change tests to not use 'mount' provider
220f5e0 Added 'touch' method enabling tests to run on Windows
ca0bc4f Change test to not call 'rm -rf'
1883455 Remove 'fails_on_windows' tag for passing tests
0d7c797 (#8414) Create scheduled_task type for use with Windows scheduled tasks
4ddef89 (#8414) Require win32-taskscheduler gem on Windows
0ecf3ab Add ability to look up fully qualified local accounts using Puppet::Util::Adsi.sid_for_account
23d5aeb Add support for displaying hashes to Puppet::Parameter.format_value_for_display
f0c3414 Move parameter formatting rules into helper method
845e05b Wrap long lines in Type::Package
18d65ec Whitespace cleanup in Type::SshAuthorizedKey
b2e2175 Include necessary Facter stubs
f5bc897 Remove test dependencies on QUANTITY of calls
51adf31 Reset the @macosx_version_major variable
4b9dfdd Reset the @job_list variable between tests
446a5bf Remove use of defined?()
0e4079d Use memoization instead of 'unless'
9d504ff (#9796) ssh_authorized_key supports whitespace again
122b8c2 (#9459) Fix problems with Windows 'user' and 'group' providers.
ee107cf Use instance variable for job_list
d1e0fa1 Refactor launchd provider spec tests
3440c10 Refactor status method
62b8d6b Deprecation Warning if using Facter <= 1.5.5
8a50c3a Test prefetching
f09d264 Stub call to Facter
a6bc5a5 Optimize @product_version variable
af42ff8 Documentation Commit
55610bf Whitespace Commit
cf3d378 Change method used to get Fact Value
ce776b0 Revert launchd_spec
f65b111 Rearrange launchd provider
ed90957 First attempt at launchd spec
637b57b Implement Caching
60482f4 Whitespace and Alignment Commit
5b52bd6 Bring up to date with topic branch
27057a6 Maint: Fix the "provider" parameter documentation

2.7.6 (includes CVE-2011-3872 see http://puppetlabs.com/security/hotfixes/cve-2011-3872/
===
c09517a Improve the error message when a CSR is rejected
9346530 Allow a master to bootstrap itself with dns_alt_names and autosign
7679c66 (maint) Remove ssl dir before starting a master with DNS alt names
e4c64c7 Fix failing CA Interface specs on Ruby 1.9
9ee1215 Fix some inconsistencies from merging
8144939 Add support for DNS alt names to `puppet ca`
2ba56e3 More 1.8.5 compatibility fixes.
6257188 Better 1.8.5 compatible implementation of `lines`.
4ba4db7 (#2848) Config options require '_', not '-'.
493f8d1 Add --allow-dns-alt-names option to `puppet certificate sign`
0cc8936 Add support for dns-alt-names option to `puppet certificate generate`
c65236d Ruby 1.8.5 compatibility changes in tests and code.
6c37623 Add `lines` alias for `each_line` in Ruby 1.8.5.
e29eb6a s/not_to/should_not/ for older versions of RSpec 2.
f1f5298 (#2848) Eliminate redundant `master_dns_alt_names`.
3a8b376 (#2848) Remove the legacy SSLCertificates code
28dead0 (#2848) Rework the xmlrpc CA handler to use the modern SSL code
a644514 (#2848) Remove unused xmlrpc code
2b1ad43 (#2848) Consistent return values from `subject_alt_names` accessors.
d8516d9 (#2848) Consistently use `subject_alt_names` as accessor name.
0b45f4c (#2848) Don't strip the subjectAltName label when listing.
99488f3 (#2848) Don't enable `emailProtection` for server keys.
f1285a4 (#2848) Only mark `subjectAltName` critical if `subject` is empty.
e65a88e (#2848) Migrate `dns-alt-names` back to settings.
b876c39 Wire up the `setbycli` slot in Puppet settings.
a53f2f2 (#2848) rename subject-alt-name option to dns-alt-names
bc2267a (#2848) Rename `certdnsnames` to match new behaviour.
a720499 (#2848) Use `certdnsnames` when bootstrapping a local master.
6e3f529 (#2848) CSR subjectAltNames handling while signing.
978b65c (#2848) List subject alt names in output of puppet cert --list
7460a5e (#7224) Add a helper to Puppet::SSL::Certificate to retrieve alternate names
94345eb (#2848) Rewrite SSL Certificate Factory, fixing `subjectAltName` leak.
a729d90 (#2848) Reject unknown (== all) extensions on the CSR.
f4fc11d (#2848) extract the subjectAltName value from the CSR.
d64b01b (#2848) Set `certdnsnames` values into the CSR.
78a01a2 (#6928) Don't blow up when the method is undefined...
43d1e38 (#9996) Restore functionality for multi-line commands in exec resources
d457763 (#9832) General StoreConfigs regression.
2958b05 maint: Deal with [].to_s problem in 1.9.2
9c25af4 (#9027) Get rid of spurious info messages in groupadd
1f25c20 (#8411) Fix change group for POSIX file provider
599642d Fix problem with set_mode (chmod) behavior on different test environments.
b43765d Undo change to failing test on 1.8.5
c275a51 Resist directory traversal attacks through indirections.
d759f84 (#9838) Return the tranaction report when doing a ral save
127f83e (#9837) Split parameter pruning from manifest formatting
9d5ce00 (#9837) Move resource formatting method to Puppet::Resource
86230d8 (#9837) Move properties in prep to move proc to method
bf952e1 (#9837) Make a clearer variable name in the specs
6885c36 (#9837) Call puppet apply to avoid deprecation warning
93f8057 (#9837) Extract methods from the main section of the resource application
5d33214 (#9837) Start the cleanup of the puppet resource application
54a2565 (#9832) Test failures with some ActiveRecord versions.
2bf8004 Updates for 2.6.11
8343077 (#9832) 2.7.4 StoreConfigs regression with PostgreSQL.
dce82ea (#9458) Require main puppet module
e158b26 (#9793) "secure" indirector file backed terminus base class.
343c7bd (#9792) Predictable temporary filename in ralsh.
88512e8 Drop privileges before creating and chmodding SSH keys.
6533292 (#9328) Retrieve user and group SIDs on windows.
2775c21 (#9794) k5login can overwrite arbitrary files as root
e7a6995 (#9794) k5login can overwrite arbitrary files as root
408d117 Updated CHANGELOG for 2.6.10
ec5a32a Update spec and lib/puppet.rb for 2.6.10 release
4e8d3a1 (#9775) Only list managed resources in the resources file
51b33d1 (#9326) Support plaintext passwords in Windows 'user' provider.
fe2de81 Resist directory traversal attacks through indirections.
5fea1dc Fix issues with Windows based file URIs
1a13d24 Simplify absolute path detection
a163cd5 Eliminate duplicate absolute path detection
0ce60a5 Added methods for manipulating URI and file paths
71ba92c Restrict the absolute path regex to the start of the string
1edf767 Move group management into providers
15149c1 Remove duplicate SID resolution code
f932511 Move owner management into providers
f05fc83 Add platform-specific metadata collectors
db0b4fb Make string_to_sid_ptr block optional
7fc6baf Add the ability to retrieve user and group SIDs
22bfd9c Move mode management into the providers
4c3aae8 Fix typo bug that prevented FILE_DELETE_CHILD from being set
7de0a80 Sub away trailing backslashes at the end of sources on Windows
44cb1f1 Refactor autorequire of parent to use pathname with ancestors
1300e0a Remove unnecessary Windows-on-non-Windows-master code for path parameter
1f9b57f Cleanup file type integration tests
8d21262 Cleanup and improve coverage of file type unit tests
0a92a70 Resist directory traversal attacks through indirections.
8b6a775 Call Array#join explicitly on command
ae74c68 Fix failing SSL Host test introduced by b6a67edc
37a1975 (#4549) Fix templates to be able to call all functions
a74e56d Expand paths in catalog_spec for windows testing
8d86e5a (9547) Minor mods to acceptance tests
8ec3c7b (#4135) Update pluginsync to only load ruby files.
0c8a0c7 Fix order dependent test failures relating to ADSI
c0edb76 (#9186) Fix tests that fail on 2008 when running as SYSTEM
8e14de6 (#9186) Handle when running under non 'user' contexts
7595475 Fix device.conf error reporting
1d3a3a7 Fix #9164 - allow '-' in device certificate names
b6a67ed Fix #7982 - puppet device doesn't reset all cached attributes
ba1f469 (#9186) Change to shared_examples_for
b27b013 (#8410) Fix child exit status on Windows
42c9982 (#9186) Add the ability to get/set windows permissions
d34d28d (#9435) Gracefully handle when syslog feature is unavailable
f013c65 (#9435) Fix absolute path matching for file log destinations
ea88745 (#9329) Disable agent daemonizing on Windows

2.7.5
===
a36f39d Updating version numbers for 2.7.5
de51f3d (#9832) 2.7.4 StoreConfigs regression with PostgreSQL.
1aa9be5 (#9793) "secure" indirector file backed terminus base class.
d76c309 (#9792) Predictable temporary filename in ralsh. (CVE-2011-3871)
b29b178 Drop privileges before creating and chmodding SSH keys.(CVE-2011-3870)
7d4c169 (#9794) k5login can overwrite arbitrary files as root (CVE-2011-3869)


2.7.4
===
47135fb Resist directory traversal attacks through indirections. (CVE-2011-3484)
9dd18cf Updated CHANGELOG for 2.7.4rc3
fe92f20 (#9440) Allow cron vars to have leading whitespace
da69637 Fix failing spec for resource file
7a39ca7 (#8667) Write out a list of resources that are managed by puppet agent
bc40516 Fix order dependent spec failure in exec specs
a20551f Updated CHANGELOG for 2.7.4rc2
d59a0b3 Update certificate_spec.rb test to include spec_helper
f325b40 Fix #7984 - GigabitEthernet/TenGigabitEthernet are uncorrectly parsed
6cc15c2 Fix #7983 - Cisco uptime facts doesn't always work
41302e9 Fixes #9143, allows macauthorization provider to work on OS X Lion 10.7
5a3f24d Updated CHANGELOG for 2.7.4rc1
04519a7 Revert "Merge pull request #100 from glarizza/tickets/2.7.x/9192_launchd_fix"
769f2b2 Revert "Merge pull request #99 from nigelkersten/tickets/2.7.x/9143-make-macauthorization-work-on-lion"
ff13d8d Add comment explaining helper method
40f64e9 Add has_macosx_plist_overrides? method
670d30c Fix ActiveRecord handling of symbols in query interpolation.
51b0c00 Fixes #9143, allows macauthorization provider to work on OS X Lion 10.7
a04051a (#9051) Move complex collect expression error into terminus.
f7e526b (#8413) Only try to catch Process::Error if it's defined
2c96286 Debug order-dependent test failures in CI / ActiveRecord.
38070d5 Don't toggle storeconfigs back and forth.
cf60243 One character typo, entire code path broken...
40dc39c More protection against accidentally using sqlite3
f898749 Save and restore indirector configuration around all tests.
e3073ac (#9051) More storeconfigs test cleanup.
51461de (#9051) Protect SQLite tests from running without gem.
bb0380f (#8662) Don't rely on error message to detect UAC capable platform
2ab5634 (#8413) Properly clean up stale pidfile on Windows
cc958e1 (#8412) Add MSI package provider for use with Windows
878ea25 (#8412) Add optional type-level validation of the source parameter
dad075d Correct grammar in parameter comment
4168a4c Clean up formatting & whitespace in Puppet::Type
fd1d4b9 (#9051) de-ActiveRecord-ify Collection expressions.
78e33cc (#9051) Port query tests into the indirection.
65580e7 (#9051) Implement the `resource` terminus for StoreConfigs.
89aaa51 (#9051) Make generic tagging imported resource origins.
d5b295d (#9051) Whitespace cleanup for puppet/parser/collector
611c466 (#9051) Dead code elimination in the compiler terminus.
6e0ff6a (#9051) Get the compiler out of the ActiveRecord business.
4d51680 (#9051) Implement the StoreConfigs indirection itself.
d0357c8 (#9051) Add configuration around StoreConfigs indirection.
8700682 (#9051) de-ActiveRecord-ify Collection expressions.
4274e15 (#9174) Provide a helpful error when missing a gem and installing on Windows
f53db3d Clean up formatting & whitespace in package type & providers
6dff78c (#8489) Use File::PATH_SEPARATOR in path attribute of service type
64dbd3b (#8489) Use File::PATH_SEPARATOR for path attribute of exec type
3e40207 (#8489) Use File::PATH_SEPARATOR rather than ':' for factpath setting
c469294 (#8489) Use File::PATH_SEPARATOR rather than ':' for args to puppet doc
a2ced0f Properly determine file deletion in puppet/unit/util_spec.rb
bc5f1e3 (#9051) Port query tests into the indirection.
fa78e99 (#9051) Implement the `resource` terminus for StoreConfigs.
f6b91be (#8140) Add an exec provider for Windows
18c322a (#8410) Factor out a base class for exec providers
cb53870 (#8410) Cleanup and fix Windows support in Puppet::Util.execute
39a582b (#8410) Use absolute_path? for Puppet::Parameter::Path validation
fb6df31 (#8410) Add a helper to Puppet::Util to determine absoluteness of a path
c2a432a maint: Fix trailing whitespace in lib/puppet/util.rb
fab2fe7 (#9051) Make generic tagging imported resource origins.
5300368 (#9051) Whitespace cleanup for puppet/parser/collector
6420ede (#9051) Dead code elimination in the compiler terminus.
543f331 (#9051) Get the compiler out of the ActiveRecord business.
4b55e72 (#9051) Implement the StoreConfigs indirection itself.
0f207a8 (#8662) Don't manage internal file permissions on Windows
47058ab (#8662) Skip user and group resources when applying settings on Windows
2ac8790 (#8662) Fix Puppet.features.root? on Windows
ccdd043 (#8662) Break circular feature dependency
4b29f5f (#9051) Add configuration around StoreConfigs indirection.
9f39cc4 maint: Stub spec test so directory is not created unnecessarily
66fb531 Don't use non-1.8.5-compatible methods 'Object#tap' and 'Dir.mktmpdir'
2091cbe maint: Fix build break due to recent merge from 2.7.x to master
2681ca5 Fix posix exec provider spec failures on Windows
3812fc3 (#5495) Remove dead Windows-specific code from posix exec provider
b6ca78c Stop trying to make config directories in Windows specs
4237cb1 (#8272) Add missing tests for Windows service provider methods.
a32c8be (#8409) Add a default group provider for Windows
4f7170a (#8408) Add a default user provider for Windows
f19a0ea (#8408/8409) Add a Windows ADSI helper module
6919d2c (#8663) Exclude exec timeout test on Windows
8009209 (#8663) Exclude git rev-parse HEAD spec test on Windows
a0013e4 Check for the appropriate permissions in File type tests on Windows
58c7dac Remove :fails_on_windows from file type tests that no longer fail on Windows
9f2a7b9 Disable file bucket diffing tests on Windows
1e59b26 Always put a slash between the checksum and path in filebucket URLs
37f87b7 Treat Windows absolute paths as absolute paths
4a6d617 Consolidate test logic determining if a registered file is in the temp directory
8c88918 Clarify logic and error messages when initializing Puppet::FileBucket::File
2efaa85 Disable symlink related file tests on Windows
7259e1e (#8644) Host provider on Windows
328eaa2 (#8660) Fix destdir option on Windows
088c7ac (#8660) Default config dir to %PROGRAMDATA% on Windows
925af95 (#8663) Disable spec tests for unsupported functionality on Windows
04965d7 (#8663) Drive letters are not valid absolute paths on Windows
f4598ec (#8663) Update the run_mode spec test on Windows to match the code
68bdc74 (#8663) The ssh_authorized_key type is not supported on Windows
9fbb0be (#8663) Reenable spec tests on Windows that now pass
c930152 (#8392) Disable master related tests on Windows
28b1658 (#8272) Allow disabled Windows services to be started
c69baf6 (#8272) Refactor specs for Windows service provider
881c385 (#8272) Use symbols instead of booleans for enabled property on Windows
9c575bd (#8272) Fixup logging in Windows service provider
ad29bf6 Fix issue with forward and backslashes in Windows paths
eaa7d92 Disable spec tests for unsupported functionality on Windows
945bf74 Update certificate spec tests for Windows
3be4d79 Add basic service provider for Windows
d9a693d Regexp escape substituted commands in Windows wrapper script
49d1e9d Rework Puppet::Util::Cacher to only expire using TTLs
9849d56 Remove use of Puppet::Util::Cacher in Puppet::SSL::Host
028b795 Remove dead uses of Puppet::Util::Cacher from autoloader
7c4dbeb Remove Puppet::Util::Cacher use from Puppet::Indirector::Indirection
d6e0b71 Remove caching from the catalog, types, and parameters
d49dd9e Remove cached_attrs from Puppet::Type::File
546e0f9 Remove Puppet::Util::Cacher usage from Puppet::Util::Settings
b6b5498 Remove Util::Cacher usage from SSL::CertificateAuthority
777b2f2 Remove unused require 'puppet/util/cacher' from Network::HttpPool
41425bd Remove use of Util::Cacher from FileServing::Mount::File
8d53090 Remove use of Util::Cacher in FileServing::Configuration
3093047 Remove Puppet::Network::HttpPool keep_alive handling
57d6217 Fix spec test failure on 1.9.2
5d3a40f Maint: Fix miscellaneous tests
ce0c258 Maint: Don't test for extended signals on Windows
bdc9790 Maint: Tagged spec tests that are known to fail on Windows
c26f3e5 Fix tests with "relative" paths on Windows
bfeb337 (#8268) Require windows drive letters in absolute file paths
fe81dec (#8489) Consistently use File::PATH_SEPARATOR
a437812 (#8356) Specify setting type for color
af2446a (#8268) Fix resource harness spec tests
d9c3b0f (#8356) Color defaults to false on Windows
9ebe500 Disable the master on Windows instead of blowing up with failed resources
7467a08 (#7581) Provide more detailed error message when missing gems on Windows
654de01 Maint: Correct docs for filebucket type and file's backup parameter
b623826 Maint: Fix line wrapping in create_resources function
fd7332b maint: remove inaccurate copyright and license statements.
a8b27de Maint: Improve create_resources function's doc string
5f22985 maint: Fix order dependent test failure
7ac1093 (#8037) Fix incorrect example in Augeas type reference
35c1006 (#9039) Update Augeas commands documentation
2bf6721 Reset indirector state after configurer tests.
e9b558d Fix posix exec provider spec failures on Windows
b28bcb0 (#5495) Remove dead Windows-specific code from posix exec provider
2297899 Do not leak indirector state from apply tests
b52fbf4 (#8612) Clarify the function of the example for exec's "creates" parameter
bb224dd (#8770) Don't fail to set supplementary groups when changing user to root
2a0de12 (#8770) Always fully drop privileges when changing user
00c4b25 (#8662) Migrate suidmanager test case to rspec
d7c9c76 (#8740) Do not enumerate files in the root directory.
39da99d (#4411) Explain that runinterval = 0 does not mean "never run"
4146a33 Maint: Fix missing option text in puppet agent and arrange options alphabetically
0e00473 (#3553) Explain that cron resources require time attributes
769d432 (#8302) Improve documentation of exec providers
76d45d2 (#7853) Clarify and complete docs for the tagmail report processor
d60852b Maint: Mention that audit metaparameter will accept "all"
51d989e Maint: Adjust wording for file type's content parameter
a110d83 Maint: Fix poor documentation for versioncmp function.
746a374 maint: Fix case sensitive require
310bd55 maint: Add inspect app options to help
3a19628 maint: Fix inspect help
344aef9 (#8808) Fail Augeas resource when unable to save changes
c209f62 Add document outlining preferred contribution methods
839e7c9 (#7999) Add some basic tests of the systemd provider
1cae354 (#7999) Add a service provider that manages systemd services natively
3b152e4 (#7114) Fix value validation on options
aa1b36f (#7114) Add tests for option property

2.7.3
===
7113448 (#4762) Ensure that clients on the moon can successfully connect.
c8835ad Add document outlining preferred contribution methods
b85f57c Add document outlining preferred contribution methods
ea0f2bf Revert "Merge branch 'vcsrepo'"
a5716e4 Revert "Merge branch 'vcsrepo'"
94f0b93 (#8704) Give better errors for invalid fileserver.conf
38801dd (Maint.) Disable cleaning of storeconfigs.
023d959 (#8690) Accept 'global' options in Puppet Faces
bff817c (Maint.) Fix spec failures related to leaking state.
ccd622a (#1886) Clean up `node clean` for merge.
c315da0 Fix #1886 - Add node cleanup capability
7e6fc0d Deprecate RestAuthConfig#allowed? in favor of #check_authorization
6401dfe Fix #6026 - security file should support inline comments
0c385f1 Fix #5010 - Allow leading whitespace in auth.conf
8da0486 Fix #5777 - rule interpolation broke auth.conf CIDR rules
1d4acb5 maint: Suggest where to start troubleshooting SSL error message
fb2ffd6 (#8596) Detect resource alias conflicts when titles do not match
778127d maint: Fix cert app to print help and exit if no subcommand
0366b18 (#7293) Set default format for SSL-related faces.
cc2c3ed (Maint.) Unquoting HEREDOCs.
89c021c (#8418) Fix inspect app to have the correct run_mode
3165364 maint: Adding logging to include environment when source fails
f484851 maint: Add debug logging when the master receives a report
10e05ad (#7266) Move Certificate option validation into face.
d522b0b maint: Fix Face testing bug 1.9.2 revealed.
ae36003 (#7290) Update indirected Faces to avoid unknown options.
88e9cd2 maint: don't print inside action implementations.
82e5fa9 (#8561, #7290) Implement the option contract fully.
77441be (#8561) Unify validation and modification of action arguments.
69b4e70 (#7290) Fail on unknown options.
6bec2df (#8561) Use canonical names for options to actions.
532c4f3 (#7184) Load the core of obsolete versions of Faces.
2cd3bc4 (#7184) Find actions bound to other versions of Faces.
1e0655e (#7184) Centralize "find action for face" into Puppet::Face
0396611 maint: better error reporting when test fails
e639868 Confine password disclosure acceptance test to hosts with required libraries
395c174 (#7123) Make `find` the default action...
fd6a653 (#7123) Support runtime setting of 'default' on actions.
b75b1c1 (#6787) Add `default_to` for options.
8820a78 Replace calls to Array#count with #length
bdd6a17 Fix order-dependent test failure in certificate_status/file spec
c830ab0 (#6789) Port SSL::CertificateAuthority::Interface to a Face
cc311ad maint: SSL::Inventory.serial should report missing names.
72abe6c (#7204) Consolidate Semantic Versioning code.
d02000b (#8401) Document that --detailed-exitcodes is a bitmask
a109c90 (maint) Cleanup and strengthen acceptance tests
c4848d2 maint: Fix documentation link for fileserver configuration
b268fb3 (#7144) Update Settings#writesub to convert mode to Fixnum
b82f29c (#7699) Help command should only list options once
4a2f22c (maint) Fix platform dection for RHEL
45b3908 (#4142) Fix module check not to fail when empty metadata.json
1feccc3 Revert "Merge branch 'ticket/2.7.x/7699_fix_help_listing_options_twice' into 2.7.x"
ae3ef42 (#7699) - Help should only show options once
5826f73 (#8032) Add containment to create_resources
98cd89b (#8147) Update test for default reporturl
f6882d6 (#8147) Change default reporturl to match newer Dashboard versions
111a4b5 (#6857) Password disclosure when changing a user's password
Fix cross branch confusion on 2.7.2rc2
8ec0804 (#8301) Red Hat spec file for 2.7.2rc1 won't work
2263be6 (#5108) Update service type docs for new hasstatus default
902c414 Update configurer_spec.rb to work with Ruby 1.8.5
7ad1b04 Clean up indentation, whitespace, and commented out code
014d952 Remove order dependency from functions integration spec
243aaa9 (#7956) Porting cron tests
3e3fc69 (#7956) Port resource acceptance tests
534ccfe (#8048) Gem install puppet no longer fails if rdoc enabled.
bbde5b5 Readying for release of 2.6.9
5160822 Clean up indentation, whitespace, and commented out code
92a8f4a Remove order dependency from functions integration spec
31554c0 (#6854) Update Red Hat spec file
cba645c Bumping release in lib/puppet.rb and updating CHANGELOG.
43027de Bumping RPM spec file to 2.6.9rc1.
99330fa (#7224) Reword 'hostname was not match' error message
1d867b0 (#7224) Add a helper to Puppet::SSL::Certificate to retrieve alternate names
db1a392 (#7506) Organize READMEs; specify supported Ruby versions in README.md
de06469 (#5641) Help text: document that puppet doc takes modulepath, manifestdir, and environment options
381fa40 (#6418) Make test 64118 more portable
98ba407 (#7127) Stop puppet if a prerun command fails
6996e0b Do not needlessly create multiple reports when creating a transaction
caca469 (#4416) Ensure types are providified after reloading
413b136 (#4416) Always remove old provider before recreating it
d866ce1 Cleanup indentation, comment, and unused code
d1c965a Make temporary auth.conf in acceptance test readable by Puppet
4af9784 (#7117) Use a different auth.conf instead of overwriting the default
ecde134 (#3360) Delete SSL directory in acceptance test before running
b502423 Update acceptance tests to use with_master_running_on
053e613 Remove pending copy of an active acceptance test
98f58ce (#2128) Add WARNING for node_name_{fact,value} descriptions
1cd848c (#2128) Whitespace only reflow commit
d9b5c1a (#2128) In-line docs for node_name_{fact,value}
3f0dbb5 (#650) Allow symlinks for configuration directories
c260cf1 Fix acceptance tests not managing their masters
1c70f0c (#2128) Add support for setting node name based on a fact
c629958 (#2128) Get facts before retrieving catalog
cd4fe14 (#2128) Add the ability to specify a node name
8ebec1e (#7193) Fix path issues with acceptance tests that call old shell tests
16b2311 (#6885) puppet agent fingerprint requires --verbose to return a value.
77a5987 maint: Confine augeas specs to require the augeas feature
8eb0e16 (#2728) Add diff output for changes made by Augeas provider
a00fd25 maint: Refactor specs in preparation for making node name more flexible
2f8bc26 maint: Fix order dependent test failure
c02126d (#5966) Add support for hostname regular expressions in auth.conf
75e2764 (#5318) Always notice changes to manifests when compiling.
bc71266 maint: Fix order dependent spec failure for face indirection
6547835 (#7690) Don't blow up when listing terminuses available for faces
0bcbca5 maint: Dedup the loadpath so we don't have to walk it multiple times
4a5e99d (#7681) Add an acceptance test for resource refs with array variables
996dc07 Maint: Fix ellipses for short descriptions
53af6f3 (#7563) DRY: Remove indirector boilerplate from individual faces
74aff59 (#7564) Finish templates
3026333 (#7561) Complete help text for all faces and actions
13e473e Maint: Add ellipsis to generated short_descriptions.
89d447b (#6962) Add "arguments" method to help API
646919e (4123) Fix test for 4123/4 on old egrep in cent4
b101804 add puppet master polling step for ticket 7117
9145569 maint: Remove reliance on system clock from schedule spec tests
107b38a maint: Fix pacman provider to work with Ruby 1.9
8eea3f5 Added the vcsrepo type and providers to the core
8f0cecf Added the vcsrepo type and providers to the core
4645c99 add puppet master polling step for ticket 7117
17e7223 (#7507) Add exclude filter for ruby 1.9 spec failures
181098b (#7502) Fixed parser spec for ruby 1.8.5
9c3bedd (#7507) Add more 1.9 filters
f037662 (#6395) Add extpuppet help, eval, and interfaces
4d4d587 Adding a sleep state post starting master
c81f5c6 Adding a sleep state post starting master
d1cc24f maint: fix spec_helper inclusions again.
3ac7aed (#7523) Refactor the grammar to reduce duplication
d22b130 (#7114) Fix specs for ssh authorized key parsed provider
551cb3e (#7114) Target returns correct value
15c6fc7 (#7114) Add integration tests for authorized_key
a5ac82a (#7114) Improve unit tests for ssh_authorized_key
1c7f0c3 (#7114) Improve value validation for authorized_key
0b8ebac (#7300) Fix instances method of mount provider
1dc662a (#1853) Pacman package provider
6bb2a85 (#1853) Pacman package provider
c8775f9 (#7259) Remove ActiveRecord requirement from indirector face spec
1ad8158 (#7259) Do not try to load all Terminus classes when configuring the Indirector
8b76be3 (#3836) External nodes should only capture stdout
d63fc34 Revert "(#7220) Add the ability to "inherit" options."
c21539f maint: sync 'authconfig' to 'rest_authconfig' setting
81d566f Fixed #7481 - Added MIT license to Thomas Bellman's function code
1695dac (#7264) Docs: Clarify that subscribe/notify imply require/before
8f907f2 adding test for ticket 7139
90eb937 (#7139) Accept '/' as a valid path in filesets
1f3b8e7 (#7300) Add specs for the mount provider
1b2a7d9 case seems needless here as there is only two opts, also the rest of the file seems to use if so this should make things more consistant
729336e (#6845) Mount writes incorrect vfstab entries
16cf1ac (#6442) Be able to start agents --listen without namespaceauth.conf
e059539 Update CHANGELOG for 2.6.8
ac0581f (#7101) Fix template error messages in Ruby 1.8.5
9d2500e (#7101) Fix template error messages in Ruby 1.8.5
0352402 (#3420) Nagios "name" attribute does not output correctly
f656818 (#4487) When setting environment on a host, ensure it is a string.
89e9a21 add test for ticket 7101
74498af add test for ticket 7101
2cce326 add test for ticket 7101
c1edcb2 add test for ticket 7101
9329a1f (#7220) Add the ability to "inherit" options.
c306db2 (#6487) Add some testing for OS X version support in DirectoryService provider
0008b63 (#6487) Directoryservice provider will fail in future OS releases
f21162b (#6368) Make the File type autorequire its nearest ancestor directory
c3a76a9 (#7021) Fix order dependent spec failures
7bd6a2f maint: Remove unused code
34f9f41 Maint: Fix a #4655 introduced log inconsistency
6981ee5 Maint: Fix a #4655 introduced log inconsistency
cb43cfc Moving tests from Puppet-acceptance repo
ac428b9 Move tests from Puppet-acceptance repo
db26326 Move tests from puppet-acceptance repo
6b18f8f Move acceptance tests from puppet-acceptance repo
9a5bf6e Fixed #7166 - Replaced deprecated stomp "send" method with "publish"
a18ac78 maint: Fix PSON order dependency in test
656eff8 (#4655) Allow stage to be set using a default class parameter
b3ab0d9 (#4655) Allow stage to be set using a default class parameter
7d3c303 Fixed #7166 - Replaced deprecated stomp "send" method with "publish"
7f658e6 vim: Initial ftplugin and indent support
ccbe9f3 Fixed #6681 - Remove --force-yes option from aptitude is used

2.7.1
===
a49d5b8 (#8048) Gem install puppet no longer fails if rdoc enabled.

2.7.0
===
1a33bf8 (#7506) Specify supported Ruby versions in README.md
d4c499d Updated CHANGELOG for 2.7.0rc4
dbe2310 Maint: Update static man pages for 2.7.0
50d188c Maint: Update static man page generator for Faces.
f370d5a (#7833) Several help text/template edits
90d2cf0 maint: more work on regexp matching in Test::Unit assertions.
8c71df2 maint: acceptance tests need to search for bin/false
0ae4732 (#7828) Fix whitespace in synopsis generator.
b4e9791 maint: handle incoherent Test::Unit assertions.
48aafa3 (#6873) Add Static Compiler terminus to 2.7.0
9017fea (#7728) Acceptance test for whit notifications.
973e752 (#7728) Suppress notifications from container whits.
1772363 (#7764, 7775, 7778) Revisions to Faces help text
5a9998e (#7773, 7776, 7764) Several help template tweaks
5587b94 maint: remove an unhelpful pending test.
bbf0a02 maint: fix misnamed acceptance test for #7139
d4e6c26 (#7624) Manually fetch all properties in instances.
c8df027 (#7193) Fix path issues with acceptance tests that call old shell tests
31bf55c (#7632) Make secret_agent application compatible with secret_agent face
c5448b7 (#7624) Auditing should not be enabled by default for purged resources.
b70f32a (#7746) Fix bootstrap issues from #7717 fix.
be233c3 (#7683) Use ronn, when available, to render the output.
2389bdf (#7683) Add a 'man' face and subcommand to Puppet.
e647f70 maint: remove obsolete work-around code from help face.
796900b (#7699) Don't duplicate inherited action names on faces.
a23cfd8 (#7177) Deprecate implicit 'puppet apply' for 2.7.0
3f47b0c (#7717) Layout cleanup for subcommand extraction.
8072b4b #7211: Test unknown options don't shadow unknown actions.
dd8108c #7211: nasty logic error with global Face options taking arguments.
618495c #7211: more helpful error messages in various cases.
7df1fa4 (#7708) Delete extended documentation from configuration reference
2935feb (#7707) Document signals in puppet agent and puppet master help
3facc33 add puppet master polling step for ticket 7117
68c106e (#5318) Always notice changes to manifests when compiling.
a5a78a5 (#7557) Remove Faces Application
ea7908b maint: Fix order dependent spec failure for face indirection
2aa9f2f (#7690) Don't blow up when listing terminuses available for faces
9447cb9 maint: Dedup the loadpath so we don't have to walk it multiple times
149a12f Maint: Fix ellipses for short descriptions
7688706 (#7563) DRY: Remove indirector boilerplate from individual faces
4662f4d (#7564) Finish templates
331d812 (#7561) Complete help text for all faces and actions
069a6b8 Maint: Add ellipsis to generated short_descriptions.
ebc642b (#6962) Add "arguments" method to help API
163ff6b (#7681) Add an acceptance test for resource refs with array variables
9f6dec2 (#7681) Allow array variables as resource references
76ad2bb (#7507) Add exclude filter for ruby 1.9 spec failures
3682025 maint: move trap call to Signal so we can stub it for specs
fc0add1 Updated CHANGELOG for 2.7.0rc3
83c7563 (#7259) Remove ActiveRecord requirement from indirector face spec
aad2fd7 (#7259) Do not try to load all Terminus classes when configuring the Indirector
3378841 Adding a sleep state post starting master
d972cea (#7507) Add more filters for Ruby 1.9 spec failures
9da1454 (#7507) Add ability to filter Ruby 1.9 spec failures
47e4ac9 (#7507) Fix when_invoked action specs in Ruby 1.9
809b6fe (#7297) Fix Puppet::Resource#to_manifest in Ruby 1.9
3197e21 (#7298) require 'English' to provide $CHILD_STATUS in Ruby 1.9
48923af (#7291) Fix issues with instance_methods in Ruby 1.9
68065ff (#7291) Fixed ascii problem with Ruby 1.9.2
1abb7c0 (#7291) Fix Ruby 1.9 face failures
6159466 (#7291) The 'script' version of actions needs options argument
09f5d9c (#7469) Add license to test face so tests pass
a44cbb1 (#7264) Docs: Clarify that subscribe/notify imply require/before
9377507 (#7468) Stub spec that tries to connect to pypi.python.org
5db214c Prevent spec failure caused by network device mock leak
3722520 Fix #7299 - do not require net/ssh for running rake spec
b983386 Updated CHANGELOG for 2.7.0rc2
61edff9 (#7353) Remove :for_humans format entirely.
d2b5ec6 Adding test for ticket 7139
6f2a129 add clean-up step to test for ticket_5477 to prevent site.pp from leaking to other tests
92905ff fixed test for ticket_7117
5076c37 (#7179) Modify default ACL for /node/<name>.
7b71745 (Maint) Adjust documentation whitespace
358418c (#7303) Remove reference to not-yet-extant man action
dce072a (#6962) Add self-documentation data to puppet faces
855a0ec Maint: adjust faces.rb's help to match that of other applications
75f164a (#7304) Remove full puppet help output when subcommand cannot be found
8a8e198 adding test for ticket 7117
dda3264 (#7353) Note the :for_humans compatibility issue.
efd1181 (#7353) Use :console rendering format in our own code.
5986e8a (#7353) Unify rendering in the face_bace application.
a4e735e (#7353) Add 'console' format to FormatHandler
94f0b09 add base test for ticket 7117
dc0088f (#7277)Fixing all secret-agent functions, and the agent itself
1f112cd (#7139) Accept '/' as a valid path in filesets
18b3584 (#7329) Consistent naming for rendering formats and hooks.
8f81f56 (#7326) Fix faces on Ruby 1.8.5
5569fad (#7117) Return the environment as a Puppet::Node::Environment in uri2indirection
5120a95 (#7276) Better reporting from the plugin download action.
bb889bf (#7276) Create a plugin face application.
5490f7a (#6962) Added 'returns' block to action documentation.
0d6ac04 maint: remove emacs 'coding' cookie from files.
48903f5 (#7278) Improve utility of the Catalog select action
45adc1a (#7279) Adding some basic file actions
a4a274b (#7315) Fix `to_pson` method to render correctly.
1b42725 (#7314) Faces fail horribly when one has a syntax error.
86c6ec2 maint: move the indirector face base out of puppet/face
c63e9c2 maint: reset more global state in testing faces...
b20e977 (#7304) Improve help from `puppet foo`
3bb8bd3 (#7317) better error handling in CLI face facade.
b23cc8a (#7282) action without `when_invoked` should fail...
040e0fd (Maint.) Fix accidental debug output in tests.
65b9a3c (#7221) Strip bad whitespace from face and action docs.
97ae812 (#7248) Fail if two aliases of one option are passed...
207deae (#7289) Specify order for option decorations.
1707f27 Revert "maint: better error reporting for argument count mismatch."
cd474b0 maint: better error reporting for argument count mismatch.
69e4b1c (#7122) Enforce call arity on actions in the CLI wrapper.
351b6fc maint: add a 'print' matcher to rspec, to inspect std{out,err}
be4d7e6 (#7269) Fix error reporting for bad render formats...
632a0a0 (#7269) Better error reporting for bad render formats.
80adaea (#7160) Support 'json' as a rendering method for CLI faces.
0256d67 (#6962) Add integration tests on Face documentation.
e8eb290 (#6962) Finish documentation API on Face options.
6e152ad (#6962) Give copyright and license for all faces.
b8525c9 (#6962) Fill out documentation on Faces and Actions
59e7ef1 (#6962) Move documentation support into a module.
092ab09 (#6962) Extend documentation API for Faces.
c627fad (#7251) Let exceptions raised in decorators rise.
bbf777f (#7249) Publicize ActionBuilder DSL methods.
95ed9aa add test for ticket 7101
6064e8e (#7101) Fix template error messages in Ruby 1.8.5
49c5152 (#7137) Get rid of spurious info messages in useradd
349bd96 Fix test ticket_6928_puppet_master_parse_fails
f25acf9 maint: add the 'to', 'not_to', and 'to_not' aliases to rspec...
f77304b (#7157) Return a non-zero exit code on face failure.
435c826 maint: use the exit_with helper everywhere...
96195c1 maint: add an "exit was called" matcher for rspec.
822d530 maint: clean up test headers on face spec files.
5c24541 Fix #7084 Make the log messages produced by whits less confusing
c7a0270 (#7121) Download plugins and upload reports in secret agent!
2a2226c Revert "Fixing Facts pson methods more resilient"
7591de7 maint: fix a race in catalog compilation versioning.
aaf7e23 Revert "(7080) Adding json support to Indirector Request"
17d176b Revert "Adding json support to Puppet::Node"
27e0831 (#7181) Rename configurer face to secret_agent.
de2199f (#6928) Don't blow up when the method is undefined...
a0de328 (#6928) backport Symbol#to_proc for Ruby < 1.8.7
f17f6bb (#7183) Implement "invisible glob" version matching for faces
7414ee7 maint: better disabling of Signal#trap in our tests.
03bd559 maint: more robust listing of valid faces.
7db4793 maint: clean up testing code a fraction...
eeb8236 maint: better error report for a missing version of a face.
677752d maint: handle face clear/reset sanely in the interface spec.
7b3744c maint: stop stubbing log level setting.
220f308 Move tests from Puppet-acceptance repo
379b46d (#7116) Handle application-level options in parse_options
a1db585 maint: fix gratuitous whitespace in the code.
601baf1 maint: remove redundant context from the test.
5d7ef5c (#7062) better argument handling in the action wrapper methods
33b5580 maint: move method comments outside the comment.
c87d6c9 Fixed #7166 - Replaced deprecated stomp "send" method with "publish"
557767b maint: Remove unused faces code
311e3ec maint: mangle grammer in rspec to avoid Jenkins fail...
0fed94f (#7013) Wire up rendering hooks on the CLI.
12098f2 (#7013) Handle rendering modes out in the application layer.
5938452 (#7013) Strip out old face-wide rendering defaults.
5258e06 (#7013) Return bound methods for when_rendering hooks.
86801b5 (#7013) Support 'when_rendering' and 'render_as' in actions.
be23b84 (#7013) better default rendering support for faces
e6caa24 maint: make sure we don't ever default to being default...
36b100a maint: print 'false' in the default render method.
2cf692c maint: delete README.strings, which is out of date.
22355dc maint: test the 'help' face has the default action 'help'
4efba71 maint: drop multi-version support from action loading.
266f937 (#6962) Add 'description' to faces and action.
32c667c (#7132) Reject 'summary' text with newlines embedded.
1251311 (#7108) Update help/man text for puppet kick
eeb1b60 (#7108) Modernize description of --listen in defaults.rb
3ec9526 Maint: puppetmaster -> puppet master in defaults.rb
5a10093 (Maint) Fix a leaking spec, patching intermittent failures.
07b677c Merge remote-tracking branch 'community/feature/puppet-device' into 2.7.x
13e64fe (#7131) Remove support for optional arguments to options
977684e (Maint) Fixing an order-dependent failure.
9d2ec21 (#7013) Add support for required options.
eeb82f8 (Maint) Code cleanup.
d85c2a8 maint: Fix the missed failure from the previous commit
e946a17 maint: Fix a broken Puppet::Node::Facts spec
d80500f maint: speed up testing output of the help face.
9264526 (#7115) Enable default actions.
ab541fa (#7059) Use option hooks for the indirector terminus option.
f770325 (#6978) Enforce the calling convention of option hooks.
c00e03d (#7059) Set the CA location using option hooks.
dca1f07 (#6978) Add before and after decorators to actions from options.
0c60aa2 maint: delete an empty describe block containing no tests.
e424740 Adding json-specific matchers
f37b2e1 Making watchr resilient to syntax errors in tests
d3c94e6 Adding json support to Puppet::Node
155b16d Fixing a failing test resulting from a fixed bug
e0615cb (7080) Adding json support to Indirector Request
07a7a68 Fixing Facts pson methods more resilient
ff08ba2 (7118) Adding summaries for all faces
a509821 Cleanup trailing whitespace
5528911 (#7111) Clarify scoping deprecation warning
ca9d68f (#6408) Update puppet cert help for new subcommand action syntax.
174e87a (#4258) Fix pkgutil spec test to have the correct provider
e119739 (#6928) Add a notice to Parser#validate action when using default
9bc4bce (#7103) Fix HEAD requests in the HTTP handler
97e9e5f Updated CHANGELOG & version for 2.7.0rc1
5915814 Revert "(#6928) Removed --ignoreimport"
24a277c (#6928) Removed --ignoreimport
fc36e8d (#6928) Remove --parseonly
a688461 (#6928) Add a Parser face with Validate action
4ef622e (#6830) Fix sha1 to digest/sha1 require issue for Ruby 1.9
64c12bd (#6830) Fix UTF-8 encoding issue for Ruby 1.9
2d459fc (#6830) Fix string method sub call on a symbol for Ruby 1.9
78e181e (#7059) handle inherited action binding scope
cc0f414 maint: ensure we handle '-foo=' options correctly in faces.
f78ab09 (#2150) Fix File const lookup when configuring routes
cb552af (#4258) Remove superfluous command check that called pkgutil
fd98341 (#4258) Fix fd leak opening pkgutil config files
7726dc3 (#4258) Permit variations of -nv in both pkgutil.conf files
f8c2f1a (#4258) Stop file and config checks from breaking spec
ef86105 (#4258) Check wgetopts in pkgutil.conf
e852580 maint: install erb templates under lib/
db11770 maint: clean up the spec test headers in bulk.
4dd6a77 (#7056) Use 'face' rather than 'faces' in the production code.
941c56a maint: eliminate deprecated since 2008 code from Puppet.
4672141 (#6117) Add POST support to indirector requests
7b4d936 (#6962) Move option handling into #parse_options, not #preinit.
7899462 maint: whitespace cleanup for puppet/util/command_line.
826d5df (#6962) delegate global usage to the help face.
9496067 maint: avoid making temporary dirs during testing.
fe6d595 (#6962) Integrate legacy subcommands into the help face.
acbbd52 (#6962) Clean up testing further.
648e3c0 (#6962) Better argument checking for help.
217c156 (#6962) Report the template filename for help render errors.
ec988e2 (#6962) Move the logic for help layout into erb templates.
2a87f41 (#6962) Override 'render' in help to just return the string.
6570827 (#6962) Add summary help for actions on an individual face.
cdc5fec (#6962) Implement 'summary' for actions.
91c29a7 (#6962) Extract summary from legacy applications for help.
d13a938 (#6962) Initial support for legacy applications in help.
26db645 (#6962) render prints the rval; fix help subcommand.
3602102 (#6770) Don't pollute valid face list when #face? is called.
14b1e00 (#6992) Expose available_subcommands as a class method.
4eccd53 (#6962) Implement Face#summary support for the help face.
1b4d7a5 (#6962) Create the basic shape of the help face.
d8dfb1f (#6962) Implement 'summary' for faces.
dc2675d (#6770) Improve test robustness against 'require'
7228f58 maint: finish transition of application help to return strings.
a20810e maint: direct people to the expected spec file...
8b13e2b maint: watchr should respect personal account-wide defaults.
6fcf03c maint: added testing for Puppet::Faces#[]
20d9ac1 maint: fix indentation in the watchr script.
0c6f50c (#775) Don't require command when removing cron entries
b2831e1 (#2150) Add routes file for indirector
e569f3b (#5027) Use Puppet#warning for deprecation_wanring instead of Kernel#warn
f6fb193 (#5027) Spell deprecation correctly
d0a5652 Fix for #5027 -- generate a deprication warning for dynamic lookup
739260b Towards 5027 -- add options hash to lookupvar as with setvar
d7201ed Refactor for 5027 -- get rid of lookup_qualified_var
10230cf Step towards #5027 -- scopes should know if they are dynamic
e5609ff Step towards #5027 -- add Logging#deprication_warning facility
1954bbf Refactor on the road to #5027 -- remove unused Scope#strinterp
31f8e66 Refactor en route to #5027 -- remove usestring parameter from lookupvar
d5dc303 Fix for #5063 -- explicitly scope internal variable lookups
b3baee8 Refactor on the way to #5063 -- removing unused Scope#level
dd33eac Refactor prior to #5063 -- remove dead "topscope?" code
cb01221 (#3360) Add an allow_duplicate_certs option
d2145d9 Fixed #5684 - Move to Apache 2.0 license
5075658 Fixing Indirector::Facts::Couch loading
26b6b37 Fixing dependency loading in Rails::FactName
379a379 Fixing 'puppet faces' application
69db817 Fixing the watchr script
8ec9d13 Fixing FaceCollection#faces
7e9707a maint: Fix sporadic sqlite error
64be97b maint: Fix sqlite3 require to really be optional
6ed0051 maint: just require 'spec_helper', thanks rspec2
f9271b9 maint: delete dead darwinport package provider
a19fbb4 maint: don't take over signal handling in tests...
f9a2ffd maint: use FileUtil to remove files, not exec
78cb48c maint: disable garbage collector during individual test cases.
d43f850 maint: Ruby < 1.8.7 knows size but not count
101c6ed maint: Get tests passing on Ruby < 1.8.7
9490cc9 (#7026) Remove whits from reports when finalizing
3094d42 maint: Add Array combinations method
e0a2e91 maint: mark tests pending for a discovered bug...
49dcc24 Updated confine in Spec test for RSpec 2
28e3db8 Add management of router/switchs global vlans
1cb1841 Cisco Switch/Router Interface management
596571f Base class for network device based providers
6560da5 Ssh transport for network device management
358245a Telnet transport to connect to remote network device
c947a6d Remote Network Device transport system
aa34b72 Introduce a module for some IP computations
79f4774 maint: mocking 'require' causes random stack-overflow failures.
d9f23c0 (#6969) String failures differentiate between invalid string/version
292a8b9 (#6985) Allows indirectors to accept a hash as an argument.
d04567f (#7005) added require 'tmpdir' to spec helper.
87ed318 (#7012) Split plumbing into Puppet::Interface
8d144d0 (#7012) Update references in code to use face(s)
5592034 (#7012) global rename of strings to faces.
6be1eb8 Maint: fix a load order problem with type(:component)
03afbad (#7006) Add a missing require to puppet/string/option.rb
cab5672 (Maint) Fix uninitialized constant.
27bd1ad (#6983) mark test pending until string is fixed...
a03790d (#6972) Handle ca-location in the certificate string.
7e7d246 (#6972) Recognize puppet global options in pre-parse.
0b97bd0 (#6972) Clean up OptParse name extraction a little.
d4012db (#6995) Fix indexing of :current on string load.
07a79cf maint: add `write_scratch_string` helper for testing...
a1a09b0 maint: whitespace cleanup for spec_helper.
a125536 (#6995) more robust testing of string loading
2a6c6cb (5200) -- replace containers with sentinals
8ddd994 (#6982) Patch the Certificate String against (#5528).
e20e618 (#5528) Add REST API for signing, revoking, retrieving, cleaning certs
0950d09 (#6949) Fix passing positional arguments to actions.
4d2a367 (#6964) use 'when_invoked' rather than 'invoke' for actions.
75ef3af maint: added testing to ensure we inherit options correctly.
0c74495 (#6749) Handle options with inline arguments.
cec3b6e (#6749) Extract the action from the arguments cleanly.
5a0b547 (#6749) Fix optional vs mandatory argument handling.
8b37d70 (#6749) Polish the CLI option pre-parse implementation
37c97cd (#6749) clean up various testing bits...
d328af7 (#6760) set terminus in indirector string base class.
4d23d60 (#6749) add a shim around the action implementation.
eb4c4fb (#6749) Start porting existing strings to the options API.
8723b1c (#6749) code and test cleanup of Application/StringBase.
3d88808 (#6749) base indirector string should fail on invalid terminus.
c52261c (#6749) disable Action#invoke for this release.
1635454 (#6749) Remove "save does not work" language from strings.
423fe1f (#6749) string cli base: implement preinit CLI parsing
512778f (#6749) detect duplicate aliases in a single option statement.
3bb6145 (#6749) fix an inheritance bug in ActionManager
a113e8f (#6749) implementing option handling in CLI string wrapper
5bba1a2 (#6749) Implement support for options on strings and actions.
1400fec MAINT: nicer to_s for actions, for user-focused rendering.
05b434d (#6758) Pass options as an argument to string actions.
a3f5f97 MAINT: fix error reporting when you set terminus incorrectly.
6554fd3 MAINT: delete a test that can't work on 2.6.
56ba0a2 MAINT: implement a pending test for code we wrote...
76760db MAINT: use a table for table-style tests...
0e834af MAINT: fix up tests that depend on the LoadError message to work.
5dc994c (6911) Cleanup and renaming of transaction internals
8af29c8 (6911) Core change -- replace topsort with frontier ordered by salted SHA1
8b5ffde (6911) Add bookkeeping facade around Transaction#relationship_graph
ee1df78 (#6937) Document the recurse parameter of File type.
fa5c2b1 (6911) Cleanup of generate_additional_resources
7b83cd9 (6911) Refactor to localize eval_generate dependency assumptions
f76db9e (maint) Fix for require order issue
127501e (6911) Use normal methods to implement "depthfirst?" test
505a48c (Maint) Bugfix for failing requires inside Puppet Strings.
5a90355 maint: Use bracket notation instead of define in specs
f7f1e58 (#6770) Fix Puppet::String#load_actions.
1ac7f63 (#6830) Fix tests that depended on special inherited behavior
29f3dda (#6830) Fix overly stubbed tests
5e9dfdc (#6830) Fix instance_variables now comes back as symbols
893817f (#6830) Fix badly stubbed Time object in test
ade4efe (#6830) Fix MD5 handling to work with Ruby 1.9
bfac57a (#6830) Fix File class scoping
a520c5e (#6830) Handle case where array is actually a string
85f3b76 (#6830) Fix case where instance_variables returns symbols in Ruby 1.9
4609e20 (#6770) Change versioning; adopt :current over :latest.
b859baa MAINT: the API is officially named "string" as of this moment.
076de13 (#6855) ResourceType#search now accepts a regex
daaa048 (#5477) Allow watch_file to watch non-existent files, especially site.pp
e16a383 Fixing #6851 - ResourceType#find/search loads types
29268f3 Fixing Module#path detection
da082d5 Fixed #6850 - Clean up ResourceType#to_pson
88aeb04 MAINT: fix the misordered invocations in action.
b42c57d (#6830) Fix stat method calls to not use an unneeded argument
6aea116 (#6770) Add support for version :latest.
1af9bb2 (#6770) Add version lookup and comparison.
78371a7 (#6770) Refactor Puppet::Interface#initialize.
53b0656 Config#print action always returns nil
8124f8e (#4576) Raise an error when a node is classified into a non-existent class
633f63c (#6833) support 'script' as a short form of 'action'
b3c059e (Maint.) Require 'puppet/interface' in spec_helper.rb
c25fb94 (#6770) Rename Puppet::Interface::interface method.
7aa8f22 (#6770) Changing versioning to semver.
635751d Propagating an argument to search out of core.
1187a0e (#6770) Add basic versioning for interfaces.
36a5665 (#6820) Fix File class lookup in the file type for Ruby 1.9
8c32db7 (#6820) Fix nagios parser to use proper hash syntax for Ruby 1.9
054eac6 (#6820) Fix Invalid multibyte character
7a4fcf2 (#6820) Fix RDOC parser to work with Ruby 1.9
341654e (#6820) Fix invalid next that should be a return
3d43d86 (#2782) Fix constant_defined?
961c716 Added list action.
a7a9e12 Alter generate action to work on CSRs only.
a1ce253 Adding Certficate#generate
562ae5f WIP - all tests fail
562bd0f Use the new name for the terminus.
5d7715b Factoring cert status app back into certificate.
af79d3c maint: Fix order-dependent spec failures
847ac20 maint: Implement an InterfaceCollection class to manage interfaces
6180397 (#6527) Fix pip tests
557ed85 (#4258) Fix hash duplication affecting canonical provider instance
0170ceb (#6527) Fix uninstall problem and refactor
af42367 (#6527) Added pip package provider.
ee66f36 (#6814) Add missing require for specs
50ba62d maint: Make args to Catalog.select explicit
e3d2486 (#6814) Create a dedicated Action class
a58bf95 (#6786) Change interface storage and access.
f6da333 maint: Change code for finding spec_helper to work with Ruby 1.9
307df20 Fix error "invalid multibyte char (US-ASCII)" under Ruby 1.9
4156edc (#6566) Replace tabs with spaces
d448763 (#6566) Fix ruby 1.9 incompatible case statement
517fd2f Fixed #6566 Replace ftools with filetuils in rake gem task
ad8cc54 (#6555) Fix another ruby 1.9 incompatible case statement
0844a17 Fixed #6555 - Fixed two more when then colon issues
923d613 Fixed #6555 - Ruby 1.9.x returning Invalid next (SyntaxError)
66a4f36 Fixed #6555 - Ruby 1.9.x warning: class variable access from toplevel
c2627a3 (Maint.) Remove Puppet::Interface#unload_interface
63f33d0 (#6805) Add a "configurer" application
84ba21e Fixing a load-order issue in Puppet::Interface
072becf (#6806) Improve error checking and reporting for interface naming.
ba67cc8 (#6785) Internal consistency for `--terminus`.
a7173dc (#6786) Fixing a number of failing tests.
9c85d70 (#6785) Rename the --from option to --terminus.
b187e07 (#6786) Removing the #interface method.
7c99dd9 (#4258) Use pkgutil -a to reliably determine package common names/aliases
ab5bc35 (#4258) Update pkgutil spec for recent impl changes
cf873c6 maint: Silence test output in the spec run
f4401d3 (#6722) load all functions before testing...
4905956 (5909) Function to dyncamically generate resources.
1a55c7a (#5479) Test that we auto-require the zone dataset.
0a2a58c (#5479) Autorequire zfs filesystem when zone dataset is configured
e582709 (#4258) pkgutil: bug fix: if shortname is not equal to package name
682686f (#6441) Add mount fixture for AIX's /etc/filesystems
349f6f2 (#6641) Make it easier to add future platforms to the suite.
6a96584 (#6441) Mark solaris tests pending, because we can't stub it.
b4f1b98 (#6641) fix mount provider tests broken in the 2.6 merge.
3b89f32 maint: use chdir rather than depend on bash for win32
2a91572 (#4798) Make rdoc work if moduledir & manifestdir overlap
28ce355 maint: Fix rdoc when documenting manifest files
58ac7d3 (#4258) pkgutil provider: better handling of short package names
9a1c3b5 maint: spec/integration/configurer has races in time checking.
75af582 maint: Move puppetdoc settings to defaults so we can use them in tests
124ff3c maint: Fix a randomization test failure
455d197 (#6582) Don't demand the checkout be named 'puppet'.
85a743b (#6582) stub puts to prevent screen output when testing help.
ec23d96 (#6582) eliminate a backtrace from mismatched block arguments.
93082e4 (#6582) unstub Puppet settings to improve indirector queue tests.
92499c8 (#6582) Eliminate the last vestige of the unit tests from the specs.
3954576 (#6582) eliminate fakeresource use in ssh_authorized_key spec.
53b6df3 (#6582) eliminate fakeparsefile helper method.
0f6faf5 (#6582) Eliminate the old fakedata helper method.
f490526 (#6582) move more helper code into methods, out of RSpec#configure
6b8f1b7 (#6582) add fixture helper methods to replace unit test code.
7c9f1b8 (#6582) order RSpec global :before and :after hooks naturally.
b311651 (#6407) Fix spec test hang with Mocha >= 0.9.11 in zlib testing
af2c85b (#6551) remove deprecated 'env' parameter to the 'exec' type
f67e7fa Modifying Facts.upload a bit
ece0c8e Fixing #16 - nodes default to yaml
63263a4 Fixing #13 - showconfig moved to indirector
23064bb Adding a test for fix to #14
353b914 (14) updated interface_base to support multiple command line arguments
9c0e55b (#5496) Added tests for the new zpool output format
b1d9728 (#5496) zpool provider supports new 'zpool status' format
026eba3 Revert #5691 "Merge remote branch 'brice/feature/process-instrumentation' into next"
905ff3a Pretty-printing json using "jj"
f0d7684 (#6494) Add setm command to Augeas provider
0026e43 (#6494) Add mv command to Augeas provider
67ed160 (#6494) Add defnode command to Augeas provider
45cba13 (#6494) Add defvar command to Augeas provider
66c994a Attempting to skip loading of duplicate actions
21b541d Fixing plugin usage
59a6485 Adding Application options to Interfaces
4fa54d0 Adding render and exit_code override support
bec807e Fixing 'puppet interface list'
368210e Adding a simple "config" app
c2715c0 Splitting the Application base class
7da0a26 Adding a string form to interfaces
04fb6de Switching Interfaces to be instances
0cbdbce Renaming 'data_baseclass' to 'interface_base'
ef289e5 Fixing indentation
cf79349 Updating readme to reflect requirements
15a53f0 (#4258) pkgutil provider: misc enhancements
cde1baa Fixing Interface listing
eff4eec (#3) Base application should catch SYSINT
a54ee1e (#2) Should not assume interfaces have indirectors
15e225b Add spec tests for pkgutil package provider
8462acd * Fix exception on parse failure of pkgutil output * Fix exception when querying latest version for unknown package
7639d5f Fix non-existent method called in SMF manifest import exception message, updated spec
f5e21f0 (#6324) Use real service resource object instead of a stub
ef9e929 (#6324) Add spec for SMF service provider
b18f045 (#1204) Make rake gen_manpages fail explicitly if ronn isn't present
ae4112b (#1204) Add manpages for modern apps and update puppet.conf manpage
f6485d6 (#1204) Fix --param flag in puppet resource manpage
dac032d (#1204) Make rake gen_manpages output puppet-{application} manpages
a0cff49 (#1204) Update all the manpages
c619520 (#1204) Move man generation task from install.rb to a rake task
9e19d22 (#1204) Edit content and formatting of puppet resource help
f4c7e48 (#1204) Edit content and formatting of puppet queue help
bd14ff5 (#1204) Fix --compile and --apply options
768d9a1 (#1204) Reformat help text for puppet master
3f1c26f (#1204) Reformat help text for puppet kick and inspect
d198db2 (#1204) Reformat help text for puppet filebucket
c35aa60 (#1204) Fix garbled help for puppet filebucket
1800d00 (#1204) Edit content of puppet describe help
f653b8d (#1204) Reformat help text for puppet cert and describe
969b8b0 (#1204) Edit content and formatting of puppet apply help
489b065 (#1204) Reformat help text for puppet doc and puppet agent.
7e3a023 Only printing output if there is any
b3f903a Enabling arbitrary interface names
782ca8d Fixing an error message
0b18cb6 (#6324) Always fall back to svcadm enable except for the maintenance state
9e124e1 Fixing rendering to support arrays
3ffb9ab Moving 'format' support to the application
7a325fe (#6144) add missing zfs properties
9cb594f Finishing the s/data/interface/ in the application
5190aba Adding to README
264a43c Renaming "data" app to "interface"
efca35c Finishing migration from puppet repo
adc9244 Feature #2597 -- generate a DOT graph of cycles on request.
2cf4528 Feature #2597 -- eliminate OpenStruct for performance...
9584cda Feature #2597 -- use O(1) methods as often as possible.
d302628 Feature #2597 -- improve names and whitespace in the code.
9ea74cc Feature #2597 -- report all paths in each cycle found.
e30fd8f Feature #2597 -- remove obsolete licensing comment...
f547118 Feature #2597 -- use iterative DFS in Tarjan clustering.
34a57b8 Feature #2597 -- really find and report cycles.
403adb8 Feature #2597 -- nicer reporting of relationships.
1ad6470 Feature #2597 -- fix cycle relationship notification format.
3f2f1c2 Maint: move puppet resource --help
82e004f Maint: move puppet kick --help
95fc38c Maint: move puppet queue --help
a041e19 Maint: move puppet doc --help
7568b78 Maint: move puppet cert --help
9fdd66b Maint: move puppet apply --help
c61d6d0 Maint: move puppet describe --help
ae78264 Maint: move puppet filebucket --help
fc66e57 Maint: move puppet master --help
9b521d7 Maint: move puppet agent --help
8d569b3 Maint: remove puts and exit from inspect --help
e1191f3 Maint: remove rdoc/usage dependency
025768f Adding license and readme file
809aebe Moving data executables to their own module
fb339cb (#5432) Use AIX native commands to manage users and groups
aa8c09f (#5432) Use AIX native commands to manage users and groups
d65e094 (#5432) Use AIX native commands to manage users and groups
27abd84 maint: Stop stubbing 'use' on any_instance of Puppet::Util::Settings
7ed5251 maint: Work-around for a Mocha bug
52f8ddd (#5432) Use AIX native commands to manage users and groups
9032898 (#5432) Use AIX native commands to manage users and groups
e27d208 Some high-level process name probes
aed4b5f Process name instrumentation infrastructure
b94c1b4 (#5427) Using Propery::OrderedList for host_alias
cca3436 (#5427) Remove redundant testunit tests
c88afa0 (#5393) Add "dataset" parameter to the zone provider
626d756 maint: Use expand_path when requiring spec_helper or puppettest
b9f3847 maint: Fix more order dependent test failures
b67f4c6 maint: Restore a default value that can cause order dependent test failures
094a5c8 (#5211) Added patch and tests for checking the size of the arrary which is returned
0ab5e0f (#2495) Better value validation for sshkey
0747b58 Maint: Modified uses of indirector.save to call the indirection directly.
f77764d Maint: Modified tests of indirector.save to call the indirection directly.
7de6af8 Maint: Add a default value for key in Facts::NodeExpirer#save
beb85d6 Maint: Moved auto-signing logic into an indirector extension
3063000 Maint: Swap the order of arguments to Indirection#save
8766efe Maint: Make http handler code call the indirector through ".indirection"
71ecad9 Maint: Refactor code to use <class>.indirection.<method>
14f8160 Maint: Refactor tests to use <class>.indirection.<method>
3eace85 Fixing indentation
f8e9155 Removing blastwave references and unused PAGER
485ac38 Changing indentation to 2-spaces as per 2.6+ style
9d63171 Single package queries made more robust when dealing with pkgutil noise
f50fac7 Fixing wget verbose regex
0f00bf4 Maint: Removed unused monkey patch that connected OpenSSL::PKey::RSA to indirector
c5a1ca0 (#5391) Include additional zfs properties
3a815e1 (#5375) Rework puppet apply to use configurer.run
99f4d2f Maint: made upstart tests more robust.
9ccd29f (#2866) yum should support downgrade.
04389f5 (#4711) Provide unit tests for yum package provider.
0956757 Fix #5261 Don't escape Unicode characters in PSON
4a2bbbc maint: Fix tests that don't run on their own
f3cd668 maint: Fix a test that was missing a require
7c16215 maint: Fix a test that was missing a require
32dcb31 (#5370) Made metrics and --summarize work with Puppet apply
e825485 Maint: Added assertion to make sure Log.close_all succeeds
cf18353 Maint: Switched spec tests to use a class rather than Array as the log destination.
ee56cfd Maint: Improved spec tests
b089392 Maint: Modified "rake spec" so that it prints full backtraces.
6e51d11 (#5274) Fixed some "rake unit" tests that were inadvertently broken by commit:ee7d2f92f9d3ec45b5c3a9cd3fe2f5832b17f23b
cd8126f maint: Fix intermittent parser spec failures
2052f36 (#5274) New tests for new hosttype/parsedprovider
ee7d2f9 (#5274) New comment property for the hosttype
8efdc76 (#5274) Tests for hostprovider removes comments
28e5772 (#5304) Use internal_name rather than real_name for maillist provider
3003719 These regular expressions will not match anything.  pkgutil doesn't output anything that can be matched.
6c7290b (#5079) Refactor and cleanup mcxcontent provider
c643e98 (#5079) Move methods around to make it clearer whether they're public or private
2725fb3 Add comments that explain what we are ignoring in the package and remove legacy output
143fc74 Ignoring lines from use_gpg and catalog fetching
69a3451 Adding patch from Rudy Gevaert to fix not installed detection
b753d83 Fixed #5288 - Changed report default to true
ccc944f Fix #4339 - Locally save the last report to $lastrunreport
8ab1aba Fix #4339 - Allow puppet apply to save last run summary
4d31430 Fix #4339 - Save a last run report summary to $statedir/last_run_summary.yaml
b0acb02 (#3747) Add specs for upstart provider
2b772f7 (#3747) Implement upstart provider
6f1416d Fix #4904 Mounts shouldn't remount unless they are ensure=>mounted
bf11e7c Maint: Move "Local-branch:" info below "---"
04515cf (#5198) Added a spec test for new TB unit
631c5a8 Maint: Add "Local-branch:" info to mails sent by "rake mail_patches"
2ec1b55 Maint: Added missing requires to fileserver.rb.
f0a1467 Maint: remove unnecessary stubbing from agent_spec
5c24579 maint: prevent fork bombs by disabling ActiveSupport's Kernel.daemonize
f8d1427 maint: First draft of cert inspector
4506dfe (#5150) Make fact REST terminus configurable to connect to inventory service
71a0cea (#5198) add terabyte support to tidy type's size parameter
91ac162 (#5198) add gigabyte reference to docs for tidy type's size parameter
cfe2025 Maint: Remove Indirector::Request objects from HTTP Handler and API V1
3d32fe8 (#5166) Inventory service is now searchable by timestamp.
1f80cc6 Refactored Puppet::Node::Inventory::Yaml tests in preparation for adding freshness check
6c11601 Refactor Puppet::Node::Inventory::Yaml in preparation for adding freshness
fb5f859 Fix #5164 Change Facts timestamp when they are received by the master
5f0cf4e Maint: Don't use a stub for a Facts object in the compiler specs
90af920 Maint: spec/unit/indirector/catalog/compiler_spec.rb wouldn't run by itself
5bf19e4 [#4894] Randomize port on webrick tests
45a9a97 (#5132) Provide a query REST interface for inventory
2c98db6 (#5148) Fix failing spec due to timezone
c2ea112 (#5148) Add support for PSON to facts
7d35a47 Fixed to #5108 - Change default of service hasstatus property to true
4d1681e (#5062) Add envpuppet helper script to ext/
f2537d8 Puppet-load: better and safer error reporting
ce1865f Fix #5023 - puppet-load multiple nodes support
efeb2f4 Make --mkusers work on OS X, we now find unused uid/gids if unspecified like other platforms.
3c44121 [#4590] SimpleGraph is slow
6dd1930 Fix test failures that fixing #4726 exposed.
ce9bf1e Modified the error message that is generated when a class, definition, or node occurs in a conditional construct so that it contains the proper line number.
6b27850 [#4657] Customer-supplied .rb files are not compatible with multiple environments or staleness check
25048ec [#4685] Classes, defines, and nodes allowed inside of non-evaluated conditionals
1ba536e [3782] Test isolation problem in test/ral/providers/cron/crontab.rb
df088c9 [4638] Cleanup of plurals and inheritance relationships in AST
50fd9b7 Fixed issue #4570 (Race conditions when serializing objects to YAML).
4da88fb [#4496]+[#4521]+[#4522] Add structures to the AST to represent type definitions (classes, definitions, and nodes).
caca187 Moved perform_initial_import from Puppet::Resource::TypeCollection to Puppet::Node::Environment.
6b1dd81 [#4472]+[#4483] Moved type-name resolution out of Puppet::Parser::TypeLoader.
6dbd477 [#4397]+[#4344] Move type-name resolution out of Puppet::Resource into the AST resources.
d026bb7 pkgutil provider: Using the --single option which speeds up execution.
ec2a03c pkgutil provider: The path to the admin file is /var/opt/csw/pkgutil/admin
0fc2aa6 pkgutil provider: Correcting a typo in a message.
e02ba01 Using --single in the pkgutil provider.
fc18591 Adding pkgutil support.
9f365b1 Fixed #4258 - Added pkgutil package provider
83d9874 Use the name in the search path for looking for metadata
70c293a Fix for environments in startup script. - Dropped the forced --manifest switch in the   suse startup script to allow for environments   to re-define this. Otherwise, environments will   not work as puppet override configuration with   command line arguments.
62bc09e Redmine: 2474 - Fix for mount fstype documentation
7faf27c [#4064]  Modify confine to also allow a message and a block containing the test.
e4b3aac [#4063] Add confine to describe block that depends on ActiveRecord
97936c6 [#3921] Add facts_terminus setting to Puppet settings
db39b7c [#4026] When --use_cached_catalog is specified on a puppetd run actully use the cache
4286839 [#4001] Added explicit check and error message when creating a file if parent doesn't exist
34d1897 [#3835] Fixed recursively absent directories improperly managing their files
9d0d94c [#3804] Fixed one failing spec for RackREST
da66e16 Fixing #3651 failing to pop comment stack for some constructs
069bf1b Fixed require warning documentation
23431da Fixed mcx documentation error
705cfe1 Documentation fixes
0a0923c [#4006] Fix test failures caused by reverting ticket 2890
8faa466 [#3866] Rename the method metaclass to singleton_class to avoid the deprecation warnings from Rails ActiveSupport
53e3610 Bug 3731. Applied Fix suggested by Doug Warner to always flatten out the array
b9aba7c maint: Have 'rake spec' output in color
3d7168b Fix for #3107 Changing users on AIX
5716028 Fixes #3663 - It should be possible to list signed hosts only
d71bd68 Updated CHANGELOG for 0.25.5
d88b357 Fixes incorrect line in partial CRL fix
dec84e5 Fixed documentation issues exposed in #3772
4daf8c3 Updated CHANGELOG for 0.25.5rc3
9214400 WIP - trying to fix #3460
9d3e98b Minimal footprint fix for #3751 (serialization 0.25.5 <-> 0.24.8)
d481340 Updated Template documentation link
5a1a45c Update Red Hat spec file for 0.25.5
2257605 Updated CHANGELOG for 0.25.5rc2
5258a0a Fixing #3533 - Removing all transaction cleanup
bcde541 Fix for #2910 -- Tidy/matches is too tricky to use
5abe571 Bug #3451: Don't leak the terminus class setting from Puppet::Resource::Catalog's spec
ebd924c Fix to the fix for #3295
ce233aa Write ssh_authorized_keys as user
6739bab Fix for #3558 -- source file reading speedup
b0e3c61 Fix for #3556 Plussignment value melding
8a30495 Fixed #3655  - Puppet doesn't find installed packages with portage provider
e4130af Fixed #3672 - Error message on duplicate fileserver mounts incorrect
1275a47 conf/redhat: Add notifempty to logrotate config
134204d Fixed stored configuration documentation
1aa98a6 Fixes #3653 - Changed default factpath value to better reflect plugins in modules
44f6d64 Partial fix to #2837 - changed warning message to debug
3a1b178 Fix #3555 - fix state of purged lists
f6046ab Fix for #3577 -- to_yaml parameter in 0.25.5rc1
f351e2d Renamed all references to Reductive Labs to Puppet Labs
cf7e696 Updated Rake tasks to no longer load puppet.rb
b93924e Fix #3540 - name methods correctly
9bc2f28 Fixes #3295 - generate() now sets the working directory to the directory containing the specified command.
3ee6834 Added YARD task
99818ef Update man pages and partial doc fix to #3491
f988af3 Fixed #3532 - Typo in lib/puppet/ssl/host.rb
f0e12e5 Fix #3496 - suppress transaction debug message
0eea2f5 Updated version and CHANGELOG to 0.25.5rc1
57ae381 Modify SuSE spec file for 0.25.x and correct shebang lines for puppetd/puppetmasterd
d90ec79 Fixes #3460 - Makes Puppet FHS compliant by moving /var/puppet to /var/lib/puppet
ae0b0bf Fix for #3101 (bug in MRI 1.8.7)
9db066b Fixes #3419. OS X 10.6 Ruby doesn't set supplementary groups
306d082 Revert the guts of #2890
4eea77a Fail gracefully on packages that don't have the HOMEPAGE variable set (e.g. dev-lang/php).
f5b8494 Fixed #3443 - Typo in mount type
b0ef2c6 Fixes #3135 - darwin doesn't support 'mount -o remount'
7018cf5 Adding :catalog_terminus setting
978ab8a fixing obsolete comment in puppetd
6d13d0d Adding support for only using cached catalogs
bc28715 Refactoring Configurer to enable the next feature
ba43d7b Fix for #3366 - --tags '' treated as boolean 'true'
5ab5e8a Supressing warnings (not really failures) in test/unit
e4df0b0 Fix test using wrong Puppet util filesetting group
eeb3d74 Mock user in SUIDManager tests
9ea27db Removing resources generate tests
218e3e9 Removing old test for service/debian provider
1556938 Replace test/unit file write test with spec
2defc00 Fix for #3424 and tests to prove it.
44798b9 Fixed changelog Rake task
5d10f65 Fix #3155 - prevent error when using two matching regex in cascade
fbedb99 Fixing #3148 Settings#without_noop when run with no noop setting
389c77b Another trivial follow-up fix for #2604: invalid path to zaml.rb
56b5753 Fix inefficient SimpleGraph#matching_edge
4b2b9eb Fix #3229 - use original value in case/selector regex matching
19863c0 Fix #2929 - Allow checksum to be "none"
fd76142 Fixed puppetlast typo
3b4e782 Follow up for #2604, debug msg left behind.
e44430b Fix for #2604 Pure Ruby yaml generation
74cd55f Fixes #3113 - When importing a manifest puppet needs to chill
7ec50a7 Fixes #3387 - Handle path elements with ticks and spaces
d561a98 Fix for #3412 install.rb should not put "." first in the tmp_dirs
751df45 Fix #3186 - require function set relationship only on the last class
a1d216c Fixed the return types were valid, and removed the copy paste error with the exception logic
d532e6d Fixing #3185 Rakefile is loading puppet.rb twice
5aa596c Fix #3150 - require function doesn't like ::class syntax
3457b87 Added time module to tagmail report

2.6.16
===
65446c9 Revert "(#5246) Puppetd does not remove it's pidfile when it exits"

2.6.15
===
f7829ec Stub mktmpdir and remove_entry_secure in os x package providers
7ac1ec8 (#13260) Spec test to verify that mktmpdir is used
0180200 Refactor pkgdmg specs
c51447d (#13260) Use mktmpdir when downloading packages
568ded5 Fix for bucket_path security vulnerability
6bef2e6 Removed text/marshal support

2.6.14
===
ade5965 Remove unnecessary fallbacks in change_{user,group}
0a09a64 Document uid/gid-related methods in Puppet::Util
2599d56 Copy owner/group in replace_file
ead36ff (#12463) eliminate `secure_open` in favour of `replace_file`
1469538 (#12460) use `replace_file` for the .k5login file
8461203 (#12462) user_role_add: use `replace_file` for /etc/shadow
0ad532a (#12463) add secure `replace_file` to Puppet::Util
76d0749 (#12459) drop supplementary groups when permanently dropping UID
50909b9 (#12458) default to users primary group, not root, in `asuser`
d00c5cc (#12457) add users primary group, not Process.gid, in initgroups
d937ae3 (#6541) Use the same filebucket for backup and restore
a758066 (#11996) Fix test failures due to hash processing order changes.
e0e31d5 (#5246) Puppetd does not remove it's pidfile when it exits
0ab4597 (#11764) Fix failing cron test
073ca03 (#11764) Fix cron jobs for passing block to method

2.6.13
===
e4ee794 (#10739) Provide default subjectAltNames while bootstrapping master
9dfd011 (#5617)  Puppet queue logging
a91cfa1 maint: Fix failing spec on old version of rspec
aa2a762 (#10289) Add an ext script to upload facts to inventory server
5129d38 (#10289) Add a safe alternative to REST for inventory service
7514d32 missing includes in network XML-RPC handlers
397a506 (#10244) Restore Mongrel XMLRPC functionality
e7a6995 (#9794) k5login can overwrite arbitrary files as root
0a92a70 Resist directory traversal attacks through indirections.
8d86e5a (9547) Minor mods to acceptance tests
2bf6721 Reset indirector state after configurer tests.
bb224dd (#8770) Don't fail to set supplementary groups when changing user to root
2a0de12 (#8770) Always fully drop privileges when changing user
00c4b25 (#8662) Migrate suidmanager test case to rspec
d7c9c76 (#8740) Do not enumerate files in the root directory.
0e00473 (#3553) Explain that cron resources require time attributes
769d432 (#8302) Improve documentation of exec providers
c209f62 Add document outlining preferred contribution methods
fb2ffd6 (#8596) Detect resource alias conflicts when titles do not match
89c021c (#8418) Fix inspect app to have the correct run_mode
3165364 maint: Adding logging to include environment when source fails
f484851 maint: Add debug logging when the master receives a report
e639868 Confine password disclosure acceptance test to hosts with required libraries
a109c90 (maint) Cleanup and strengthen acceptance tests
b268fb3 (#7144) Update Settings#writesub to convert mode to Fixnum
4a2f22c (maint) Fix platform dection for RHEL
111a4b5 (#6857) Password disclosure when changing a user's password

2.6.12 (CVE-2011-3872 see http://puppetlabs.com/security/hotfixes/cve-2011-3872/)

2.6.11
===
e158b26 (#9793) "secure" indirector file backed terminus base class.
343c7bd (#9792) Predictable temporary filename in ralsh.
88512e8 Drop privileges before creating and chmodding SSH keys.
2775c21 (#9794) k5login can overwrite arbitrary files as root

2.6.10
===
ec5a32a Update spec and lib/puppet.rb for 2.6.10 release
fe2de81 Resist directory traversal attacks through indirections. (CVE-2011-3484)
243aaa9 (#7956) Porting cron tests
3e3fc69 (#7956) Port resource acceptance tests

2.6.9
====
db1a392 (#7506) Organize READMEs; specify supported Ruby versions in README.md
381fa40 (#6418) Make test 64118 more portable
98ba407 (#7127) Stop puppet if a prerun command fails
6996e0b Do not needlessly create multiple reports when creating a transaction
caca469 (#4416) Ensure types are providified after reloading
413b136 (#4416) Always remove old provider before recreating it
d866ce1 Cleanup indentation, comment, and unused code
98f58ce (#2128) Add WARNING for node_name_{fact,value} descriptions
1cd848c (#2128) Whitespace only reflow commit
d9b5c1a (#2128) In-line docs for node_name_{fact,value}
3f0dbb5 (#650) Allow symlinks for configuration directories
c260cf1 Fix acceptance tests not managing their masters
1c70f0c (#2128) Add support for setting node name based on a fact
c629958 (#2128) Get facts before retrieving catalog
cd4fe14 (#2128) Add the ability to specify a node name
8ebec1e (#7193) Fix path issues with acceptance tests that call old shell tests
16b2311 (#6885) puppet agent fingerprint requires --verbose to return a value.
a00fd25 maint: Refactor specs in preparation for making node name more flexible
75e2764 (#5318) Always notice changes to manifests when compiling.
4a5e99d (#7681) Add an acceptance test for resource refs with array variables
646919e (4123) Fix test for 4123/4 on old egrep in cent4
8b76be3 (#3836) External nodes should only capture stdout
8f907f2 adding test for ticket 7139
90eb937 (#7139) Accept '/' as a valid path in filesets
1b2a7d9 case seems needless here as there is only two opts, also the rest of the file seems to use if so this should make thin
729336e (#6845) Mount writes incorrect vfstab entries
16cf1ac (#6442) Be able to start agents --listen without namespaceauth.conf
0352402 (#3420) Nagios "name" attribute does not output correctly
f656818 (#4487) When setting environment on a host, ensure it is a string.
2cce326 add test for ticket 7101
c306db2 (#6487) Add some testing for OS X version support in DirectoryService provider
0008b63 (#6487) Directoryservice provider will fail in future OS releases
34f9f41 Maint: Fix a #4655 introduced log inconsistency
6b18f8f Move acceptance tests from puppet-acceptance repo
9a5bf6e Fixed #7166 - Replaced deprecated stomp "send" method with "publish"
656eff8 (#4655) Allow stage to be set using a default class parameter
7f658e6 vim: Initial ftplugin and indent support
ccbe9f3 Fixed #6681 - Remove --force-yes option from aptitude is used

2.6.8
=====
c1edcb2 add test for ticket 7101
db26326 Move tests from puppet-acceptance repo
bee1ef7 Updated CHANGELOG for 2.6.8rc1
8b7444d (#2331) Remove darwinports pkg provider, replace with rewritten macports provider
65c4e14 Fixed #7082 - Added system support for groups
b7f4ff7 (#7018) Give more context on the service type's assumptions. Wording tweaks.
bb19dea (#7018) explain internals better in service provider documentation
23c9663 maint: Fix sqlite3 require to really be optional
4b73d41 maint: Fix sporadic sqlite error
54b9f5d (#6818) Stop from getting Rails 3 named_scope deprecation warning
e493f8a (#6856) Copy dangling symlinks with 'links => manage' File resource.
1e4968e (maint) Indentation fixes
99d78f2 (#6490) Add plugin initialization callback system to core
5d1cb02 Fix #4339 - Locally save the last report to $lastrunreport
306aa30 Fix #4339 - Save a last run report summary to $statedir/last_run_summary.yaml
9bb3018 Fixed #3127 - removed legacy debug code
d2bacd3 Fixed #3127 - Fixed gem selection regex
1b66c28 (#5437) Invalidate cached TypeCollection when there was an error parsing
0675c9a (#6937) Adjust formatting of recurse's desc
2cdadf9 (#6937) Document the recurse parameter of File type.
647a640 (#6893) Document the cron type in the case of specials.
87ca313 (#5670) Don't trigger refresh from a failed resource
f5aabf5 (#5908) Add support for new update-rc.d disable API
37f9ca0 (#6862) Add a default subject for the mail_patches rake task
9a4de12 Fixed #6256 - Creation of rrd directory.
7c60db5 (#5477) Allow watch_file to watch non-existent files, especially site.pp
7761acb (#5221) Add test for fix to fileset with trailing separator
357514c (#5221) Fix fileset path absoluteness checking with trailing slash
f8941b8 (#4769) Fix negative timeout support for newer rubies
a29c7fd Fixed #6562 - Minor kick documentation fix
df20513 (#6658) Propagate ENC connection errors to the agent
08115c0 (#4884) Remove typo from spec test
f2c771b (#4884) Modify tests to pass on non-OS X systems
ec1aa19 (#4884) Revise new exec tests, add a few more
196294a (4576) - if ENC declares invalid class, it is logged at warning.
0d2d6f3 (#4884) Add an shell provider for execs
d2e911a (#4884) Fix Test::Unit exec tests
fa0cfc6 (#4884) Break the exec type out to have a posix provider
c86a980 (#4884) Add consistent path validation and behavior
77fbf7f (#4884) Add expand_path to requiring the spec_helper
7ec9057 (#4884) Autorequire shared behaviors and method to silence warnings
acc99ba (#4884) Fix whitespace
6a4d291 (#4884) Get rid of open3 require since it wasn't being used
3e7ebbb Fixed #6554 - Missing $haveftool if/else conditional in install.rb breaking Ruby 1.9
fddc165 (#5814) Improved cron type specs
f2dfee6 (#5814) cron_spec shouldn't depend on cron provider

2.6.7
=====
17f673d Updated CHANGELOG for 2.6.7rc1
852fb97 (#5073) Download plugins even if you're filtering on tags
4f34dbf Fix #5610: Prevent unnecessary RAL lookups
9781032 Revert "Merge branch 'ticket/2.6.x/5605' of git://github.com/stschulte/puppet into 2.6.next"
25926d1 (#6723) Fix withenv environment restoration bug
093f162 (#6689) Remove extraneous include of Puppet::Util in InventoryActiveRecord
4c19299 Remove extra trailing whitespace from lib/puppet/resource.rb
ff9e242 (#5428) More fully "stub" Puppet::Resource::Reference for use with storedconfigs
0262633 (#6707) Fix typo in rest_authconfig.rb
8858e40 (#6689) Make inventory_active_record terminus search quickly
285c4cc (#5392) Give a better error when realizing a non-existant resource
cd5deda (#2645) Adding a less-stubby test to verify the "system" attribute's behavior
531e258 maint: Remove serialization of InventoryFact values
3489412 maint: Rename InventoryHost to InventoryNode
4bd5493 Fixed #2645 - Added support for creating system users
a3f2357 maint: Remove spec run noise
7764412 maint:Refactor of mount provider integration tests
880d0c6 (#6338) Support searching on metadata in InventoryActiveRecord terminus
f836366 (#6338) Implement search for InventoryActiveRecord facts terminus
8ce30c8 (#6338) Add an InventoryActiveRecord terminus for Facts
1ef83cb Added integration tests for the mount provider
64440e5 (#6513) Propagate the environment when doing variable lookup in settings
92dffb2 (#6513) Adjust P::U::Settings test name to reflect what it tests
5ef1031 (#6632) Adding a new mount no longer causes error with umount
bd5517d Adjust Darwin mount provider tests to pass on Linux
9d2fceb Maint: Begin adding integration tests for the mount provider
23d1c03 Maint: Added the ability to replace the behavior of Puppet::Util.execute with an arbitrary code block for ease in spec testing.
455a891 (#5794) create reports directory when creating host specific directory
1b1e803 (5724) Prep for deprecation of DESTDIR
f4a0af1 Refactoring duplicate code and logic in prep for DESTDIR deprecation.
7a00d6b (#6606) Inline docs: Document all autorequire relationships
e3aec14 (#5148) Fix failing spec due to timezone
8bd80a9 (#5148) Add support for PSON to facts
c3baa28 (#6338) Remove inventory indirection, and move to facts indirection
6c53eb3 (#6445) Fix inline docs: puppet agent does not accept --mkusers
4e29f43 (#6541) maint: whitespace cleanup on the file integration spec
b907ba3 (#6541) Fix content with checksum truncation bug
422399b (#5466) Write specs for output of puppet resource
8cc390c (#5466) Monkey patch Symbol so that you can sort them
24eacb7 (#5466) Fixed puppet resource bug with trailing ,
743e039 (#4922) Don't truncate remotely-sourced files on 404
bb69011 (#6338) Remove unused version control tags
e2a5085 Maint: Align tabs in a code block in the Augeas type.
65a5496 (#6509) Inline docs: Fix erroneous code block in directoryservice provider for computer type
ea9f1f0 Maint: Rewrite comments about symlinks to reflect best practice.
94f8ead (#6509) Inline docs: Fix broken lists in Launchd provider.
c80a77d (#6509) Inline docs: Fix broken code blocks in zpool type
27863c3 (#6509) Inline docs: Fix code blocks in service type.
f4034f7 (#6509) Inline docs: fix broken code blocks in schedule.rb.
6f6c4b5 (#6509) Inline docs: Fix broken code block in file type (content attribute)
a949a83 Revert "(#6309) Ensure the correct device is mounted when managing mounts"
23a510a (#4914) Improved stubbing in mount/parsed_spec tests.
ac2262d (#3999) Allow disabling of default SELinux context detection for files
23eb77d (#6322) --noop should not suppress error codes
439115e (#6499) Make puppet respond identically to -h and --help
23b7119 Maint: Add an assertion mechanism to Puppet
e3dfe41 (#6418) Recursive files shouldn't be audited
0e9858f (#6407) Fix spec test hang with Mocha >= 0.9.11 in zlib testing
309b932 (#5552) Display help when no subcommand is given.
de6a205 (#5552) Clean up subcommand handling inside puppet cert.
bb31c3d (#6376) Add test case for facts find request
2ecf913 Revert "(#5935) Allow functions to accept negated values"
c57c508 (#4914) Improved parsed_spec for mount
ec33a09 (#4914) Remove mount specs
e854205 Remove pending tests from parsed mount provider
6cb365a (#6309) Ensure the correct device is mounted when managing mounts
d1f1858 (#6376) Add support and testing for _search GET requests
3b41d44 Clean up whitespace, and commented out code in parsed mount provider
a7cebf8 (#6337) Fix Ruby warning on 1.8.6 about "future compatibility"
8a48560 (#5150) Make fact REST terminus configurable to connect to inventory service
e6870f6 (#5166) Inventory service is now searchable by timestamp.
2d2f9ab Maint: backport timestamp accessor for facts from 2.7 branch
fa0ed63 Refactored Puppet::Node::Inventory::Yaml tests in preparation for adding freshness check
67f24e4 Refactor Puppet::Node::Inventory::Yaml in preparation for adding freshness
23fc4db (#5132) Provide a query REST interface for inventory
e3c59df (#5935) Allow functions to accept negated values
7cb884e (#6346) Move the trap calls onto Signal so they're easier to stub
b5bae9f (#6331) Remove final special :trac: link from the file content property
4d25d90 (#6331) Inline documentation: Fix rotted links pointing at the Trac wiki
b25d9e4 maint: make rspec exit with status 1 when there are failures
5c26f68 (#5516) Rebuild parser.rb after merge.
e512e3e (#5977) fix spec test failure when new applications are introduced.
b5b5923 misc: ast_context has two arguments, not one.
414e3a5 Fix #5516 - Hashes can't be used in selectors
c373b62 Fix #6269 - Hashes only work with two levels of access
9090507 Fix #6267 - puppetdoc embedded links to puppet entities are not hyperlinked
b4a171e Fix #5720 - puppetdoc misses some class comments
cfa0c32 Fix #6281 - Make sure puppetdoc analyzes all files
48bc7d0 Fix #6280 - puppetdoc crashing on string interpolation
0b7faa6 (#6270) Fix formatting in split function's doc string
637e139 (#6270) Fix formatting in regsubst function's doc string
e9ee621 (6130) Change header level on metaparameter reference
d6e4ffe (#4914) Specs for mounted? match new behaviour
f534470 (#4914) Add specs for modified mount provider
b753038 (#4914) Add specs for modified mount type
9f40608 (#4914) Update property blocks
fd111f2 (#4914) Query property_hash for mountstate
2884660 (#4914) Prefetch mountstate
ade951a (#4914) Join lines for better readability
8b98526 (#5662) Fixed tests that didnt stub key_attributes
02b3111 (#5605) Prefetch doesnt work with composite keys
2a0c970 (#5662) Parsedfile doesnt work with mult keyattr
35dd070 (#5661) Creating types dont work with >1 namevar

2.6.6
=====
d24e32a Update CHANGELOG and version for 2.6.6rc1
7c2a980 (#6541) Fix content with checksum truncation bug
63e911f (#6418) Recursive files shouldn't be audited

2.6.5
=====
30fa41d Updated CHANGELOG for 2.6.5rc5
b481321 (#6337) Fix Ruby warning on 1.8.6 about "future compatibility"
dcce45c (#6353) Restore the ability to store paths in the filebucket
0450197 (#6126) Puppet inspect now reports status after run completes.
960890f (#6364) Adjust mis-translated regex in mount provider for AIX
9e0f9c5 Updated CHANGELOG for 2.6.5rc4
664ef67 (#3646) Fix the documentation fix for `puppet apply --apply`
4b6519a Updated CHANGELOG for 2.6.5rc3
7ef2fbf Updated fix for #3646 - apply / compile documentation
193016d (#5977) fix spec test failure when new applications are introduced.
c08fc1b Updated CHANGELOG for 2.6.5rc2
1f89906 (#6257) Speed up PUT and POST requests under rack
70a43c4 Updated CHANGELOG and version for 2.6.5rc1
f108f03 (#6018) Nick F's --help text for puppet inspect.
04ea826 (#5823) document the not-an-API status of set_run_mode
4ff5769 (#5823) run mode can now be set dynamically...
bddfa1e (6114) Update the audit metaparameter for 2.6.5.
ac8d316 Fix for #5755 -- making zaml serialization robust over projected objects
c912a2a (#4139) hook log autoflush into global defaults
f9e2e2b Augmentation of tests for prior commit
392504a Fix to fix for #5755 -- backref serialization issues in zaml
a732a15 Fixed #5564 - Added some more fqdn_rand documentation
f279f2c Fixed #4968 - Updated list of options turned on by --test in documentation
ce5a2bf (#5061) - allow special hostclass/define variables to be evaluated as defaults.
fd73874 (#6107) Fix an error when auditing a file with empty content
530496b Remove already initialized constant warning from file_spec.rb tests
76788f8 (#5566) Treat source only File checksums as syntax errors when used with content
d657292 Rename variable used in File type validation to be more clear
3398139 Remove invalid "timestamp" and "time", and add missing "ctime" File checksum types.
6c93eb2 Remove order dependency when specifying source and checksum on File type
3a125d4 Bug #5755 -- ZAML generates extra newline in some hash backreferences.
50c12e5 bug #5681 -- code fix to handle AIX mount output
139760b Bug #5681 -- parse AIX mount command output.
2f74d83 Spec for #5681 to allow parsing of AIX mount output in mount provider
878f266 Fixed #6091 - Changed POSIX path matching to allow multiple leading slashes
eb97aa5 Bug #6091 -- test leading double-slash in filenames are allowed.
1bfc9a0 Fixed #6071 - Fixed typo and improved exec path error message
c50a48e Fixed #6061 - Allowed -1 as password min/max age
bf44e72 Bug #6061 -- verify that negative {min,max}_password_age are accepted.
af1c1fe Feature #5855 -- fix withenv call in freebsd package provider
d871641 Feature #5855 -- undefined method 'withenv' in FreeBSD package provider.
f1ab588 Fixed #6009 - nested member list vs directory service group provider
86a2a00 (#5944) Remove documentation of define() when used on nodes, as it is not a supported use of this function.
2b9f653 (#5944) Further edits of inline defined() documentation.
5d108e8 (#5944) Improve documentation of defined() function
7d38ab2 (#5594) Update documentation of exec resource type.
67e1bba (#5931) Prevent errors when calling insync? on audited properties
0f9d236 Maint: Removed dead code from resource harness.
0765afb Maint: Rename misleading insync? method in file provider
0084b08 (#5548) Specify return values of manual status commands in service type description.
dd332f6 Fixed #6002 - Added note about function execution
3cfbd07 (#5045) Cleaning up some tests and code
a2036ea (#5045) External node classifiers should be able to specify params for classes
18ca97b (#5045) Adds support to resource/type to also accept a param hash
70630b9 Fix #3165 Ralsh (bin/puppet resource) can't manage files
1fd3600 Fixed #3646 - Added documentation for compile and apply to man page
ae48634 Fixed #5914 Removed genconfig = true from genconfig output
7e7f342 Fixed #1657 - Added note about target file
069f29b Fixed #2096 - clarified option modification and tested it is working
66b442b Fixes #5916 - Cleanup of unused doc methods and documentation
9b74968 Modified rubydoc in lib/puppet/util/command_line/puppetca to fix inaccurate description of --clean.
e58f5dc Fixed #5742 - Removed legacy fqdn option from documentation
4d1b51f Fixed #5167 - misleading documentation in the defaults of [main]
c1b5c7f (#5913) Fix Puppet::Application.find constant lookup behavior
7b3b56e (5977) Puppet::Applications can be loaded from multiple paths.
f9bfb96 (#5900) Include ResourceStatus#failed in serialized reports
79b6332 (#5882) Added error-handling for bucketing files in puppet inspect
17843d5 (#5882) Added error-handling to puppet inspect when auditing
1a6fab2 (#5171) Made "puppet inspect" upload audited files to a file bucket
a7cd185 Prep for #5171: Added a missing require to inspect application.
71ac9cf Locked Puppet license to GPLv2
abc6256 (#5838) Support paths as part of file bucket requests.
002f9f1 (#5838) Improve the quality of file bucket specs.
94d7179 (#5838) Make file bucket dipper efficient when saving a file that already exists
89f5692 (#5838) Implemented the "head" method for FileBucketFile::File terminus.
9cfd3d5 (#5838) Reworked file dipper spec to perform less stubbing.
c514c64 (#5838) Added support for HEAD requests to the indirector.
2b9b7a5 (#5838) Refactored error handling logic into find_in_cache.
08561b2 (#5838) Refactored Puppet::Network::Rights#fail_on_deny
87c5c30 (#5910) Improved logging when declared classes cannot be found:
4efc98a maint: Remove unused Rakefile in spec directory
a002231 (#5171) Made filebucket able to perform diffs
8f314f2 (#5710) Removed unnecessary calls to insync?
e270086 Prep for fixing #5710: Refactor stub provider in resource harness spec
c57a677 Maint: test partial resource failure
8aa8b9d (#5799) Simplify report dir creation
2d88844 maint: Add vim swap files to .gitignore
3d3baec maint: Remove rspec options from the Rakefile
df65304 maint: Inspect reports should have audited = true on events
4c9eca1 Maint: Added "skipped" to the YAML output for Puppet::Resource::Status
717670f (#5771): Fix spec failures associated with rspec upgrade
52760a4 (#5771) Upgrade rspec to version 2
7603b05 maint: remove stray debug statement.
7661ba8 maint: Prune #inspect methods on various objects
80bfb54 (#5758) Verify that report events are correctly created
de85f8d Prep work for #5758: set audited=true on all audit events
e162da9 Prep work for #5758: clean up initializer for Puppet::Transaction::Event
06a8d1e Fix #5698 puppet inspect shouldn't report of attributes of deleted files
1f72c31 (#5715) Added attributes resource_type and title to Puppet::Resource::Status.
a6cd736 (#5715) Removed attribute source_description from the YAML representation of Puppet::Resource::Status.
98db2da (#5715) Removed unnecessary attributes from YAML of Puppet::Transaction::Event.
bd4a8a1 (#5715) Make certain report attributes always present.
716ee1c (#5715) Changed the type of metric names to always be strings.
037eac4 (#5715) Add status attribute to reports.
e4a2e04 (#5715) Made the report "calculate" methods strictly functional.
71db5be (#5715) Made the changes/total and events/total metrics always present
a4e40f4 (#5715) Refactor in preparation for adding a status attribute to reports.
15dda94 (#5715) Added total time to inspect reports and made inspect metrics more consistent.
d1bcdec (#5715) Removed Puppet::Transaction::Report#external_times from YAML output.
1550bbb (#5715) Added total time metric to apply reports.
4cc42cd (#5715) Removed redundant attribute Transaction::Event#version
1907650 (#5715) Removed redundant attribute Resource::Status#version
e596a57 (#5715) Removed Puppet::Util::Log#version.
908e0e0 (#5715) Removed the unused attribute Puppet::Transaction::Event#node
0e39ec5 (#5715) Removed Resource::Status#skipped_reason.  It was never used.
b765f0e (#5715) Prep work: Fixed add_statuses in report_spec.
8631709 (#5723) Fix failing type/package specs
76fe2b3 Implement #5168 and #5169 ctime and mtime are properties
d11ae78 [3782] Test isolation problem in test/ral/providers/cron/crontab.rb
4d3030c Modified the behavior of Puppet::Resource::Status as follows:
7fff780 (#5408) Reworked ResourceHarness so that code is clearer and all behaviors are tested
d516f63 (#5493) Add report_format, puppet_version, and configuration_version to Reports
093c45f (#5375) Rework puppet apply to use configurer.run
e99a3ea Fix #5566 none, mtime, and ctime checksum types can write file contents
d74e8e1 maint: Fix ActiveRecord confine issue
6daeb16 maint: Fix a test that was missing a require
5db696b maint: Fix tests that don't run on their own
7f4e058 (#4487) Fix environment column in hosts table
3ac50fa maint: restore plugin handler safety
f38c36c (#5408) Attributes can be both audited and managed
54a1025 maint: missing stub
1d3192e maint: missing stub
1aa8157 maint: missing line and filename stubs
5e5ee97 maint: Fully stub partially stubbed test.
3d7c8d0 maint: remove Puppet.settings stubs
52fba89 maint: test was expecting Catalog.find too few times
8c134b6 maint: broken test not failing due to over-eager exception catching
3e59277 Fix #1757 Change file mode representation to octal
84bf02e Bug #5423: This moves the home directory property before the uid property, thus minimizing room for damage when usermod is in use.
1131ad7 (#4943) Add puppet inspect application
e005cc7 maint: Remove bogus mongrel test
c908fdb (#5261) Fix #5261 Don't escape Unicode characters in PSON
b27e9b4 [#5081] Revert "Fix #4349 - Parsing with ignoreimport=true was always loading site.pp"
af6e08c (#5304) Use internal_name rather than real_name for maillist provider

2.6.4
=====
76890a5  Revert "(#5304) Use internal_name rather than real_name for maillist provider"
19f3879  Disable remote ralsh by default
eee1a9c  (#5424) Ship auth.conf as part of installing from source
779fea8  (#5304) Use internal_name rather than real_name for maillist provider
83f878e  Renamed Reductive to Puppet

2.6.3
=====
53bb805  Incremented CHANGELOG for 2.6.3
184733c  [#5322] (#5322) Remove spec file that adds little value and causes failures
178c2a6  Fix test failures that fixing #4726 exposed.
74b6c09  (#4726) Fix RRD legacy support
8662056  Fix for #4279 -- mount detection on HP-UX
fbb096a  Fix for #5055 -- adding to_sym to Puppet::Node::Environment
b2ff6a5  Fix for #5298 -- Collections need to do type lookup
1ce00dc  Step towards [5298] -- cleanup indentation, etc. in AST::Collection
722608b  Fixed #5287 - Schedule documentation is incorrect
c8b6fb5  Fixed #5296 - test warnings messages
d221c05  (#5297) Fix schedule tests that were missing stubs for Time.now
f2fd0d1  Fix for #5273 -- user resource constantly resetting password age
544dcf8  Fix #5289 -- Bad copy/paste changes message on test failure

2.6.3rc3
========
126681f  Updated CHANGELOG for 2.6.3rc3
b15231d  Fix for #4299 -- Don't require which
ea435a4  Fix #5020 - Prefer finding node name from REST uri over certname
a097b93  Fix for #4894 -- retry tests if port is in use
ee61b4e  Fix for #4955 -- Race condition & memory leak in Puppet::Util
f57425d  Fix #4921 - race condition in Parser Functions creation
9604f1c  Fix #5252 - line number mis-attribution during parsing
cc5224c  Maint. fix for test broken by 00eedac5
5f7d0fb  Fix for #2568 -- Add a dbconnections option to set AR pool size
ba4d22b  Maint.  Removing code for which no CLA has been signed
4a3d5d7  Reimplementation of functionality removed by prior commit
235d641  Refactor for CLA
9ba0c8a  Fix #4923 - close process race when truncating existing file
cb16d3d  Puppet-load: better and safer error reporting
1d26742  Fix #5023 - puppet-load multiple nodes support
00eedac  capture stderr from exec resources
4cbceab  (#4573) FreeBSD service provider now supports versions <7 and >8
06c8748  Fix #3808 - puppetdoc should use --force-update only if RDoc supports it
6e6712b  [#4813] Remove dead code from puppet/rails/host.rb
956296a  Fix #4911 - Do not generate doc for standard RDoc parser generated object
4fa24bb  Fix #5127 - error when accessing array elements
abb8c66  (#5242) Fix schedule specs that fail near daylight savings
ec667fd  Kludge for #5206 -- port of fix for #3536 to yaml
9a3b584  (#5062) Add envpuppet helper script to ext/
aad7008  [#5225] Fix spec failure that depended on time change
21db472  (#5233) Randomize tmp dir paths

2.6.3rc2
========
244213c  Updated CHANGELOG for 2.6.3rc2
76ac1f8  Fixed #5112 - Launchd Service broke in 2.6.2 with OS X 10.4 Clients.
776ea2a  Fixed #5137 - Removed no longer required TOC references
31118fe  Kludge for #5048 -- serialization compatibility with 0.25.x
65ef24e  (#4534/#4778) -- Normalize parameterized classes
3b53bfc  Fix for #5022 -- Escaped newlines should be elided

2.6.3rc1
========
e3fc5b9  Updated CHANGELOG and version for 2.6.3rc1
3c56705  Fix for #4832 -- Making PSON handle arbitrary binary data
e232770  Minimal fix for #4975 -- only call chage when managing password age rules
a090e86  Fix for #4963 -- Use correct commands for password expiry on solaris

2.6.2
=====
295c3be  Updated CHANGELOG for 2.6.2
1d719be  Fix for #4945 -- explicitly check os to supress man page installation
55417bc  Reversion of 021d534482dd8edb863cb77d668ac3525362a0a6
a6e2bea  Fixed #4919 - added parenths to fix error message:

2.6.2rc1
========
917c520  Incremented version to 2.6.2
900eae4  Updated CHANGELOG for 2.6.2rc1
1b6094d  Fixed documentation typo
bdf12fe  Fix for #4896 -- stray newline left over from removed diagnostic
e7424c6  (#4772) Update SuSE .spec file
0aaa742  Fixes #4792 (Duplicate definition since 2.6.1 upgrade)
ea49d13  Improvement to #4025: made spec tests work on all platforms
0b4ce08  Adds #3046 - support for password min/max age
e9f9d26  [#4783] (#4783) Fix RRDGraph report generation
34f87cf  Add user account expiry to the useradd type and provider
a7fb9b1  Fixed #4025 (failure in launchd if certain plists are binary).
2573872  Fix for #4649 -- avoid unsupported features on non-posix systems
eb9279c  Fix for 4273 -- revert b7e2580ab49ecdb67fc9b522829c005fc3750fbe
53a2bea  Fix for #4804 -- escaped backslashes in interpolated strings
d12e477  Fixes #4863 (Missing "require 'webrick'" causes nondeterministic spec failures)
574812e  (#4860) Add regression tests that would have caught bad params method
68947e7  (#4860) Fix wrong method name.. params seems to be renamed to parameters
021359b  Fix for #4644: install.rb works properly on Windows
d057b90  Fix #4726 Update puppet rrdtool metric code to support modern rrd ruby bindings
66cf3a9  Fix #4226 - Prepend 'Puppet CA: ' to fqdn for default root ca_name
d54352a  Port Puppet::SSLCertificates::CA test to rspec
effc6b8  Fixes #4852 - error messages involving Whits now mention Classes instead
3f99bd7  Fix #4267 - Create a backup before dropping permissions
6468f4e  (#4763) Don't call a method that was removed in Rails 3 activerecord
79d5fde  Fixed #4763 - Hardcoded ActiveRecord version
4798df3  Fixes #4822 -- Puppet doc -o option broken
99c1019  [#4798] Puppet doc manifests documentation mode broken
8cd1540  [#4692] undefined variables cause :undef to be passed to functions
06bf566  [#4787] Missing require causing failure
bba04e0  Fix for #4746 -- Newline goes at the _end_ of the line
9e17c25  Fix #4743: Allow the audit meta-parameter to accept both 'all', and :all
f950061  [#4716] ResourceTypeAPI exposes implementation details that are likely to change
8ff4b9a  Fixed #4819 - corrected cron documentation
2b50f30  [#4771] Import of manifests with the same name only happens once
7b8cb74  Fix for #4708 - tagmail should allow . in tagname
6f229ee  Minimal fix for #4631 -- set implicit classes as in 0.25.x
021d534  Fixed #3707 - rpm, like dpkg-query exits 1 if the package is not installed.  Returning nil in this provider had the effect that on every run, puppet would end up calling yum erase .  Returning the correct data structure resolves this.
216f663  Fixed Puppet Doc TOC generation
c3cb57c  Fixed versioncmp function typo
898a170  Fixed Reductive references in LICENSE file
996f14e  Documentation updates for Markdown conversion

2.6.1
=====
cad1e0f  Updated CHANGELOG for 2.6.1
14f871d  [#4756] addendum for #4756
9bdfe69  Fix for Bug #4756 - Providers no longer respect missing features Restored deleted lines from type.rb and reinstated unit tests
14b3340  Fix for #4736 -- preserve case of defined resources
bd973a2  Fix for #4637 --use of namevar missed in refactor

2.6.1rc4
========
efa834a  Updated CHANGELOG for 2.6.1rc4
763e7cb  Minimal fix for #4691 -- class name uppercased in $name
4a9c857  Fix for #4693 -- implicit stages should never be serialized
fa4d32c  Fix for #4646 -- Missing stub
4d55c6e  Fix for tests broken by fix for #4489 -- stub standalone
b397b69  Fix for #4489 -- apply was using the rest terminus
e91a8cc  [#4462] uncaught Timeout::Error
4d36a51  Fixed alias metaparam docs error
b063635  Skip apt-listbugs and apt-listchanges when installing from puppet
e860907  [#4660] Avoid passing rake and autotest args to puppet tests
419e007  Fixed #4706 - logcheck patterns
f6c0265  Fixed queue require for #4555
07d0be4  [#4308] Remove puppettest from specs
9e69616  Fixed RSpec warning messages
8d24861  Fixed #4100 - Added http_caching to yumrepo type
8cd266e  Added cost parameter to the yumrepo type
0056d41  Fixed extlookup documentation and spacing
e783a16  Fix for #4506 -- too much data being serialized
f59cfc8  Fixed terminus example documentation
690465e  Fix #4615 - vim highlighting fails on slashes and colons.
078e4fd  Updated man pages
7548c65  Updated Man page generation since move to Markdown

2.6.1rc3
========
8be1929  Updated CHANGELOG for 2.6.1rc3
81a2725  Fix for #4456 -- need to accept some mime-type aliases
c318558  Fix for #4489 -- apply was using the rest terminus
491c31d  Fix for #4542 -- included classes weren't assigned proper stages
302d657  Fix for #4501 -- reports not generated in standalone
1ea4ccf  Start server before agent
4c28079  [#4555] puppet queue tries to call code it hasn't required
d1150e0  fix #4528 - treat * as absent
20f4b90  Fix for #4518 -- classes not getting added to compiler.classes
57bb06b  [#4545] Remove obsolete 'trac' specs
82b4f04  Maint. -- Fix test failures broken by previous commit
0c30754  Maint.  Removing code at the request of the original author
3df0490  [#4298] Puppet apply prints an error if the file to apply doesn't exist
5d4f222  Fixed #4527 correctly for 2.6.1
1b3d782  Updated config.ru example for 2.6.1

2.6.1rc2
========
0aa27b5  Updated for 2.6.1rc2
252c9b8  Further RST to Markdown fixes for types, values, tests
1157e8d  Updated all types to Markdown output
fef8800  Updated reference output to generate valid Markdown
79e0a2e  Reformatting documentation from RST to MarkDown (#4509) Signed-off-by: Jes Fraser <jes@gadget.geek.nz>
62435e5  Rewrote functions documentation to Markdown
e4b2aa6  Removed legacy Trac code
8ddea2a  Maint.  Passenger fix broke a test
f43e87b  Fix for #4476 -- rails calling yaml internals
a23d80a  Fixes #4485 -- single quoted strings should not treat \n as new line
8e31b52  Passenger needs HTTP headers values to be string
037bb32  [#4404] Remove requirement for source on Parser::Resource::Param
0e4bc62  [#4364] Fix failing spec due to incorrect loglevel
3a6ca54  Fix #4458 - Do not dump the whole environment when instances can't be found
d909827  Fix for #4465 -- earlier "feature" patch broke ldap
47005aa  Maint -- tests need to respect RFC-952
6aac8f0  [#4467] Make Puppet Master respect facts_terminus settings
1cba9a7  added md5 support as requested in http://serverfault.com/questions/166199/puppet-md5-sum-of-string
1dfd2b6  [#4381] extlookup shouldn't trigger reparses of .pp files
be2b1f3  [#4370] Fixes extlookup precedence getting overwritten between runs
03808fd  Fixed #4364 - Reduced audit msg from info to debug
539b57c  [#4347] run_mode was colliding with --mode for "puppet doc"
1faebdd  [#4423] repair parameterized class instantiation
37568bd  [#4423] class { shouldn't get stored on the namespace stack
449315a  [#4397]+[#4344] Move type-name resolution out of Puppet::Resource into the AST resources.
daa801b  [#4344] Temporary fix to stop agent from importing modules
00ebf01  [#4344] Fix for failing templates when module name matches file in local dir.
e32320e  [#4336] "reportdir" was in the wrong section
0f9672a  Fixed #4311 - Typo in defaults.rb
f54d843  Fix #4461 - attempt to fix another performance issue
2c21fae  Fix for #4300 Solaris svc files need new pid filenames
83c2419  [#4284] Fix failing specs run as root due to missing puppet group
8237f68  [#4242] Fixed (removed) a broken unit test
d5ad0fb  Removed eventual documentation line ... eventually came
871e6fd  Fixed #4368 - Updated clean stored configs ext script for new config sections
cb64477  Updated version to 2.6.1

2.6.1rc1
========
ecf44e4  Updated CHANGELOG for 2.6.1rc1
bdfcac5  Update Red Hat spec file for 2.6.0
9f08e7c  Feature: puppet-load - a tool to stress-test master compilation
ef9a4a6  Fix #4245 - default insertion of ACL is not thread safe
4065e81  Fix race condition in rack autoloading of request/response
3163932  Fix #4244 - Cached Attributes is not thread safe
7d42f77  JRuby doesn't implement Process.maxgroups
760e418  Fix #4349 - Parsing with ignoreimport=true was always loading site.pp
67bdf89  Fix #4348 - Puppet doc single manifest broken
13c71b9  extlookup() is a builtin
d38e522  [#4333] old optparse doesn't support default_argv=
86b0882  Fixed #4326 - Updated SUSE packaging
03313b8  Fix #4319 - source file url sent to the master is invalid
ac3a0d2  vim: highlight default parameters in definition/classes
be2141a  vim: match collected resources.
c047c8d  vim: added elsif
9569136  Fix for 4314 -- Need to allow '-' in class name for refs
636079f  Fixed #4304 - Changed logging level for auto import message
000fd1e  Fix for #4303 -- reverting to old escaping in '-strings
1d494a3  Tweak to fix for #4302--dangling ref to known_resource_types
2383050  Fix #4302 - Compilation speed regression compared to 2.6
63ec207  Minimal fix for #4297, with notes for follow-up
7ad7eb1  Fix #4286 - rename puppetdoc global module <site> to __site__
28bb195  Fixed yumrepo type deprecation wanring `
067a46d  Temporary tweak to tests for #4242
9778f2a  [#4242] Fixed recursion due to parents including their children
59a23d6  Fix for #3382 -- Empty classes as graph placeholders
865282a  Fixed example config.ru
a0a63c3  Fixed network and indirection reference
64386cf  Fixed Indirection reference

2.6.0
=====
db0b30d  Updated CHANGELOG for 2.6.0
42a475e  Fixing #4268 - manifests always imported
06fc40c  [#4269] Undef variables interpolate to empty string
1288f8c  [#4270] Force inherited classes to load into the correct environment
539d716  [#4287] Fix the undefined evaluate_match error when comparing functions
d2da1d4  Tweak to tweak to fix for #4233 -- ":" is valid in type names
bbc07f2  Bandaid for #4285 -- :name vs <namevar>
40e6f02  Tweak to fix for #4233 -- only accept word chars in types

2.6.0rc4
========
d87a2e3  Updated CHANGELOG for 2.6.0RC4
cf597d7  [#4233] Ruby regexps are not multiline by default, but Resource titles can be multiline
d6cbb21  Fix for #4234 -- ruby DSL fails on second resource
4822de3  Fix for #4236 -- Only interpolate $ if followed by a variable
b509032  Fix #4238 - if should match undef as ''
8c8c146  Minimal fix for #4243 -- import isn't thread safe
d319da4  [#4247] storeconfigs was calling Puppet::Parser::Resource.new with the wrong arguments
9f91540  [#4256] External nodes parameters can now be assigned to nodes
680dd1a  Fix for #4257 -- problems resolving ::-prefixed classes
6e07a19  Fix #4262 - Puppetmaster used to log compilation time
5b68afe  Fix for #4255 -- misleading diagnostic message
dd03ac9  Partial fix for #4278 -- the performance aspects
4ce33fd  Fixed #4249 - Updated SUSE packaging specifications
91185c6  New man pages for 2.6.0
1cda7c5  Fixes errant Trac references in documentation

2.6.0rc3
========
f60b6a0  Updated CHANGELOG for 2.6.0rc3
9df87e9  [#4219] Install misses command_line dir, puppet $app --help fails
0422852  conf/redhat: Consistently pass pidfile option to daemon, killproc, and status
63bf037  conf/redhat: Update conf/init files for single binary
f72741f  conf/redhat: Rebase rundir-perms patch
793d7b7  [#4213] -o option for setting onetime now works properly
2edf7fe  [#3656] Serializing arrays of references
27d5a47  [#4215] Have rundir depend on vardir
06cc552  Fix for #4220 -- modules not implicitly loading their init files

2.6.0rc2
========
8747479  Updated CHANGELOG for 2.6.0rc2
fa74020  [#4209] catalog.resources should return resources
f5f9a38  Fix for #4210 -- missing require in CA
1c3e844  Minimal fix for #4205 -- incorrect Import loop messages
99d8323  Fix #4206 - import "path/*" tries to import files twice
a2115af  Alt fix for #4207 -- serialize environments as their names
fe4dcd8  [#4208] Missing parameter breaks multithread compilation

2.6.0rc1
========
e028310  Updated CHANGELOG for 2.6.0rc1
3180b9d  Code smell: Two space indentation
5432259  Code smell: Avoid needless decorations
8f15707  Code smell: Don't restate results directly after assignment
c3e2353  Code smell: Use &&= for dependent initialization
42a5390  Code smell: Use ||= for conditional initialization
a07bbe2  Code smell: Omit needless checks on defined
07b15bf  Code smell: Avoid unneeded blocks
8d1fbe4  Code smell: Avoid explicit returns
889158a  Code smell: Booleans are first class values.
81e283b  Code smell: Line modifiers are preferred to one-line blocks.
e8cf063  Code smell: Use string interpolation
eefccf2  Code smell: English names for special globals rather than line-noise
184132e  Code smell: Use {} for % notation delimiters wherever practical
9ee56f2  Code smell: Inconsistent indentation and related formatting issues
051bd98  Code smell: Miscellaneous oddity removal
77f8599  Code smell: Win32 --> MS_windows
3fbc1d5  Updated GPG rake signing task for new Puppet Labs key
94fa5d5  [#4182] show_diff was broken for streamed file contents
7009704  Fix for #4117 "Storing newly-audited value" messages
9cf9788  Manifests with variables were broken when read from STDIN to puppet apply
835f73c  Use the name in the search path for looking for metadata
5bab997  maint:rename resource_type to define in internal dsl
654b564  [#4198] Require 'fileutils' everywhere FileUtils is used
a07af2b  [#4196] Move the docs into the source directory structure
3c00591  Fix for #4178 - generalize autoloading to include .rb
cea2e5b  [#3582] Remove assumption that Puppet.settings would return values of a consistent type
c58e420  [#4180] Support legacy module structure
b4593f2  Update RDoc parser to reflect change of custom plugin and fact locations
dda165a  Fixed #4180 - Updated old module structure to match correct default
1715f3a  [#2730] mount ensure present shouldn't unmount
a282cc3  Fixed subscribe example
2353115  Fix for environments in startup script. - Dropped the forced --manifest switch in the   suse startup script to allow for environments   to re-define this. Otherwise, environments will   not work as puppet override configuration with   command line arguments.
cfca62b  Redmine: 2474 - Fix for mount fstype documentation
3ff38df  Fix for #4137 -- Oracle needs text for strings > 255
62dbae5  Fix for #2807 Puppet settings available as variables
a5fc364  [#4161] RDoc fails to parse some of our ruby syntax
b7e2580  [#3169] Adds more debugging to SSL cert verification
70af43f  Fix for #4167 -- overriding file permissions in conf file
2c88884  [#4114] Fixes test failures caused by previous 4114 fixes
4a6428b  saving work for my unit tests. The redhat one still fails...
1e0d922  [4123] - allows self.instances to correctly report state of services.
8d3ced5  created init provider method self.get_services which accepts an array of filenames to exclude when processing defpath.
cdd4382  [#4114] Fix failures in the unit tests
e419293  [#4114] Added queueing to the log
4b00c6a  [#4110] Wrap Type#retrieve calls for backwards compatibility
5f8a242  Fix for #4120 No namevar running puppet doc -r type
6ac36eb  [#2370] Allow OpenBSD to add packages with versions and flavors
45a9f37  [#4108] Changed missing Application constant error
a0ea74b  [#4149] Don't create two Resource::TypeCollections
7978be5  [#3906] Fixed missing constant Puppet::Rails when using storeconfigs
fb6f2aa  [#4136] Specs should listen on localhost
6d4be90  [#3961] Part two: --destroy should also be local
0598f35  Fix for #4148 (2.6 is greater than 0.25.x)
5971898  Fix for #4142 stray use of JSON instead of PSON
74e5bdc  [#3172] Fix the arguments to Application::Kick.new, which I had broken
4f06e9e  Maint: Explicitly put test sqlite files in a temp directory
84a9412  maint: fix stub failure in report_spec.rb
1f48d68  maint: fix stub failures in report_spec.rb
bee843a  maint: fix stubbing in package_spec.rb
528b915  maint: fix stubs in transaction_spec.rb
37277a5  maint: fix stubbing in catalog_spec.rb
ea55e83  Maint: Improve the speed of setting settings.
7c7f6da  maint: file_spec heisenbugs
d6d726b  Heisenbug: settings as catalog trying to create directories
e579aab  maint: spec_helper should reset settings directories on *every* test
298a764  maint: Remove a heisentest that wasn't testing what it claimed
b389392  maint: spec_helper should only get loaded once
3304068  maint: :mutable_defaults to improve spec consistency
08b49c6  [#4090] Fix the run_mode for certs and put tests on the applications to assert their run_mode
e318db6  [#4059] fix the specs to correctly mock the Puppet::Resource.new call signature
ab3d27c  [#4059] Minor errors preventing ralsh from running
59bf5e4  [#2713] Enable ELSIF
ebd0311  [#3172] puppet kick can take hostnames as bare arguments
697508d  [#4108] Missing constants fail deliberately and with a message
2639a56  [#4092] Changed notify message to defined instead of changed
223157d  Fix for #4091 -- require loop in executables
174e02a  [#4090] Change how RunMode instances are created so that an object for each RunMode is only created once instead of every time it's called
62e3b61  [#4090] Fix last few tests and renames of mode to run_mode
2a25883  [#4090] Git rid of the idea that run_mode is a configurable option with defaults
75e0662  [#4090] Rename mode (:master, :agent, :user) to run_mode
3cd48d8  [#4089] Replace internal usage of :check with :audit
e848d41  [#3961] puppet cert --generate implies ca_location = :local
255628e  [#3961] Rename cert's @mode to @cert_mode to reduce confusion
b2bd05d  maint:  Confine a test that depends on sqlite
fdc8c35  [#3994-part 3] rename spec tests from *_spec_spec to *_spec.rb
9a94ee2  Fix for test ordering sporadic failure
9ceb454  [#3994-part 2] rename integration tests to *_spec.rb
06dffc1  maint: A test specified that a file wasn't writeable, but was writeable when run as root, which caused the test to fail.  Changing the test so that a directory is in place of the writeable file so not even root can write to it.
2baf74e  maint: Fixes some noisy specs
0aae5a7  maint: Fixing tests that fail when run as root
0fa10a6  Cleaning up various warnings in specs
2ab123f  Removing obsolete nodescope concept
153d7cd  Fix #3665 - part 2, node inheritance fixes
dd4fa66  Fix failing tests in spec/unit/resources/type.rb
770a8ea  Fix #3665 - main class shouldn't be a subscope of itself
76953d8  maint: Fixes broken order-dependent Tidy specs
9afc67a  Fix for pre 1.8.7 compatibility in namvar patch
d62a391  Breaking require-loop
b4af238  Fix for #3985 typo causing warning
9169ef0  Fix: puppet apply trying to use XMLRPC constant
af41beb  Remove an old test that had been unintentionally reintroduced by a mistake in a conflict resolution
6a8e6fe  Tweak an old test due to new error handling.
5f53bfa  Restore error handling for value=
e817ad1  Fix tests broken by level-violation fix
e5478d4  Simplify the newattr method by removing a level violation
4ef40b8  maint: Rework testing of Reports http processor to be self contained
edfcbf9  [#3139] Fixed a problem with the value method for parameters
61e978b  [#3139] Fixed a broken integration spec in type tidy
cf9bcad  maint: Fixing test to reflect that host environment assignment now takes an object instead of a string
c70c96b  Fix some tests broken by changing the call to newattr
a72fb14  Fixing oversensitive test
15004f3  maint: Fix failing test that needed more methods stubbed
60932e1  Fixed require warning documentation
6fcb87d  Fixed mcx documentation error
15ae389  Documentation fixes
f95169b  [#4006] Fix test failures caused by reverting ticket 2890
b5572ae  Bug 3731. Applied Fix suggested by Doug Warner to always flatten out the array
117e6b6  maint: Have 'rake spec' output in color
a7e4fe8  [#3810] Do not create a reports settings block
db44a32  Tweak for fix for #1175 to fix test failures
3bd6f11  maint: Fixing a test typo s/stub/stubs/
ebc3e78  maint: Fixing a failing spec by stubbing a method on a stubbed object that should have been stubbed.
3b4d33c  remove tests for removed code
c8089f1  [#2646] Fixes the change to onetime made in b96cd6c
4bf6950  [#3139] Make newattr idempotent
51b70c0  [#3994] rename the specs to have _spec.rb at the end
9958c80  [#4064]  Modify the Rails spec to use the block form of confine
af8bd77  [#4064]  Modify confine to also allow a message and a block containing the test.
182c003  Fixing #3988 - adding support for watchr
3a44f0e  Fix #3932 - Add --charset to puppetdoc for RDoc mode
fb5c1d7  Fix #3907 - Hash couldn't be initialized with an empty hash
9592dd8  Fix #3871 - Add the 'in' operator
3696d95  [#3865] External subcommands
0fc41ae  [#3802] Replace rug with zypper
dc1a977  [#3766] Remove YAML fixups
e0e6b64  Provides #3723. Add ability for execs to have several attempts at a successful execution and fix minor bug with logoutput and returns as an array..
c8ca19a  [#3674] Make sure that failing to load a feature isn't fatal
2a73b5d  [#3674] Part 2: Autoloader load method should propagate failures
7952af5  [#3674] Autoloader should propagate failures
f35c59f  Fix #3667 - Fix class namespace
938fbe9  Removing obsolete nodescope concept
49cf2f2  Fixing #3651 failing to pop comment stack for some constructs
0dd4201  Fixing #3072 - Resource generation is recursive
b96cd6c  Fixes #2646. Move onetime option from the agent to global defaults so we can specify it in the config file.
0a21e1b  [#2522] authorized keys owner is verified
738802e  Fixing #2337 - Adding 'freeze_main' setting
50a626d  Fixing #1545 - Adding 'caller_module_name' variable
5d1934b  Fixing #1545 - module_name is now a variable
bba45f1  [#4055] Confine CouchDB-related specs to the couchdb feature
1c5b67d  [#4055] Refactor of abstract Couch terminus, more specs
432db25  [#4055] Add CouchDB terminus for facts
35636e9  [#3921] Fix typo "fact_terminus" -> "facts_terminus"
45ca669  Targeted fix for #3851
c00285c  [#3810] Add http reports processor and `reporturl` setting
1d49def  [#3804] Fixed one failing spec for RackREST
1e89bff  Fixes #3514 - CR/LF line ending in puppet.conf cause silent failure
e6709da  [#3409] fix test failures from ldap environment patch
a7884b4  [#3409] environment is not checked when nodes are in ldap
c75b219  Fixes #3395 - CR+LF line endings in manifests cause syntax error
8b127b1  [#3388] Setting host_aliases from [] to [] no longer results in any changes
be7112a  Fixing #3139 - all properties can now be audited
986298b  Working #3139 - Adding Settings.clear Spec#after
32f6a9d  Working #3139 - Removing Property#checkable
58cf8d9  Working #3139 - Catalogs default to host_config
8f3e8bb  Working #3139 - ResourceHarness does caching
d6407f4  Working #3139 - removing obsolete checking in Storage
0b95a85  Working #3139 - scheduling moved to resource harness
4627b8f  Improving fix for #1175; tightening thread safety
ccc869e  Part 2 of fix for #1175 (functions in environments)
7c6b883  [#1621] Composite keys for resources
2396eba  Use the 'root' feature rather than directly checking the uid
8128311  fix tests to reflect methods moved from type/file/owner to provider/file/posix
28702a4  variable name error in refactor
19c70b5  Remove over-eager error branch in a complicated If
09881cf  Confine out a lib that puppet was failing to load on non-win32
d72fd9d  Confine out tests that fail on unix
d1b86ec  Behavior change for //UNC_Paths broke an old test
ba506c1  Resolving conflicts with jes5199:ticket/master/2935-settings-mode
f15a324  Fix Exec type
86bd838  Move syslog into a feature
fc92408  Adapt Util::Storage specs and avoid trying to lock on directories
58100ed  Relax path qualification check on FileServing::Fileset
1c016a1  Implement quoting on the exec commands and repair specs
6a92894  Avoid trying to symlink() on windows
47c9dd1  Implement "forking" for Windows
c59d864  Avoid non-win32 signals on win32 runtime
bbba9f9  Avoid trying to set uid/gid on windows
a90bcb0  Start extracting the owner managment for files into providers
b51be28  Expand file type to be able to handle Win32 and UNC paths
17a9ad1  Updated version to 2.6.0
a2e809b  Fixed RSpec deprecation notice in lexer tests
f054d5b  Make specs work on win32
54c4538  Delete tempfiles on win32
97c043f  Fix path handling
f80b4c7  Print stacktraces if requested
1d98e67  Adapt defaults to Win32 environment
ea9bb49  More win32? feature def
1645d8e  Define posix and win32 features
b3aa3ec  Improve error message
d67f60f  Fix ProviderDpkg specs to avoid any real executions
e119b04  Avoid setting the timeout before we know which timeout we should set.
d40e6d4  Bug: tidy specs need FileBucket::Dipper
a6b52bb  Avoid trying to lock on non-files
533ef68  Removing obsolete FCollection stub from Functions
bc90df6  Functions are added to a module instead of Scope
17e40e7  Slightly restructuring "Functions" file
9d0a38e  [#3921] Add facts_terminus setting to Puppet settings
2874729  [#3921] Remove unnecessary require 'puppet/resource'
58a3d27  Fix for #3949 and related
b755f7f  Fixed #3912 - Added client certificate name as an internal fact called "clientcert"
b5f14c6  {#3866] Rename the method metaclass to singleton_class to avoid the deprecation warnings from Rails ActiveSupport
2b5bd49  Fixing #3822 - checksums will be loaded from filebuckets
94390de  foo
3b7aac5  For #3822 - Reducing checksum code duplication
ca7b166  Fixed unsupported perlstyle regex and few other minor bugs
85f2565  Signed-off-by: Ross West <westr@connection.ca>
a4eb5d5  Signed-off-by: Ross West <westr@connection.ca>
970fd87  Fixing #3791 - client environment is used
cce63d8  Bug #3748 LDAP group membership
4ba3dc2  Fixing #2655 - Adding default parameter values to resources
20a74bc  Refactoring tests - replacing stubs with instances
b5db33b  Fix for 3664: interpolating qualified variables.
9ddee72  Fix #3664 - qualified variable parsing in string interpolation
a32381e  Feature #2935 remove misleading comment
5937af4  Feature #2935 Unify the codepaths for setting settings
b7d387e  Feature #2935 Puppet[:mode] and Puppet[:name] are read-only
342298c  Bug: Broken codepath in util/settings
6d5566a  Feature #2935 settings are in Mode sections instead of executable names
9536723  Feature #2935: method extract require_application
c338fef  Feature #2935: Test for if we're "puppet cert"
cbb2802  Code cleanup: remove "self." from setdefaults
37a5530  Feature #2935 Modes: root? predicate
ac7efc8  Feature #2935 Puppet::Mode#master?
5665e39  Feature #2276 Single Executable: Update docstrings
fc29049  feature #2276 Single Executable: use new names for settings sections
631552c  Feature #2935: Applications should declare modes
8f4d644  Feature #2935: lazify require graph for applications
6b26a7c  Feature #2935: Puppet::Mode
b65d1af  Feature #2276 Single Executable: usage message
76304f8  feature #2276 Single Executable: move CommandLine methods
e9627a0  Fixing #2658 - adding backward compatibility for 0.24
61a719f  Adding #2658 - Adding support for run stages
d13f8ac  Fixing #3671 - --compile Catalogs are pretty-printed
89e8745  Fixing #2655 - Adding default parameter values to resources
edcf429  Refactoring tests - replacing stubs with instances
3dfb762  Fixing Catalog conversion
0d4fd60  Fixing #1903 - metaparam inheritance is much faster
047ebfe  Fixing Parser::Resource param validation
2fae0bd  Fixes #1999 - Allows the 'apt' provider to downgrade packages.
b10d35d  Fixes #3745 Catch unhandled exception in ssh_authorized_key provider
584961a  Fixed #3721 - Removed -u option from crontab on HP-UX
a15a70c  Fixing tests broken by conceptual merge conflicts
5988f76  Fixes #3663 - It should be possible to list signed hosts only
2c153b1  Fixing #448 - relationships have their own syntax
052f98f  Fix #3408 - enable puppetd http compression
3eaf69c  Fix for conflict between fileserving streams and none-checksums
2cf7222  Fix #3373 - Client side file streaming
ee5d7f1  Add master side file content streaming
63c122f  Fixing tests broken by Luke's CRL flag patch.
91e6022  Fixes incorrect line in partial CRL fix
379bda0  WIP - trying to fix #3460
3947574  Updated Template documentation link
5fd6e54  Change the main spec to an apply spec
009629f  Feature #2276 Single Executable: usage message
5b64d3b  feature #2276 Single Executable: optparser should get CommandLine#args instead of ARGV
5683fd9  Feature #2276 Single Executable: Pass a commandline object to the application
d038a1d  Refactor #3706 Reify eigenclasses of Applications
7656ba7  feature #2276 Single Executable: CommandLine can be instantiated
63e2e56  feature #2276 Single Executable: subcommand method
b6e2ce6  feature #2276 Single Executable: help info
b073722  feature #2276 Single Executable: help for apply
bfad735  feature #2276 Single Executable: rdoc paths on ubuntu
7103378  feature #2276 Single Executable: legacy settings
54c1cc5  feature #2276 Single Executable: "puppet describe"
c79b228  feature #2276 Single Executable: "puppet kick"
6bdda8c  feature #2276 Single Executable: "puppet cert"
f9783fc  feature #2276 Single Executable: "puppet master"
1d8bd0d  Fix #3552 single executable should display usage
722a27f  Fixes #3702: the 'log' report now sends the host name as the log source again.
ddd40bb  Fix for #3690 failing to calculate error codes
d61a69a  Fixing #3668 - fixed autoloading classes from modules
f66095d  Fix #3656 JSON serialization of dependencies
f0a0084  Fixes #3582 - Adds dbport configuration option for specifying database port
8b99367  Adding indirector support to Resource Types
748aed9  Fix #3552 single executable should display usage
eafde5c  Added support for flat packages in the pkgdmg package provider. Added a test in: ./spec/unit/provider/package/pkgdmg.rb
c9e3d75  Fix: the rcvar name is not necessarily the same as the service name. (More and more I get the feeling that FreeBSD's rc system is totally unsuitable for Puppet. What about porting Upstart or SMF to FreeBSD ... ?)
861c177  Added proper status command
5f72eb9  Re-included old BSD service provider, made new one default for FreeBSD
c3cd24b  Rewrote FreeBSD service provider
1250f80  Fixed documentation issues exposed in #3772
211782f  Updated CHANGELOG for 0.25.5rc3
7c59acf  Renamed all references to Reductive Labs to Puppet Labs
e82f5de  Fix for #3107 Changing users on AIX
44f1465  Fixing #2864 Added support for AIX System Resource Controller (SRC) - service start stop
02ed8db  Fixes #2836. Add hold support to dpkg provider
0f2d3ce  Fixes #1223 Add Zypper support for SuSE machines
a166d50  Fix for #3399 zone type should handle exclusive IP stacks
af521fa  Adding #3518 - basic dot format support
9b2b0ec  Fix #3551 rake spec fails to run integration specs
6a66d5e  Update Red Hat spec file for 0.25.5
46c72bb  Updated CHANGELOG for 0.25.5rc2
ee0cc07  Fixing #3533 - Removing all transaction cleanup
11189fb  Fix for #2910 -- Tidy/matches is too tricky to use
913b63c  Bug #3451: Don't leak the terminus class setting from Puppet::Resource::Catalog's spec
a228399  Fix to the fix for #3295
ae52005  Write ssh_authorized_keys as user
8c5e80e  Fixing bad test
088c801  Fix for #3558 -- source file reading speedup
cd06b87  Fix for #3556 Plussignment value melding
2de7da4  Fixed #3655  - Puppet doesn't find installed packages with portage provider
d20d5de  Fixed #3672 - Error message on duplicate fileserver mounts incorrect
6ae6821  conf/redhat: Add notifempty to logrotate config
7fc66d5  Fixed stored configuration documentation
14456b4  Fixes #3653 - Changed default factpath value to better reflect plugins in modules
f3e466b  Partial fix to #2837 - changed warning message to debug
686239f  Fix #3555 - fix state of purged lists
6f8a1e9  Updated Rake tasks to no longer load puppet.rb
83a8c68  Fix #3540 - name methods correctly
3d395e8  Fixes #3295 - generate() now sets the working directory to the directory containing the specified command.
0f077c7  Added YARD task
b49c60b  Update man pages and partial doc fix to #3491
115f37d  Fixed #3532 - Typo in lib/puppet/ssl/host.rb
784dd26  Updated version and CHANGELOG to 0.25.5rc1
4a6474c  Modify SuSE spec file for 0.25.x and correct shebang lines for puppetd/puppetmasterd
385506f  Fixes #3460 - Makes Puppet FHS compliant by moving /var/puppet to /var/lib/puppet
b494427  Fix for #3101 (bug in MRI 1.8.7)
966b269  Fixes #3419. OS X 10.6 Ruby doesn't set supplementary groups
49be54e  Revert the guts of #2890
e69b7db  Fail gracefully on packages that don't have the HOMEPAGE variable set (e.g. dev-lang/php).
83ac6b8  Fixed #3443 - Typo in mount type
dfe5c3a  Fixes #3135 - darwin doesn't support 'mount -o remount'
2a60e1e  Adding :catalog_terminus setting
626945b  fixing obsolete comment in puppetd
9fbb69f  Adding support for only using cached catalogs
7e1e76e  Refactoring Configurer to enable the next feature
b28e21a  Fixed changelog Rake task
e93eab8  Fix #3155 - prevent error when using two matching regex in cascade
b883272  Fixed puppetlast typo
67bf142  Fixed README contents to reflect Puppet Labs and docs and wiki changes
e35e142  Fixed link typo
d40e24c  Fixed #3384 - Updated broken link
da00f68  Making a Puppet::Module test more resilient
9792915  Fixing yumrepo type to use 'flush'
9ee4c2d  Only trying to retrieve passwords on OS X when root
8c31ebe  Removing obsolete tests
aee9c29  Fixing a warning in the aix package provider
232ad8f  Removing tests for code that was removed in the REST refactor
94fddbc  Fixing and porting Transaction Report tests
13d141a  Fixing Property#change_to_s in rare case failures
66858ef  Fix test in parser.rb due to API change
0f254be  Fixing Hash functionality with non-constant keys
41aeba4  Removing vistigial method in ASTHash
1821187  Porting/removing group test/unit tests
03532e0  Porting a simple set of tests from test/unit
006e6af  Removing obsolete test
1a6e08f  Fixing Transaction integration test
410b71c  Removing invalid File integration test
effa719  Cleaning up content/source code
456447c  Protecting spec_helper chmod from failure
fa64774  Redeleting puppetmasterd integration test
797f412  Making SshAuthorizedKeys tests less brittle
622bb70  Markus's patch concerning string interpolation
23adec5  Fix tests that use or stub find_by_checksum, which I just changed the signature of.
4ac8e2c  The pure-ruby YAML lib doesn't accept parameters
e31fe8c  Fix a failure in new FileBucket where it was impossible to read from a bucket with a non-default path.
3797c7a  Update YAML dir test to match behavior
83d8bda  Fix heisenbug in spec/unit/provider/mount/parsed.rb
dde69c3  Remove test for old RDoc work-around
c5ce824  Fixing various broken Resource::Type tests
6cd6c47  Renaming and fixing puppetrun tests.
a27013a  Fixing calls to "class_scope" in Scope tests
84d6892  Fixing all 'require' function tests
b643413  Removing any mentions of :casesensitive setting
fe140a2  Migrating "puppet" executable integration test
edef647  Fixing 'puppet' to directly run manifests
fff8d04  Fixing syntax warning
7c25317  Moving puppet back to bin
a4d1ba0  Puppet::Parser::AST::Leaf#evaluate_match "insensitive" renamed to "sensitive"
404bdfa  Repair validate_checksum codepath, even though it is disabled.
e895494  Puppet::Parser::Resource.new parameters have changed
94651df  Add stub to Puppet::Parser::Collector test to prevent runaway stub failures
40c1fb0  Resolving conflicts with ???
1059370  Fixing a typo from a regex
3eeebf5  Fixing change printing for content/ensure
47c3ca1  Converted File[checksum] to a parameter not property
44cba9c  Adding "checksum?" helper method to Checksums module
d05d25c  Refactoring File[source] tests somewhat
aab2374  Resolving conflicts with luke:tickets/testing/2954
86cf226  Adding virtual and exported resource support to the DSL
9d5ba41  Cleaning up ResourceAPI tests
9060766  s/DSL::ResourceHelper/DSL::ResourceAPI/g
6d2a10b  Adding simplistic pure ruby interface
e515513  Adding environment support to parser resources
30f49bb  Resolving conflicts with ???
b7015d7  Moving the string interpolation parsing to the parser/lexer
07cfdd0  Resolving conflicts with jesse:feature/master/3394
ad148d6  Resolving conflicts with luke:tickets/master/2759
922cf1a  Resolving conflicts with ???
0d70468  Finishing renaming :params to :parameters internally
ad93d0e  Forcing parent evaluation in resource types
6e4db82  Fixing type/title resource resolution
aa659f2  Converging the Resource classes further
5401a7c  Adding strictness checking to resources
9c867e6  Fixing most of the broken tests in test/
274d1c5  Adding tmpfile cleanup to tests
7089446  Removing Resource::Reference classes
4871c90  Adding support for class parameters
4709e9b  Removing :paramcheck and :typecheck settings
744295d  Allowing Environment.new to take an environment
4f907c6  TypeCollection now supports namespace arrays
2fa0a48  Adding parameter validation to Puppet::Resource
aff5992  Fixing failing Environment unit tests
61636e4  Tuning file load order
7a99a1d  Removing obsolete Settings comments and require
af9a920  Adding an environment helper
c8e89cc  Changing the interface of Puppet::Resource
b7ea180  Partially fixing #2954 - Adding class parameters
cbe2c49  Fixing test structure
4bff506  Indirector/FileBucketFile warnings
0917248  REST: Fix a state leak causing test failures
8f9fc30  REST FileBucket: REST barfs on relative paths
23ccefe  REST: hide Request object
d8e1b27  Feature #3394 REST runner, execution
1603f73  Feature #3394 REST Runner, preparation
16658a0  Feature #3383 Part 2: Remove RAL XMLRPC
eda649b  Feature #3383 RAL over REST
09b1412  Fix tests on #3347
e5a7800  Feature #3347 REST-ified FileBucket
f838389  Fix a failing test in #3115
9acd0b2  Feature #3115 REST-ified status()
b581c23  Fix #3229 - use original value in case/selector regex matching
490a03d  Cleaning up a test.
576accd  Removing unused Checksum::File terminus
58920a0  Converting File terminus to use formats.
37fd6ae  Fixing datadir defaults to match new standards
bf3359e  Adding client and server data dirs
b41d535  Adding filename extension support to formats.
7504f1e  Resolving conflicts with ???
d0389f4  Renaming Parser::ResourceType to Resource::Type
67ef78d  Removing Interpreter class
b82b4ef  All non-transient parser references are gone
644ad7e  Fixing callers to Parser to only pass environment
9f8e0c0  Using the RTC helper to find the known resource types
1705366  Always warning if autoloading a file fails
7bef2e0  Adding helper module for finding known resource types
804105d  Moving Rails initialization to Compiler terminus
26b272b  Parser now uses Environment resource type collection
cb16908  Adding 'known_resource_types' to Environment
201889b  Renaming LoadedCode to ResourceTypeCollection
2c2b3c2  Storing per-environment LoadedCode instances
6bf1953  Removing old, never-used DSL code
df2d392  Adding support for parsing ruby files
b938edf  Fixing test structure
847233f  Adding []/[]= support to Parser::Resource
6e04fba  Fix for #3366 - --tags '' treated as boolean 'true'
33b565a  Fix for #3424 and tests to prove it.
4820a1b  Fix for #2604 Pure Ruby yaml generation
1c5b3d7  Fixes #3113 - When importing a manifest puppet needs to chill
e6a720b  Fix for #3412 install.rb should not put "." first in the tmp_dirs
b1b3bcf  Resolving conflicts with testing
ba2a3af  Fix 2239 (step five): introduce new Puppet::Transaction#stop_processing? flag and associated check thereof within the resource evaluation code.  This should allow for the transaction to bail out of its processing if it finds that a stop has been requested, based on the state of Puppet::Application.stop_requested?.
9cb6841  Fix 2239 (step four): Refactored Puppet::Daemon's stop/restart methods to set status flags appropriately in Puppet::Application, and removed call to now-deprecated @agent.configure_delayed_restart.  This should get the restart and stop behavior for daemons and their agents working nicely with the new global process status interface of Puppet::Application.
82f852a  Fix 2239 (step three): Refactored Puppet::Agent to base starting/restarting behaviors and predicates on new run-status interface of Puppet::Application.
edbe9b6  Fix 2239 (step two): introduce Puppet::Application.controlled_run method to provide simple status-restricted execution of a passed in block; this can replace the process status checks and properly handle delayed restart behavior for Puppet::Agent.
2cf647c  Fix 2239 (step one): introduce global settings represeting application run state with methods for setting the state and appropriately-named predicates for querying state, all in the Puppet::Application class itself.  To be used by Puppet::Daemon and Puppet::Agent and Puppet::Transaction for better response to TERM, INT, HUP.
ce944a5  Fix unit tests in file/target.rb
481ddb8  Name change of event in ral/type/exec.rb
1ebc91e  Use a helper function to evaluate a resource since the API has changed
bfb1fa5  Allow skipped resources to process events
a18b05d  Actually invoke the allow_changes? method in ResourceHarness
bf2f088  Generated resources' events are actually bound to the resource that generated them.
50ed75b  Remove test that tests internal class structures which have changed.
1779079  Remove stale set_trigger
9154aca  Since the types stored in resource's @parameters have changed, we need to also change include? method to be more robust.
2a2ab75  Fix test failures due to name changes of event symbols
0a72a98  Remove rollback test, since rollback was removed.
010907b  Mark resource/status as failed if they are associated with a failing event.
17bccb0  Restore noop non-behaviours
8465cd0  Resolving conflicts with reinh:feature/master/single_executable
0f768ed  Removing now-obsolete user tests
7627441  Fixing most failing test/ tests.
9d9b20f  Fixing Configurer interface to transaction report
eb0a4b5  Fixing fingerprint tests to work with new log validation
f4ef039  Changing REST report integration test to use new interface
fdefb64  Fixing "require" function to use new class interface
266bc08  Removing now-obsolete "retrieve" method on package type
67a75db  Fixing broken selinux tests
2777e1f  Fixing feature validation when passed one item
5aa26d0  Changing method profile for other event queueing
ec7ea27  Refactoring event queueing for performance
68ce086  Changing the method profile of EventManager#queue_event
9919b14  Moving Metric management to the reports
a9fc134  Removing mention of @changes in Transaction
a18769d  Cleaning up the report tests a bit
386b3e5  Fixing #2759 - reports now have complete change info
fbd5b0a  ResourceHarness now doesn't check params with no 'should'
3f6c948  Changing Transaction to use the new ResourceHarness
6051599  Fixing log message when changes fail
149d5ef  Fixing some compatibility and old tests
c30494f  Renaming some methods in Transaction::Change
8d5f052  Adding Transaction::ResourceHarness class
6651aa4  Adding first version of Resource::Status class
4bb35a7  Fixing File type indentation
796d882  Removing last event collection transaction code
e838bcc  Solidifying the RAL/Event integration.
977595b  Refactoring the Change/Event/Property interface
5776fe4  Cleaning up the Log initialization code.
2292b76  Refactoring the RAL interface to logging
d93d80a  Using Logging module in main Puppet module
c6dd180  Adding tests for "Logging" module
242209d  Correcting comments and making report timestamp internal
a4b77f6  Failing in app/puppet if facts are not found
f925475  Fixing file content logs
73f57f2  removing extraneous comment
4be8601  Adding Transaction events to Transaction reports
2aa579b  Removing a redundant method in Report
5a8b460  Removing unused code and adding a couple of tests
9a78bee  Adding tests for the 'report' log destination
f2ed655  Extracting event management into a separate class
329527f  Changing SimpleGraph.matching_edges to expect one event
f8d7c44  Moving event creation to the resource
ee9cff9  Reorganizing Property class to match current style
4212f1c  Cleaning up Event creation
8280987  Adding "type" instance method to enhance Demeterness
ad90900  Random code cleanup
32d34e9  Moving Ensure property into separate file
3c86666  Moving Parameter utility classes into separate files
2cbd9e8  Switching transactions to callback-based events
6a450c5  removing never-used code
379ac8f  Moving log destination code into separate files
b2d1728  fixed a couple of typos
7ab29c4  Unit tests for path changes
a8245d8  Handle path elements with ticks and spaces
98581ad  Fix builtins glob in single executable
b4b07f5  Fix failing specs
e7bc19a  Rename puppet application spec to main
c014c29  Renaming the old puppet executable
deff92d  Find both bin and sbin usage docs, fail gracefully
3c8d012  Fix application name in bin/ralsh
be0ecf8  Initial puppet single executable
7a32777  Renaming applications, mostly removing 'puppet'
b19a044  Some tests were leaking state when the test failed
5b2802c  Typo in method call in test.
6a148e2  Supressing warnings (not really failures) in test/unit
06deee7  Fix test using wrong Puppet util filesetting group
74f5167  Mock user in SUIDManager tests
000d37a  Removing resources generate tests
11379c0  Removing old test for service/debian provider
2b8125c  Replace test/unit file write test with spec
164f1ce  Allow adding single key to hashes
fd427a5  Raise an error when appending not a hash to a hash
75c32f9  Fix #2389 - Enhance Puppet DSL with Hashes
9122ac5  Fix #2929 - Allow checksum to be "none"
73c8d0d  Fix #3186 - require function set relationship only on the last class
c5a4de2  Fixing #3185 Rakefile is loading puppet.rb twice
c694c4d  Fix #3150 - require function doesn't like ::class syntax
075f3c8  Added time module to tagmail report
dfb8082  Fixed the return types were valid, and removed the copy paste error with the exception logic
6e16ea1  Resolving conflicts with ???
bca7e2c  Add AIX package management support (installp&nim)
b2c9455  Fixing #3148 Settings#without_noop when run with no noop setting
8bafc37  Move scope parenting & class_scope from Compiler to Scope
7403c6e  [#3392] Better Rakefile, remove puppetmasterd spec
de94f68  Fixing tests in pkg provider
4b55fb0  bug #3407 Part 2
f891ba2  Fixing #3407 Failing tests in spec/unit/node/environment.rb
af9c19a  Bug #3406 augeas spec fails if there is not a default provider
718a87a  Bug #3402 Stub returning invalid type for :noop
88d6cd5  Bug #3401 Spec failed due to missing manditory setting in mock
d9920bc  Bug #3400 Bad mocks causing failing tests
c6f02f2  Fix #3167 Duplicate constant warnings in dpkg.rb
70c71c5  Fixed Rails database tests
46f9d00  Fix #3117 - cert fingerprinting uses a method not available in ruby <= 1.8.6
04842ef  Fixed test error message.
fcce222  First shot at the OpenSolaris pkg(5) provider
3e9677f  Feature #2839 - fingerprint certificate
91c44b4  Fix a few puppetd specs tests
d77c9ac  Revert "Feature #2839 - fingerprint certificate"
58a81ba  Fixing #1054 - transaction reports are always sent
282b4b3  Removing some unneeded validation code from Transaction.new
66a3e6a  Removing unused configurer code
2044550  Fix #2894 - exclude .pp files under modules files directories
d31ff7e  Adapt to method name change since 8971d8
a9fb82b  Feature #2839 - fingerprint certificate
a967b93  Feature #2395 - revoke when cleaning a certificate with puppetca
e26e831  Updated test series
53869e9  Fix #2818 - scope variable assigned with undef are not "undef"
4226e01  Fix for #2959 (calling exit status on a nil report)
8971d8b  Fixing #2596 - Node, Class, Definition are not AST
39d4a93  Adding a context method to the Errors module
22c642d  Extracting language doc support into a module
adc211a  Adding module metadata
bf40f4f  Upgrading rspec for tests to 1.2.9
61d1911  Fix 2841 - Puppetdoc/RDoc parses realize function
e63d23e  Added tickets/master/2596 to the testing branch
41da962  Feature 2827 Option to disable managing internal files
c9f40be  Fixed #2568 - Add database option 'dbconnections'
2d137e2  Fixing #1507 - Adding a :ca_name setting
089ac3e  Fixing #2617 - using the searched-for REST name
28e1bc6  Always using the CA_name constant instead of "ca"
2d4b795  Fix #1934 - detailed-exitcodes for puppetd
0f61816  Fix #2649 Allow ssl dir creation in --noop mode
53be6f8  Fix #2796 - Fix puppetdoc rdoc selector parsing
391786f  Fix #2795 - puppetdoc rdoc reports a better error message
b832d81  Fix #2784 - puppetdoc/rdoc didn't parse mono-instruction class content
b1deb89  Covers the RDoc Puppet Parser with specs
ced5a78  Fix #2376 - Display class/node inheritance in puppetdoc
8d9fbbd  Fix #2703 - add 'require' to puppetdoc
41b7c3c  Adding an example yaml node script
66a44dd  type augeas: add 'incl' and 'lens' parameters
c61335f  Patch to address feature #2571 to add Oracle support to Puppet

0.25.5
======
d71bd68  Updated CHANGELOG for 0.25.5
d88b357  Fixes incorrect line in partial CRL fix
dec84e5  Fixed documentation issues exposed in #3772

0.25.5rc3
=========
4daf8c3  Updated CHANGELOG for 0.25.5rc3
9214400  WIP - trying to fix #3460
9d3e98b  Minimal footprint fix for #3751 (serialization 0.25.5 <-> 0.24.8)
d481340  Updated Template documentation link
5a1a45c  Update Red Hat spec file for 0.25.5

0.25.5rc2
=========
2257605  Updated CHANGELOG for 0.25.5rc2
5258a0a  Fixing #3533 - Removing all transaction cleanup
bcde541  Fix for #2910 -- Tidy/matches is too tricky to use
5abe571  Bug #3451: Don't leak the terminus class setting from Puppet::Resource::Catalog's spec
ebd924c  Fix to the fix for #3295
ce233aa  Write ssh_authorized_keys as user
6739bab  Fix for #3558 -- source file reading speedup
b0e3c61  Fix for #3556 Plussignment value melding
8a30495  Fixed #3655  - Puppet doesn't find installed packages with portage provider
e4130af  Fixed #3672 - Error message on duplicate fileserver mounts incorrect
1275a47  conf/redhat: Add notifempty to logrotate config
134204d  Fixed stored configuration documentation
1aa98a6  Fixes #3653 - Changed default factpath value to better reflect plugins in modules
44f6d64  Partial fix to #2837 - changed warning message to debug
3a1b178  Fix #3555 - fix state of purged lists
f6046ab  Fix for #3577 -- to_yaml parameter in 0.25.5rc1
f351e2d  Renamed all references to Reductive Labs to Puppet Labs
cf7e696  Updated Rake tasks to no longer load puppet.rb
b93924e  Fix #3540 - name methods correctly
9bc2f28  Fixes #3295 - generate() now sets the working directory to the directory containing the specified command.
3ee6834  Added YARD task
99818ef  Update man pages and partial doc fix to #3491
f988af3  Fixed #3532 - Typo in lib/puppet/ssl/host.rb
f0e12e5  Fix #3496 - suppress transaction debug message

0.25.5rc1
=========
0eea2f5  Updated version and CHANGELOG to 0.25.5rc1
57ae381  Modify SuSE spec file for 0.25.x and correct shebang lines for puppetd/puppetmasterd
d90ec79  Fixes #3460 - Makes Puppet FHS compliant by moving /var/puppet to /var/lib/puppet
ae0b0bf  Fix for #3101 (bug in MRI 1.8.7)
9db066b  Fixes #3419. OS X 10.6 Ruby doesn't set supplementary groups
306d082  Revert the guts of #2890
4eea77a  Fail gracefully on packages that don't have the HOMEPAGE variable set (e.g. dev-lang/php).
f5b8494  Fixed #3443 - Typo in mount type
b0ef2c6  Fixes #3135 - darwin doesn't support 'mount -o remount'
7018cf5  Adding :catalog_terminus setting
978ab8a  fixing obsolete comment in puppetd
6d13d0d  Adding support for only using cached catalogs
bc28715  Refactoring Configurer to enable the next feature
ba43d7b  Fix for #3366 - --tags '' treated as boolean 'true'
5ab5e8a  Supressing warnings (not really failures) in test/unit
e4df0b0  Fix test using wrong Puppet util filesetting group
eeb3d74  Mock user in SUIDManager tests
9ea27db  Removing resources generate tests
218e3e9  Removing old test for service/debian provider
1556938  Replace test/unit file write test with spec
2defc00  Fix for #3424 and tests to prove it.
44798b9  Fixed changelog Rake task
5d10f65  Fix #3155 - prevent error when using two matching regex in cascade
fbedb99  Fixing #3148 Settings#without_noop when run with no noop setting
389c77b  Another trivial follow-up fix for #2604: invalid path to zaml.rb
56b5753  Fix inefficient SimpleGraph#matching_edge
4b2b9eb  Fix #3229 - use original value in case/selector regex matching
19863c0  Fix #2929 - Allow checksum to be "none"
fd76142  Fixed puppetlast typo
3b4e782  Follow up for #2604, debug msg left behind.
e44430b  Fix for #2604 Pure Ruby yaml generation
74cd55f  Fixes #3113 - When importing a manifest puppet needs to chill
7ec50a7  Fixes #3387 - Handle path elements with ticks and spaces
d561a98  Fix for #3412 install.rb should not put "." first in the tmp_dirs
751df45  Fix #3186 - require function set relationship only on the last class
a1d216c  Fixed the return types were valid, and removed the copy paste error with the exception logic
d532e6d  Fixing #3185 Rakefile is loading puppet.rb twice
5aa596c  Fix #3150 - require function doesn't like ::class syntax
3457b87  Added time module to tagmail report
71653a7  Fixed #3162 - tidy does not remove empty files when "size => 0" is set
efd0f76  Fixed #3128 - Updated man pages and moved puppet.conf.8 to puppet.conf.5
ad4f94a  Add version number to puppetlast display.
0533cea  Forgot fakedata called in spec
6416f91  Fixing #2669 puppetmasterd integration has leaky state
8a3a205  Fix for #2327, check the return types from augeas and fail where appropriate
2ae7516  2047: Add a not_include into match
55f6239  Minor unit test fixes
b7b7a1c  vim: Improve function matching when functions contain ')'
b3c363c  vim: puppetDefArguments is contained by puppetDefine
f9e05a8  Fix for #3094 (libdir should take ":" delimited path)
b473264  Fix #1842 Net::HTTP#enable_post_connection_check doesn't work anymore
9419c2b  Fix for #3035 (redhat services use init for source)
10becce  Fix for #3077 (unit tests broken in 0.25.1-->0.25.4)
49a7185  Fix for #3085 (user_role_add pulls from same source as useradd)
1f086c2  Fix for #3114 (ruby's arbitrary limit on process groups too low)

0.25.4
======
c5eef04  Updated CHANGELOG for 0.25.4
0025e13  Partial reversion of patch for #3088 to fix #3104 (Exception misreported)
bfc9e45  Updated CHANGELOG for 0.25.4rc3

0.25.4rc3
=========
a91c476  Fix for #3088 (catching Exception also traps SystemExit)
1a263e2  Fix for #3089 (timestamp may now be a time object, not a string)
75634b7  Fix for #3093 (also need to be able to call pkgget_with_cat on class)
94e269c  Uncommeniting the fix for #3001
9636b93  Updated CHANGELOG for 0.24.5rc2

0.25.4rc2
=========
d4319a5  Minimal fix for #3001 (failing to fetch metadata on dangling symlink)
cdcbdc7  Fixing #2914 - pre/post hooks now work for transactions
67216aa  Fix for #3075 (sshkey host_aliases ignored)
e4462c0  Updated version and CHANGELOG for 0.25.4

0.25.4rc1
=========
441879f  Revert "Fix #2845 Cron entries using "special" parameter lose their title when changed"
f7e1435  Updated rake task to fix gem build issue
49013f0  Updated version and CHANGELOG for 0.25.3

0.25.3
======
f8c1b08  Reversion of pipe IO patch for testing on #3025
7f25805  Fix #1464 Mount complains about missing fields
c99f394  Fix #2845 Cron entries using "special" parameter lose their title when changed
0a7e212  Fix #2887 'service' tests paths too early
dd22b71  Replaced ugly gem creation task with slightly less ugly task
d0efcc6  Added tasks directory to Rakefile and gem task file lists
8a6d66e  Added puppetpackages task description
eada68a  Updated CHANGELOG for 0.25.2

0.25.2
======
6111ba8  Fix for temporary file security whole
e7d98cc  Fix for #2999 (absent package handling on solaris)
87136b4  Fix typo in documentation: wheter vs. whether.
cbc2ef0  Partial rollback of refinements to fix for #2994
fd631b9  Do not close stdout or stderr in execute.
f878fe8  Update Red Hat spec file for 0.25.2
4394c48  Updated CHANGELOG for 0.25.2rc3

0.25.2rc3
=========
13cbf04  ReFix 2675 ending slash in directory should get stripped off
5c6f07b  Use a pipe instead of a temp file for command output.
7e64393  Additional fix for #2994 (followed symlinks do not have checksums)
7e2e12b  Fix for #2995 (don't fail to load PSON when UTF-8 missing)
c84186a  Revert "Fix for #2731 (problem communicating with processes in SELinux)"
74d9693  Updated man pages for 0.25.2
7e2b1e9  Fix for #2995 (don't fail to load PSON when UTF-8 missing)
d1ff4b3  Fix for #2994 (undefined method "_file" message)
4d81511  fix #2987 - check correct hash entry

0.25.2rc2
=========
682000b  Updated CHANGELOG for 0.25.2rc2
e4bb529  Fix for #2967 (RFC-1123 problem and regression on wildcarded domains)
776be7c  Updated CHANGELOG

0.25.2rc1
=========
a73f799  Updated version
26e7486  Fixing failing tests
05e897e  Fix for #2881 (ralsh doesn't find individual parsed resources)
e04f9e4  Code smell reductions
24654a2  Making provider/host/parser.rb compatible with host_aliases
49530ad  Fixing #2964 updated resources cannot be collected until they are exported twice
6ab2453  Fix for #2731 (problem communicating with processes in SELinux)
0e5d264  Fix for #2940 (propogating nil rather than reporting the error)
d60ea0e  A slide down the RFC-1123 slope towards MS Windows compatibility and chaos
b185801  Fixing #2960 Test Failed: 'Puppet::Type::Mount::ProviderParsed when modifying the filesystem tab should write the mount to disk when :flush is called
5e5c8b5  Fixing tests
0cb5e7d  Fix for #2943 (Make puppet --apply respect --preferred_serialization_format)
0884035  Fix #2970 spec/unit/provider/ssh_authorized_key/parsed.rb has order dependencies
b86decc  Fix #2816 MySQL server has gone away
854c065  Fix for #2813 (alias propety v. alias metapram)
813cb58  Fix for #2765 (--no-fqdn regression in puppetrun)
e9a0cb7  Fix for #2657 (retain old setting if config has syntax error)
727ee72  Fix #2966 spec/unit/util/queue.rb can't be run twice
8c8e921  Fixing #2963 spec/unit/util/autoload.rb depends on global state
ea90daa  Fix for #2965 (Chatty SELinux message)
fc221ff  Fixed RSpec deprecation error
037b99a  Fixing #2958 inconsistent errors in spec/integration/bin/puppetmasterd.rb
d11c750  Fix for #2951 (SELinux test errors on OS X)
0dc2dba  Fix for #2890 (the cached certificates that would not die)
03f37ac  Fix for #2950 (parens needed warning)
61fd460  Fix #2924 Test Failed: Puppet::Indirector::FileContent::FileServer when finding files should find plugin file content in the environment specified in the request
2432b23  Fixed test typo
f5960ce  Closed #2937 - Migrated a number of requires to features
2d88926  Fix for #2869 (SELinux tests failing under some load orderings)
18c5165  Adds partial IPv6 support to authstore
857047d  Fix for #2567 (Authstore does unintended/pointless DNS lookups)
dddbd28  Enabling steps for #2567 (Authstore does unintended/pointless DNS lookups)
ea0a43f  Fix 2948 Failing rests in spec/unit/rails.rb
b6f4291  Fix #2923 failing tests in spec/unit/ssl/host.rb
bf7c108  Fix #2677 Proper OIDs on puppet.schema for LDAP
e0488b2  Fix #2808 puppetqd doesn't give an error when no config is given
7b2e2ba  Fixing 2851 spec/unit/network/rest_authconfig.rb test descriptions change
1c69af2  Fixing 2855 Inadvertent zlib dependency
3528a7b  2850 spec/unit/application/puppetd.rb generates warnings if run with certain other tests
d343af0  2876 spec/unit/indirector/catalog/compiler.rb changes behaviour
a7fae47  Fix 2936 Insufficient mocks for webrick in spec/unit/network/http/webrick.rb
b96b757  Fix for #887 (safely setting pager to cat for blastwave)
d685f44  2633 file and line info on bad params in type/file
4326eb2  Fix for #2817 (links created even when links property set to follow)
118adc1  2875 spurious test failure in spec/integration/file_serving/content.rb
0f63a54  2877 race condition in webrick
4895329  Fix for #2921 (test not checking for what it really wanted)
f47fa40  Fix for #2925 (accept higher versions of rspec)
c261721  Fix for #2911 (Allow capital letters in selinux contexts)
bf7d650  Fix for #2900 (rug output parsing too specific)
cccbca4  Fix for #2786 (failed trying to backup directory in recursive purge)
6dfac97  Fixing 2907 rspec crash when spec/unit/application/puppetrun.rb is run after spec/unit/util/ldap/connection.rb
1c8d272  Fixing 2870 Spurious failures in spec/integration/ssl/certificate_request.rb
979440f  Fixing 2862 spec/integration/file_serving/metadata.rb fails unless run with other tests
e04d299  Fixing 2858 spec/unit/application/puppetmasterd.rb fails if run twice
53a9805  Minimal fix for #2822
9ac1ed6  Fix for #2863 (calling each on uninitialized tag list)
bd9e06f  Feature 2827 Option to disable managing internal files
8b66998  Fixing 2849 puppet changes sshkey alias every run if it is blank
7136c85  Fixed spellquote function documentation
de16fd3  Updated yumrepo type documentation
d1fa7cf  Fixed --no-ca option in Gentoo also
8b5b4b6  Fixed incorrect command line in Red Hat sysconfig file
623d9c7  Fixing 2886: Failing specs in format_handler
feb021f  Avoiding rspec bug which causes 'be_all' tests to always pass
228f105  Removed some extraneous files from ext
01c98f6  Fixed #2798 - Correct issue with crontab provider on AIX
f7c5ceb  Fixing 2725 Error message when permissions incorrect on file server directory
07b94b4  2842 Format debugging should be removed
3abcc89  Fix #2783, take2 - puppetdoc should use environment to get modulepath/manifestdir
f5dd6c8  Fix #2831 - puppetdoc doesn't cope with regex node
4a06379  Fixing #2857 (quote nesting error)
9a41c35  Fixing #2791 fs_find should follow symlinks
5629092  Added additional documentation to file mode attribute.
dc8812c  Fixing 2792 selinux tries to set properties on unsupported filesystes
57632a0  fix #2854 - parse timestamps
cb6bc27  fix regex for non-installed packages
9cfe390  Fixing 2812 authorized_keys without comments fail
53b3b86  Fix for ticket #2844 (file recursion generated vs. explicit prefix)
8129caa  Fix for ticket #2700 -- check for @explicit_waitforcert in puppetd --test
e32f980  Fixed #1806 - supplementary groups are not reset
be7ff82  Fix 2768 maillist resource is broken
48beaba  simplify and fix portage provider
0ac0ce9  Implement tasks for git-based workflow.
bd5dc64  Possible workaround for #2824 (MRI GC bug)
c1e47a4  Fixing #2789 puppetrun fails without --tag
106c9a9  Fixing 904 RDoc::usage incompatible with rubygems
5ed2e26  rack: SSL Env vars can only be in Request.env
7f2e5fc  Fix #2671, preferred_serialization_format does not complain about invalid values
f0eaf20  Fixing #2764 ActiveRecord 2.1 support
eaab789  Fix failing tests introduced by #2797
55d8ffa  Fix #2810 - adapt tidy to new FileSet api
236bacc  conf/redhat: Prevent killproc from removing /usr/sbin/puppetmasterd
41f025c  Fixed ldap typo again
6c2daa3  Fix #2783 - Puppetdoc rdoc should use environment to get modulepath/manifestdir
5648666  Add Environment#manifestdir and small refactoring
74a877e  Minimal fix for #2821 ("rake spec" is needlessly slow)
cd10e6d  Added package signing task
ca56aa7  Least kludgy patch for #2675
adc0a4e  Fix for #2661 and related issues
65f601a  Fixing 2806 Specifying multiple tags fails to apply any of them
e2c675e  Updated generate function documentation to make it clear it runs on the master
53f40bd  Fix #2681 Incorrectly duplicating resources
3fdc8ef  Ticket #2770 (deserializing Exec[...]s with "\n"s)
b172287  Fixing #2767 invoke-rc.d warnings
4013560  Fix #2797 - tags are not inherited by recursed file sub child
f05a04e  Fix #2784 - puppetdoc/rdoc didn't parse mono-instruction class content
38ec9fc  Fix #2796 - Fix puppetdoc rdoc selector parsing
5f7177e  Fix #2795 - puppetdoc rdoc reports a better error message
136949d  Fixing #2631 show_diff sometimes doesn't happen
cb3e5e1  Fix #2787 - Storeconfig doesn't store/update node ip and environment anymore
ff23b57  Fix for #2670, Puppet silently ignores catalog_format
ee13efa  Add docs to Mac OS X package creation script and clean out old docs in the preflight
b8470b8  Fix #2757 & CSR 92 (symlinks in recursively managed dirs)
5b750c2  Fix #2769 - default schedule are not defined
eca338c  Fix for #2772 (webrick test failures)
b1c57e9  Al Hoang's patch for #2781, removing obsolete when/: syntax
50e9c98  Follow-on for #2724 - Adding an external node classifier

0.25.1
======
2f0b1e5  Updated CHANGELOG
20e5222  Fixing #2689 - file owner warnings are reduced
09fb3f7  Fixing #2752 - "require" loads "include"
6846c32  Fixing some recently broken Scope tests
0043392  Fixed typo in lib/puppet/indirector/ldap.rb
6b254eb  Fix #2753 - Do not "global allow" plugins/modules mount if some rules have been parsed
ff3a7bc  Re-fixed #2750 - Stop disabling the CRL or checking for a disabled CRL
594c774  Revised partial fix for #2661 and related issues
73d04c6  Bug #2534 Raise error if property appears twice
7517572  Bug #1908 cron environment should allow empty vals
febe707  Bug #1742 Invalid params to --color outputs 'nil'
d383ab8  Use notice() in the versioncmp() docs
9dff716  conf/redhat/*.init: Use -p option to killproc
f47a70f  Ticket #2665: Regexp exception on ++ in package names
b6e4ef3  Fixed #2750 - Set :cacrl to nil instead of 'false' in puppetd
2b57e06  Fix #2691 - Collection AR request should not include params if querying with tags
e8bce7a  Workaround #2668 - Compress facts so that the request size limit triggers less often
e2ce790  Fixed #2737 - The zone provider needs to get acquainted with OpenSolaris
aea1e5f  Update Red Hat spec file for 0.25.1
fbdded7  Ticket #2685 (Type error in ssh_authorized_keys)
4d9f76a  Fix for #2745 fakedata tests not working
b4bcfe9  Fix for #2736, target doesn't work for ssh_authorized_keys
ae528f6  Ticket #2734 PSON/JSON not serializing classes of a catalog
f59f805  Bug #1900 Parsing of quoted $ in stdin
6ba122f  Fixing #2735 - node classes are immed. added to classlist

0.25.1rc2
=========
bca3b70  Bundling of pure ruby json lib as "pson"
ce46be5  Proposed alternative solution for #2664 (REGEX / DIV lexing)
b0518c3  Fix for #2681 (duplicate resource)
8a73082  Fix #2707 config_version fails more helpfully
54ded1b  Fixes #1719, this avoids calling the external binary *which* everytime we are looking for a binary
4c3c279  Updated required Facter version in README
fcce46a  Fixed #2702 - Set :outputdir to "doc" if not specified
3940dfb  Fixed #2674 - createpackage.sh: problem finding install.rb
3b548f4  Fix #2699 - Use --masterport for PUPPET_PORT variable
a75bf50  This updates the portage provider in three ways:
ad86e9e  Fixes #2688. Macauthorization provider now handles booleans internally correctly.
d891f7a  Ticket #2676 (a typo)
bfba2cd  Fix #2672 - Make sure nodenames keep their underscores when used as classname
db67e5f  Added rcov exclusion to Rakefile

0.25.1rc1
=========
6912a7e  Incremented version to 0.25.1
fd322da  Fixes #1538 - Fixes the yumrepo backtrace in noop mode.
6551e86  Fix #2664 - Mathematic expressions mis-lexed as Regex
a595033  Fix for #2654 (error generating error message)
a951163  Fix #2642 - Runit provider rework
96b5087  Fix for ticket #2639 (Puppet[:user]/Puppet[:group] vs. 'service')
af57483  Fixing #2632 - 'require' works for 0.25 clients
d42bda1  Fixing relationship metaparam backward compatibility
d53bc16  Adding version information to the catalog for compat
5f25589  Ticket #2626 (unhelpfull error messages)
a1d3b04  Fixing #2617 - use the cert name as specified
8987509  Refactored Puppet packaging and gem creation
5c2ba47  FIXES 2616: Remove sync.syncronize and Puppet.info
a53a77c  Renamed test branch to testing in rake task
d054fd9  Fixing #2656 - puppet parseonly tests don't hang
cde70cf  Fixes #2648. Spurious macauthorization parameter changes
dcf0d0d  Fix #2652 - Fix SELinux syntax error
ba269f2  Fixed #2651 - Corrected install permissions on man page directories.
361c502  Fix #2638 - Allow creating several nodes with matching names
2283605  Added automatically constructed test branch task and file
fd2a190  Fix for #2621 (JSON serialization of exec)
577a45b  Fix #2622 - Puppetdoc in single manifest to console is broken
d2d7070  Fix #2640 - Daemontools and Runit were not creating the enable symlink
d21b266  Fix #2627 - regex node name could lead to invalid tag
cb90528  Merged fix for #2601
b1554a1  Updated changelog task and CHANGELOG to version aware
f5a106d  Fix for #2637 (Webrick accpting connections on dead sockets)
19e98f9  Fixed #2608 - install.rb will not run on ruby 1.9.1 due to ftools being deprecated
40cd6d4  Fix for #2605 by falling back to alternative solution to #1963
630407d  Make regsubst() function operate on arrays (feature #2491).
a45c435  Fix for #2600 (wrong number of arguments under older mongrel)
f2bc8aa  Fixed #2634 - Added servicegroup_name parameter to serviceescalation type
7404e31  Fixs #2620 authconf interpolation, #2570 0-9 in domain names
4344339  Fix for ticket #2618 (stubbing so redhat tests run under debian)
c2e26b9  vim: match regexp language features
1494bd7  Require active_record/version to support ActiveRecord < 2.3
a5c56fc  Fixed #2607 - Added Facter dependency for Puppet Gem

0.25.0
======
b1eddbb  Updated and created new CHANGELOG format
994d6e0  Adding tests for the #2599 fix
42ab73f  Ticket #2525 don't fail find_manifest on invalid module names
a0f0dcc  Updated permissions on test files
d45812b  Refactoring tests to reduce code size, increase coverage, and make Luke happy.
aba2f66  This further normalizes the handling of init-style services (including the redhat "service" wrapper script).  Removes special case handling of non-zero exit code in redhat (base already did this) and centralizes scattered @resource[:has_____] checks.  Tests that proper versions of each are called and one level of fallbacks.
fb236a0  Combined fix for #2525, #2552 -- RedHat service issues
d40b942  Fixed #2589 - Renamed zfs delete to destroy and added tests
4aa7fce  Monkey patch to improve yaml compatibility between ruby versions
1f6c74d  Fixed typo in parser test
2e9b706  Updated Red Hat spec file and RH patches for 0.25.0.
19815dd  Fixing #2592 - you can escape slashes in regexes
ea58478  Fixing #2590 - modulepath is not cached inappropriately
1a3d0c8  Fixed #2593: puppet init script status command not returning proper exit code
8dabc72  Update documentation string to reflect actual intent of Puppet::Node::Facts::Rest
b30a3c7  Fixes #2581. Use new 10.6 global launchd overrides file for service status/enabled
7f05469  Fixed Naginator link
e589cd3  Fixing #2582 - / no longer autorequires /
3342b73  Fixing #2577 - clarifying and demoting the deprecation notice
d397f8d  Fixing #2574 - autoloading finds plugins in modules
800a78b  The first regex node now matches first
6750aeb  Fixing #2563 - multiple regex nodes now work together
b728b93  Fixes #724 - false is equivalent to 'ruby -W1'
a9d5863  Fix parser error output
ee4f6ba  Fixing #2551 - fixing content changed logs
c8f859e  Fix for test isolation portion of Ticket #2511
6fa9271  Fixing #2549 - autoloading of top-level classes works again
c752680  Fixing a heisenbug resulting from a race condition
ea417d6  Fixing #2460 - puppetmasterd can now read the cert and key
a49915a  Not using the service user in settings when it's unavailable
14ec838  Explicitly loading all facts in the directory service provider
5ee6602  Adding an 'exists?' delegator from user type to provider
06fcece  Switching the owner/group settings to use symbolic values
4eb325a  Fixing the yamldir group to be a group instead of user
058514a  Moving Setting classes into separate files
b0f219a  Removing chuser on darwin restriction
7f749cb  Fixing a ruby warning in the authstore test
c0da3bf  Fixing #2558 - propagating recent fileserving changes
ff39bc7  Fixes #2550 Handles case where metadata is nil
47dee83  Ticket 2559 -- parseonly ignored specified file
a4f6896  Fixed #2562 - Recognize the usecacheonfailure option again Signed-off-by: John A. Barbuto <jbarbuto@corp.sourceforge.com>
e408d6c  Refactoring the Module/Environment co-interface
796ba5c  Fixing #1544 - plugins in modules now works again
6bd3627  Adding a global cleanup to the spec_helper
0ef5f22  Removed misguided case sensitivity tests
c1967bb  Fixes #2513. debian service provider now uses invoke-rc.d to determine enabled? status
7e09247  Fixing fact-missing problem when puppet.conf is reparsed
a35e9bf  Fix for #2531; adds tests to confirm problem and related cases, notes fixes specific issue by eliminating the specal case for opaque strings which caused them to be strings when everything else was arrays; adds nots and pending tests where FQDN support could be added but stops short of a full refactor.
299eadb  Fixed #2530 - Fixed status setting in the SMF provider
e6a7e82  Fixed spec typo
75c6e4a  Fixes #2493
b62d966  conf/redhat/*.init: Fix condrestart/try-restart
e9fbd4c  conf/redhat/client.init: Fix #2123, status options on older RHEL
0461a02  Updates to Solaris smf files to reflect new binary locations
55a9cdb  Fix #2517 - Stack overflow when CA cert missing
601a2e5  Fix #2516 - Fix format detection when content-type contains charset
d86bc88  Fix #2507 - Add missing integration tests
aad3b76  Fix #2507 - Exported resources were not correctly collected.
63cb1ad  Fixes #2503
c129f2a  Fixes #2360 - Removed annoying log message
b1ffffa  Fixed #2525 - Wrong method being overridden in Red Hat services
a88fc4d  Fixing more tests broken from missing libraries
9a356ab  Fixing ActiveRecord Indirector tests to skip w/out Rails
acc5a96  Fixing #2489 - queue integration tests are skipped w/out json
1a5c5b3  Fixing #2508 - removing mention of ActiveRecord 2.3
0cb9072  Fixing #2541 - file cache is more resilient to failure
23948d0  vim: Mark puppetFunction values as contained
79a4339  Add shellquote() function.
79d705f  Fixes #2499. Allows execs to specify an array for the returns parameter
b611c34  Updated fix for #2481
f385072  Revert "Fxied #2481 - Added status and restart overrides for Red Hat service provider."
cc379b6  Fixed #2498 - logcheck update
85a3633  Removed extraneous debugging

0.25.0rc1
=========
bf94de9  Updated two more tests
5b87dba  Logs now assume resource params have metadata
1410bed  Adding metadata delegation from param to resource
3ab3a5c  Removing unnecessary debug output
488e368  Adding integration tests for #2371 (backup refactor)
f1406bf  Adding many tests for #2371, and slightly refactoring
8f60f0c  Fixes for Redmine 2371.
cd224c6  Fixes #2464, #2457. Deprecate reportserver for report_server. Add report_port setting. Add tests.
401a9ec  Fixing #2484 - "format missing" messages are better
f6cc598  Fixes #2483 - Log only copies metadata from RAL objects
7c4c00f  Fixed #2486 - Missing require 'monitor' in parser_support.rb
ea34ee6  Added R.I.Pienaar's extlookup.rb to the ext directory
36d3f58  Added example conf/puppet-queue.conf
967eb9f  Fxied #2481 - Added status and restart overrides for Red Hat service provider.
c702f76  rack: SSL Env vars can be in Request.env or ENV
ca17b3c  rack: don't directly use the forbidden HTTP_CONTENT_TYPE env var (fixes rack specification conformance)
a002e58  Removing old filebucket test
d8de446  Cleaning up tests for #2469
266aafa  default server in remote filebuckets
1f8ef60  Fixes #2444 - Various JSON test failures
11c0fb7  Fixed #2294 - Classes sometimes cannot be found
7e5b562  Adding #2477 - puppet can apply provided catalogs
97274ad  Fixing problems my Feature refactor caused
6fb8bf6  Fixing ruby warning in definition test
b3545fc  Fixed global deprecation error in useradd Unit tests
dc24472  Adding a test for the Exec type
58d9587  Speeding a test up through stubbing
d4d8372  Fixing a small test by stubbing instead of mocking
f7e1c36  Fixing a test broken by the regex features
54a225d  Fixing tests broken by caching autoload results
1ce31b4  Migrating Handler base tests from test/ to spec/
cc3f56a  Migrating Feature tests to spec
21d1d25  Fixing cron test to match new behaviour
849fa67  Migrating tests to spec and removing an obsolete test
6f458cc  Logging the configuration version we're applying
ac58e27  Configuration version information is now in logs
6ed0103  Adding support for an external catalog version
39320b8  Cleaning up duplication in another test file
25fae5f  Removing duplication in the test structure
36c0662  Simplified Rakefile and moved tasks to tasks/rake directorya
b45ccf8  Implement node matching with regexes
58a73b5  Make sure node are referenced by their names
3ebf148  Enhance selector and case statements to match with regexp
ef68967  Fix #2033 - Allow regexp in if expression
17e62b1  Add AST::Regex, an AST leaf node representing a regex
4f9545f  Add regexes and regex match operators to the parser
0ccd259  Add regex, match and not match token to the lexer
201ae59  Allow variable $0 to $9 to be interpolated, if ephemeral
f357a91  Implement ephemeral scope variables
d40ef29  Signed-off-by: Eric Sorenson <ahpook@gmail.com>
6d22afb  Modifying the REST client error to make server errors more clear
21f477a  Fixes #2472. Load Facter facts when ralsh is invoked, plus test.
2e41edb  Update CHANGELOG.git
ebb5a1f  Fixed ci_spec task for RubyGems 1.3.5
b6b903e  Fixes #2461. Provide new and old code paths for macosx_productversion_major with deprecation warning
26b0c70  Fixing typo in two tests which caused them to always pass
76fc2b1  Fixing #2440 - catalogs can now be compiled on demand
832b6ff  Exiting from app failures instead of raising
4ea3f17  Minimal patch to fix #2290 (/tmp permissions)
08ff9e8  Fix #2467 - rack: suggest putting puppet/lib at beginning of RUBYLIB search path
fb60f90  Fix #2465 - Default auth information is confusing with no auth.conf
0ca9b53  Fix #2459 - puppetdoc added namespace classes as RDoc modules instead of classes
18b5d61  Fix #2429 - vim: class/define/node should only be followed by whitespace
da828a4  Fix #2448 - fix the broken runit provider and tests
3898436  Fixed #2405 - Mount parameter "dump" doesn't accept all valid values on FreeBSD
9825bec  Fixes #2362. Do not validate users/groups when supplied with numeric uid/gids
450a19c  Fix #2454 - Definition named after a module don't show in puppetdoc
8551ece  Fix #2453 - puppetdoc mixes long class names that look alike
e3ee594  Fix #2422 & #2433 - make sure puppetdoc transform AST::Leaf boolean correctly
b3b76df  Fixing #2296 - overlapping recursions work again
9120712  Fixing mocks to remove warnings
eeec8e9  Fixing #2423 - no more strange dependency cycles
7d40f9e  Fixing #2443: Adding debugging guidance to dep cycle errors
b4facb0  Fixing a test broken by changing the default os x package type
b418921  Fixing selinux tests broken in the fix for #1963
719e76b  Fixing #2445 - fixing the mount test mock
f13f08d  Minor fix to URL for LDAP nodes documentation
7c859a7  Fixing #2399 - removing client-side rrd graphs
f6d6145  Fixing #2421 - file renaming errors now propagate
db82523  Fixes #2438, get major OS X version from Facter and replace Puppet::Error invocations with fail builtin
22145e7  Update install.rb to cope with all OS X versions, not just 10.5
935c463  Fixing #2403 - provider specificity is richer and better
d95b687  Fix #2439 - let puppetdoc use loaded_code
ef5c4ae  Fixed #2436 - Changed ralsh to use Puppet::Type.new and avoid deprecation notice
0c18013  Fixes #2430 - Stock apache2.conf for passenger incorrect
c383ceb  Make pkgdmg default Darwin provider, make confines consistent on Darwin package providers.
98599c4  Convert to using sbindir for OS X packages, clean out previous executables in bindir
c659743  Fix #2425 - make sure client can contact CA server with REST
17205bb  Fix #2424 - take 2, make sure default mounts allow every clients
f2c55cc  Fix #2378 and #2391 tests
8bbd8b4  Fix #2424 - File server can't find module in environment
effaf80  Fix small typo in the fix for #2394
a06094e  Feature #2378 - Implement "thin_storeconfigs"
b2a008e  Fix #2391 - Exported resources never make to the storeconfigs db
8f82407  Fix #2261 - Make sure query string parameters are properly escaped
c86d44e  Fixed #579 - puppet should try to clear solaris 10 services in maintenance state
910a5e2  Fix #1963 - Failing to read /proc/mounts for selinux kills file downloads
ba824e9  Fixing #2245 - provider lists are not lost on type reload
eb40966  Ruby no longer clobbers puppet autoloading
a42e878  deprecate NetInfo providers and examples, remove all NetInfo references and tests.
22f5632  Fixed #2410 - default acl logs as info instead of warn.
65b0137  Adding test for current auth config warning.
74f5ad4  Fixed #2394 - warn once on module mount deprecation.
f46a52a  Add test for current module mount deprec warning.
858d333  Fixes #2258,#2257,#2256. Maintain correct type for integers/booleans, allow correct values, and fix rule array handling
44f127f  Added Markdown mode to puppetdoc to output Markdown.
8a8ce9d  Excluded directories from rcov coverage report
d152c5e  Allow boolean value for boolean cli parameter
911b490  Fix #2364 - Associates the correct comment to the right statement
faefd92  Make sure the parser sees the correct line number
869ec27  Fix #2366 - puppetdoc was parsing classes in the wrong order
4c659b7  Added rcov coverage to Spec tests
1fd98b1  Fixes #2367 - Mongrel::HTTPRequest returns a StringIO object
8b09b83  Fix #2082 - puppetca shouldn't list revoked certificates
ea66cf6  Fix #2348 - Allow authstore (and REST auth) to match allow/deny against opaque strings
1e83aad  Fix #2392 - use Content-Type for REST communication
aaca17a  Fixed #2293 - Added cron syntax X-Y/Z and '7' for sunday
cddc365  Switching to LoadedCode from ASTSet
fc1f8cd  Adding a special class to handle loaded classes/defines/nodes
325b8e4  Fix #2383, an incompatibility with early ruby 1.8 versions
46112da  Fixing #2238 In some cases blank? is not available on String.
cdd1662  Fixing #2238 - Deal with nil hash keys from mongrel params
769c8aa  Final fix to CI test rakes
a6816ff  Set ENV['PATH'] to an empty string if non-existent
64a4720  Fix to CI rake tasks
5680cd5  Fixing #2197 - daemontools tests now pass
603b9cf  Change the diff default output to "unified"
9bc9b5c  Added missing colon to suntab
0f2d70d  Fixed #2087 and refactored the code that gets the smf service state

0.25.0beta2
===========
3f070c1  Using the logging utilities to clean up module warnings
feb7f89  Fixing #1064 - Deprecating module 'plugins' directories
ccf4e69  Removing deprecated :pluginpath setting
4036de9  Fixing #2094 - filebucket failures are clearer now
ed876e0  Refactoring part of the file/filebucket integration
bd81c25  Adding tests for file/backup behaviour
c45ebfa  Fixed pi binary so --meta option works and updated documentation
d2080a5  Fixing #2323 - Modules use environments correctly
b9e632f  Fixed #2102 - Rails feature update fixed for Debian and Ubuntu
1c4ef61  Fixed #2052 - Added -e option to puppet --help output
d332333  Fix #2333 - Make sure lexer skip whitespace on non-token
5fbf63c  Updated split function and add split function unit tests (courtesy of Thomas Bellman)
a585bdd  * provider/augeas: strip whitespace and ignore blank lines
a94d2de  Fixed pi tests
5f7455e  Fixed #2222 - Cleanup pi binary options and --help output
134ae3e  Fixing #2329 - puppetqd tests now pass
de55e19  Cleaning up scope tests a bit
e4ae870  Fixing #2336 - qualified variables only throw warnings
607b01e  Fix #2246 - take2: make sure we run the rails tag query only when needed
06b919d  Fix collector specs which were not working
2945f8d  Make sure overriding a tag also produces a tag
e142ca6  Removed a unit test which tested munging which is no longer done in the type
d8ee6cf  Clearn up a parsing error reported by the tests
446557f  vim: several improvements + cleanup
9152678  Fixed #2229 - Red Hat init script error
b5a8c4d  Fix #1907 (or sort) - 'require' puppet function
74730df  #2332: Remove trailing slashes from path commands in the plugin
1a89455  Changing the preferred serialization format to json
0de70b7  Switching Queueing to using JSON instead of YAML
7b33b6d  Adding JSON support to Catalogs
c0bd0aa  Providing JSON support to the Resource class
c16fd1b  Adding a JSON utility module for providing Ruby compat
f059c51  Adding JSON support to Puppet::Relationship
7f322b3  Adding a JSON format
7666597  Allowing formats to specify the individual method names to use
d40068f  Allowing formats to specify the methods they require
024ccf5  Adding a "json" feature
c8b382d  Fix some tests who were missing some actions
f9516d4  Make sure virtual and rails query use tags when tag are searched
b5855ec  Make sure resources are tagged with the user tag on the server
d69fffb  Fix #2246 - Array tagged resources can't be collected or exported
6ce0d1e  Partial fix for #2329
4f2c066  Removed extra whitespace from end of lines
97e6975  Changed indentation to be more consistent with style guide (4 spaces per level)
41ce18c  Changed tabs to spaces without interfering with indentation or alignment
f3b4092  Fix #2308 - Mongrel should use X-Forwarded-For
7b0413e  Fixes Bug #2324 - Puppetd fails to start without rails
48d5e8c  Enhance versioncmp documentation
ef56ba5  * provider/augeas: minor spec test cleanup
d322329  * provider/augeas: allow escaped whitespace and brackets in paths
9735c50  * provider/augeas: match comparison uses '==' and '!=' again
dbfa61b  * provider/augeas (process_match): no match results in empty array
386923e  * provider/augeas: remove useless checks for nil
171669a  * provider/augeas: simplify evaluation in process_get/match
51cc752  * provider/augeas (open_augeas): use Augeas flag names, not ints
4951cdf  * provider/augeas: ensure Augeas connection is always closed
0d5a24d  * provider/augeas: minor code cleanup
cea7bb5  * provider/augeas (parse_commands): use split to split string into lines
95bd826  * provider/augeas: remove trailing whitespace (no functional change)
7c5125b  Brought in lutters parse_commands patch and integrated it into the type. This includes reworking the get and match commands as well. This change introduces a few small changes. These are:
6ce8154  Removed --no-chain-reply-to in rake mail_patches task
4ef7bba  Removing --no-thread from the mail_patches rake target
508934b  Fixing a bunch of warnings
fb0ed7a  Fixing tests broken by a recent fix to Cacher
650029e  Always providing a value for 'exported' on Rails resources
f1dba91  Fixing #2230 - exported resources work again
5522eb8  Disabling the catalog cache, so puppetqd is compatible with storeconfigs
abbb282  Fixing the rails feature to be compatible with 2.1+
907b39b  Using Message acknowledgement in queueing
42247f0  Fixing #2315 - ca --generate works again
d7be033  Fix #2220 - Make sure stat is refreshed while managing Files
e4d5966  Added puppet branding to format patch command
00d5139  vim: Remove another mention of 'site' from syntax
9067abd  vim: Highlight parameters with 'plusignment' operator
736b0e4  vim: Highlight strings in single quotes
ce01c95  vim: Clean up syntax spacing
3af2dbf  JRuby OpenSSL implementation is more strict than real ruby one and requires certificate serial number to be strictly positive.
62534a1  Logging when a cached catalog is used.
ff5c44f  Changing Puppet::Cacher::Expirer#expired? method name
e3d4c8e  Fixing #2240 - external node failures now log output
bc1445b  Fixing #2237 - client_yaml dir is always created by puppetd
e0c19f9  Fixing #2228 - --logdest works again in puppetd and puppetmasterd
ab34cf6  Fixing puppetmasterd tests when missing rack
9d5d0a0  Fixing the Agent so puppetrun actually works server-side
b0ef08b  Fixing #2248 - --no-client correctly leaves off client
b83b159  Fixing #2243 - puppetrun works again
3d2189f  Fixed #2304 - Added naggen script to directly generate nagios configuration files from a StoreConfigs Rails database
700ad5b  Sync conf/redhat/puppet.spec with Fedora/EPEL
3ec3f91  Fixed #2280 - Detailed exit codes fix
f98d49f  Fixing #2253 - pluginsync failures propagate correctly
d860a2f  Fixing a transaction test that had some broken plumbing
a728757  Refactoring resource generation slightly
6e824d8  Adding a Spec lib directory and moving tmpfile to it
1d69dbf  Extracting a method from eval_resource in Transaction
7650fb2  Not trying to load files that get removed in pluginsyncing
3995e70  Fix #2300 - Update ssh_authorized_key documentation
cb4a4d3  Changed version to allow Rake to work.  Minor edit to Rakefile
99f666f  enable maillist on centos, redhat, fedora
e13befa  Fixing #2288 - fixing the tests broken by my attr_ttl code
a406d58  Fix for #2234: test fails with old Rack version
c189b46  Fixing #2273 - file purging works more intuitively
138f19f  Caching whether named autoloaded files are missing
415553e  Adding caching of file metadata to the autoloader
d489a2b  Adding modulepath caching to the Autoloader
5f1c228  Adding caching to the Environment class
047ab78  Adding TTL support to attribute caching
6a413d2  Fixed #2666 - Broken docstring formatting
469604f  Deprecating factsync - pluginsync should be used instead
d39c485  Added spec and unit tests to the Rakefile files list and fixed CI rake tasks
e1a7f84  Added install.rb to Rakefile package task
e180a91  Fixed #2271 - Fix to puppetd documentation
4bf2980  Protecting Stomp client against internal failures
f4cb8f3  Adding some usability bits to puppetqd
a18298a  Refactoring the stomp client and tests a bit
2771918  Relying on threads rather than sleeping for puppetqd
07ff4be  Fixing #2250 - Missing templates throw a helpful error
7ce42da  Fixing #2273 - CA location is set correctly in puppetca
e1779c7  RackXMLRPC: buffer request contents in memory, as a real string.
fb957cc  Modules now can find their own paths
c608409  Moving file-searching code out of Puppet::Module
83ba0e5  Fixing #2234 - fixing all of the tests broken by my bindaddress fix
4f3a67f  Fixing #2221 - pluginsignore should work again
2d580c2  Fix snippets tests failing because of activated storeconfigs
8c718c9  Fix failing test: file.close! and file.path ordering fix
17f2c7d  Confine stomp tests to Stomp enabled systems
6a80b76  Fix some master failing tests
172422f  Fix bug #2124 - ssh_authorized_key always changes target if target is not defined
f945b66  Fixing #2265 - rack is loaded with features rather than manually
5aef915  Added .git to pluginsignore default list of ignores
6db5e8d  Cleanup of the Puppet Rakefile and removal of the requirement for the Reductive Build Library
5cc4910  Fix #1409 once again, including test
a6af5bf  Added split function

0.25.0beta1
===========
2dd55fc  Fixing #2200 - puppetqd expects Daemon to be a class
c016062  Removing unneeded test stubs
1a2e1bc  Fixing #2195 - the Server class handles bindaddress
df3a8f6  Minor fixes to function RST documentation
305fa80  Remove the old 0.24.x rack support, which is now useless cruft
d85d73c  puppetmasterd can now run as a standard Rack application (config.ru-style)
d6be4e1  Add XMLRPC compatibility for Rack
6e01e7a  Puppet as a Rack application
cc09c1a  Use FileCollection to store the pathname part of files
d51d87e  Add an unmunge capability to type parameters and properties
a1c0ae0  Fix #2218 - Ruby YAML bug prevents reloading catalog in puppetd
bf054e1  Fixes #2209 - Spec is failing due to a missing require
1c46205  Fix #2207 - type was doing its own tag management leading to subtile bugs
929130b  Moved puppetqd binary
36d0418  Fixed #2188 - Added set require to simple_graph.rb
51af239  Fixed puppetqd require and tweaked stomp library error message
dc0a997  Fixes #2196 - Add sharedscripts directive to logrotate
4d3b54e  Added puppetqd binary to Rakefile
1fee506  Updated version to 0.25.0beta1
0fbff61  Updates to CI tasks
aa6dcef  Fixing #2183 - checksum buffer size is now 4096b
c0b119a  Fixing #2187 - Puppet::Resource is expected by Rails support
5ec4f66  Adding an 'Exported' attribute to Puppet::Resource
adff2c5  Removing a non-functional and horrible test
606a689  Making sure the cert name is searched first
f489c30  Removing an "inspect" method that often failed in testing
93c3892  Removing deprecated concurrency setting usage in rails
6f8900d  Always making sure graph edges appear first
3f7cd18  Reverting part of the switch to sets in SimpleGraph
bf46db7  Fixing rails feature test
5f6b5c0  Failing to enable storeconfigs if ActiveRecord isn't available
8ed7ae3  Fixing the Rails feature test to require 2.3.x
a0c1ede  Modifying the Settings#handlearg prototype
284cbeb  Fixes #2172 - service provider for gentoo fails with ambiguous suffixes
68ba1f1  SMF import support working and documentation update
f1f0a57  Fixes #2145 and #2146
ec478da  Fix configurer to retrieve catalog with client certname
e623f8a  Unify auth/unauthenticated request authorization system
037a4ac  Allow REST auth system to restrict an ACL to authenticated or unauthenticated request
3ad7960  Fill REST request node with reverse lookup of IP address
c0c8245  Refactor rest authorization to raise exceptions deeper
aac996e  Add environment support in the REST authorization layer
72e28ae  Fix some indirector failing tests
dc1cd6f  Fix #1875 - Add a REST authorization system
8523376  Enhance authconfig format to support uri paths and regex
22b82ab  Add dynamic authorization to authstore
15abe17  Add RSpec unit tests for network rights
86c7977  Add RSpec unit tests for authconfig
f04a938  Adding support for specifying a preferred serialization format
6a51f6f  Fixing the FormatHandler test to use symbols for format names
b249f87  Fixing #2149 - Facts are passed as part of the catalog request
1cde0ae  Adding better logging when cached indirection resources are used
828b1ea  Fixing #2182 - SimpleGraph#walk is now iterative
9f32172  Fixing #2181 - Using Sets instead of Arrays in SimpleGraph
7a98459  Removing code that was backported and is now not needed
d06bd3e  Finishing class renames
b694b3c  Fixing tests that apparently only worked sometimes
93246c0  Removing the old rails tests.
5cb0f76  Fixing some rails tests that sometimes failed
bdbf9db  Added class_name tags to has_many relationships
2e62507  Adding time debugging for catalog storage to active_record
a705809  Adding defaults necessary for queueing
8a67a5c  Adding daemonization to puppetqd
fcd1390  Adding Queueing README
9b90f34  Using a setting for configuring queueing
444ae9f  Adding puppetqd executable.
22ae661  Adding "rubygems" and "stomp" features
efe6816  Removing unnecessary parser variables when yaml-dumping
a3b1e8c  Add queue indirection as an option for catalog storage.
bccfcc9  Introduce abstract queue terminus within the indirection system.
7947f10  Introduce queue client "plugin" namespace and interface, with a Stomp client implementation.
80dc837  renaming a method
f7ccaaa  Adjusted parameter name and puppet tag classes to use new cache accumulator behavior for storeconfigs.
75f1923  Initial implementation of a "cache accumulator" behavior.
bab45c4  Saving rails resources as I create them, which saves about 10%
7a91e1f  Changing rails value serialization to deal with booleans
c30ede5  Adding equality to ResourceReference
589f40f  Adding some more fine-grained benchmarks to Rails support
042689e  Adding a Rails-specific benchmarking module
89d9139  Adding simplistic param_name/puppet_tag caching
ea4e3b2  Adding more time debugging to Rails code, and refactoring a bit
6314745  Refactoring the Rails integration
be30a61  Adding a common Settings method for setting values
863c50b  Switching to Indirected ActiveRecord
a137146  Adding ActiveRecord terminus classes for Catalog
b9c95eb  Adding ActiveRecord terminus classes for Node and Facts.
8d0e997  Fixing #2180 - Catalogs yaml dump the resource table first
4e0de38  Partially fixing #1765 - node searching supports strict hostname checking
c1f562d  Removing unused Node code
e6b4200  Fixing #1885 - Relationships metaparams do not cascade
50e0f3d  Fix #2142 - Convert pkgdmg provider to use plists instead of string scanning for future proofing
c1be887  Fixing #2171 - All certificate files are written with default perms
e2201d6  Fix #2173 - fix running RSpec test by hand
424c87b  Fix #2174 - Fix RSpec rake targets
7ab7d9f  Fixing #2112 - Transactions handle conflicting generated resources
84e6c1b  Adding another stacktrace for debugging
4793334  Fixing puppet -e; it got broken in the move to Application
7398fa1  Partially fixing #2029 - failed caches doesn't throw an exception
88ff9c6  Fixing #2111 - SimpleGraph only creates valid adjacencies
36594fe  Switching to new() in the Puppet::Type.instances() class method
edcbab5  Removing duplicate method definition from SimpleGraph
d8eaca8  mini daemon to trigger puppetrun on clients without puppet listen mode
d2c417e  Fix #2113 - Make temp directory
173b5f0  Adding #2122 - you can specify the node to test with puppet-test
a677e26  Fixing all tests that were apparently broken in the 0.24.x merge.
e016307  Fixing Rakefile; apparently there was a rake or gem incompatibility
62dad7a  Fix #2107 - flatten resource references arrays properly
cbee426  Fix #2101 - Return to recurse=0 == no recursion behavior
3b4816b  Fix #2101 - fix failing test
f089e11  Fix #2101 - fix recurselimit == 0 bad behaviour
1b4eae7  Added rake ci:all task
3f61df8  Fixed #2110 - versioncmp broken
830e1b1  CHANGELOG updates
3e0a9cd  Moved of puppetd, puppetca, puppetmasterd, puppetrun binary from bin to sbin
6ddebf4  Fixed #2086 - Fixes to make building tarballs easier
33d3624  Fix #1469 - Add an option to recurse only on remote side
77ade43  Forbidding REST clients to set the node or IP
0179e94  Fixing #1557 - Environments are now in REST URIs
a497263  Adding explicit optional attribute to indirection requests
3e95499  Removing an unused source file
97975e1  Adding a model accessor to the Request class
b6116fe  Requests now use default environment when none is specified
15740fe  Moving the REST API functions into a module
ef4fa68  Using the Handler for the REST api on both sides of the connection
8b13390  Adding REST::Handler methods for converting between indirection and uris
edf00db  Adding environment support to the REST URI
a064ed1  Moving the query_string method to Request
ff9c3ca  Adding tests for the REST query string usage
87ec08e  Fixing #2108 - pi should work again
af4455e  Fix #1088 - part2 - Add rspec tests
b15028f  Fix #1088 - Collections overrides
b24b9f5  Fixed #2071 - Updated LDAP schema
88aa1bc  Fixing tests broken in previous commits
f8dea98  Fixing #1949 - relationships now use attributes instead of a label
d0fc2f5  Correctly handling numerical REST arguments
90afd48  Not passing file sources on to child files
858480b  Correctly handling non-string checksums
27aa210  Removing unnecessary calls to expire()
5329b8a  Passing checksums around instead of file contents
71e4919  Moving default fileserving mount creation to the Configuration class
09bee91  Fixing #2028 - Better failures when a cert is found with no key
cf1cb14  Moving the clientyamldir setting into the puppetd section
5f73eb5  Fixed #1849 - Ruby 1.9 portability: `when' doesn't like colons, replace with semicolons
e40aea3  Fixed metaparameter reference to return str
5df9bad  Fixed #2016 - Split metaparameters from types in reference documentation
7e207a1  Fixed #2017 - incorrect require
417b5a5  Fixing #1904 - aliases are no longer inherited by child files
c0d5037  Removing or fixing old tests
262937f  Correctly handling URI escaping throughout the REST process
b800bde  Refactoring how the Settings file is parsed
d7864be  Relying on 'should_parse_config' in the 'puppet' application
bd8d097  Providing better indirection authorization errors
d3bc1e8  Adding pluginsyncing support to the Indirector
00726ba  Moving Request and Fileset integration into Fileset.
058266f  Switching the ModuleFiles Indirection terminus to the new Module/Env api
19b8534  Migrating the old FileServer to the new Module/Environment code
1be7c76  Using the Environments to handle a lot of Module searching
2b4469d  Environments now use their own modulepath method.
94de526  The 'Environment' class can now calculate its modulepath.
2573ef1  Added support for finding modules from an environment
9c18d5a  Adding support for finding all modules in a given path.
4b5ec82  reformatting the environment tests
458642b  Supporting multiple paths for searching for files.
eec1cad  Adding support for merging multiple filesets.
bdf3a80  Adding new methods to Puppet::Module.
a7be174  Refactoring Puppet::Module a bit.
7ceb437  Only using the checksum cache when we're using a host_config catalog
5fd182d  Fixing fileserving to support strings or symbols
7bc41ce  Adding clarity to query string handling in REST calls
992231a  Some small fixes to provide better debugging and load a library
0304a78  Providing better information when an exception is encountered during network communication
4a7cba3  Stubbing tests that were affecting other tests
3105b5b  Fixing a warning in a test
c854c59  Fixing a syntactically invalid application test
0f43fd6  Move --version handling to Puppet::Application
156fb81  Move puppetd to the Application Controller paradigm
0c71c5c  Move puppetdoc to the Application Controller paradigm
e317fa9  Move ralsh to the Application Controller paradigm
81f5438  Move puppetrun to Application Controller paradigm
3390d8d  Move pi to the Application Controller paradigm
8265d6e  Move puppetmasterd to Puppet::Application
af219bf  Move puppet to the Application Controller paradigm
d51398c  Move filebucket to the Application Controller paradigm
9b9e5e8  Move puppetca to the Application Controller paradigm
97e716a  Introducing the Application Controller
495ad66  Fixing broken filetype tests resulting from the loss of Type[]
21a714a  Fixing some tests that somehow broke in the merge to master
327ee17  Removing a test that was too dependant on order.
487b9b1  Failure to find node facts is now a failure.
610c838  Fixing #1527 - Failing Facter does not hurt Puppet
a2eca6c  Removing some unused code
cb0a083  Using Puppet::Type.new instead of create
84bd528  Actualling syncing facts and plugins
d5abdfb  Fix #1933 - Inconsistent resource evaluation order in subsequent evaluation runs
9bac833  Adding README.rst file
916abc2  Changing how the Configurer interacts with the cache
5335788  Fixing tests broken during the #1405 fix.
08a5d49  Adding an Agent::Runner class.
c7d178d  The Agent now uses its lockfile to determine running state
c0fcb21  Creating and using a new Puppet::Daemon class
700e823  Not using 'master' client for testing
4b7023e  Fixing (and testing) the return of Indirection#save
8dc0005  Adding a 'close_all' method to the Log class.
37d1a7c  Removing restart-handling from Configurer
bf3c72e  Adding temporary class EventManager
fc14b81  Splitting the Agent class into Agent and Configurer
e8be6dc  Removing the Hash default proc from SimpleGraph.
6bb804f  Removing the Catalog's @aliases hash default value
502e062  Removing an erroneous configuration call in puppetmasterd
337057a  Removing obsolete code and tests for the agent.
d53ad31  Converting the catalog as needed
f38277f  Adding REST support for facts and catalogs.
c48525b  Adding better error-handling to format rendering
b93a642  Resetting SSL cache terminii to nil when only using the ca
212b3e3  Allowing the Indirection cache to be reset to nil
5a83531  Moving the Agent locking code to a module.
b672790  Cleaning up SSL instances that can't be saved
f78a565  Only caching saved resources when the main save works
5434459  Moving classfile-writing to the Catalog
e65d7f1  Refactoring how the Facter integration works
6b4e5f4  Reformatting tests for facts
54faf78  Moving fact and plugin handling into modules
9d76b70  Removing the Agent code that added client-side facts
a5c2d7a  Adding Puppet client facts to Facter facts.
b99c6b5  Clarifying how node names are used during catalog compilation
8b44d6f  Reformatting Indirector catalog compiler tests
e770e7a  Removing ConfigStore code that was never actually used.
37692e5  Renmaing Puppet::Network::Client::Master to Puppet::Agent
15d8768  Revert "Adding the first bits of an Agent class."
63fb514  Revert "This is work that I've decided not to keep"
8f5cbc3  This is work that I've decided not to keep so I'm just applying it here so it continues to show up in the history in case I ever want to look at it again.
25b28c5  Adding a new Agent::Downloader class for downloading files.
1afb821  Adding the first bits of an Agent class.
2afff60  Adding support for skipping cached indirection instances.
361db45  Change the way the tags and params are handled in rails
62cdeaa  Add methods to return hash instead of objects to params and tags
3acea41  Rails serialization module to help serialize/unserialize some Puppet Objects
10bf151  Fixing #1913 - 'undef' resource values do not get copied to the db
500ea20  Fixing #1914 - 'undef' relationship metaparameters do not stack
1407865  Revert "Fixed #1916 - Added environment option to puppetd"
8d0086b  Fixed #1916 - Added environment option to puppetd
a065aeb  Fixed #1910 - Updated logcheck regex
fa9dc73  Typo fix
7c8094c  Fixed #1879 - Added to tidy documentation
f40a6b1  Fixed #1881 - Added md5lite explanation
6af3179  Fixed #1877 - Tidy type reference update for use of 0
a5b0a75   Fix autotest on win32
234a035  Fix #1560
fb8f8cd  In order for ReST formatting to work properly, newlines and indentation of doc strings must be retained.
69432d6  Fix Bug #1629
1f6dce5  Fix #1835 : Add whitespace/quote parsing to
8142981  Fix #1847 - Force re-examination of all files to generate correct indices
d2d3de5  Fix #1829 - Add puppet function versioncmp to compare versions
bdee116  Fix #1828 - Scope.number? wasn't strict enough and could produce wrong results
d69abfe  Fix #1807 - make Puppet::Util::Package.versioncmp a module function
34335b7  Fixed #1840 - Bug fixes and improvements for Emacs puppet-mode.el
3b8a77d  Fix #1834 part2 - Fix tests when no rails
b6e34b7  Fix #1834 part1 - Fix tempfile failing tests
566bf78  Fixing #1729 - puppetmasterd can now read certs at startup
0cf9dec  Canonicalizing Setting section names to symbols.
0fc0674  Fixing all of the test/ tests I broke in previous dev.
e4ba3db  Deprecating the Puppet::Type.create.
b6db545  Deprecating 'Puppet.type'; replacing all instances with Puppet::Type.type
89c25ad  Finishing the work to use Puppet::Resource instead of TransObject
1c7f8f6  Adding name/namevar abstraction to Puppet::Resource.
e601bab  Supporting a nil expirer on cacher objects.
f69ac9f  Setting resource defaults immediately.
352d7be  Refactoring the Settings class to use Puppet::Resource
91ff7c1  TransObject is nearly deprecated now.
fae3075  Simplifying the initialization interface for References
14c3c54  Replacing TransObject usage with Puppet::Resource
60062e4  Renaming the "Catalog#to_type" method to "Catalog#to_ral"
6b14000  Using Puppet::Resource to convert parser resources to RAL resources
e3b1590  Adding resource convertion to the parser resources
c306a17  Adding equality testing to Puppet::Resource::Reference
48a9949  Correcting whitespace and nested describes in Puppet::Resource::Catalog
d48fff6  Renaming Puppet::Node::Catalog to Puppet::Resource::Catalog
c927ce0  Renaming Puppet::ResourceReference to Puppet::Resource::Reference
e88746b  Adding Trans{Object,Bucket} backward compatibility to Puppet::Resource
832198f  Starting on #1808 - Added a base resource class.
820ff2e  Removing the "clear" from the macauthorization tests
89e9ef7  Fix #1483 - protect report terminus_class when testing for REST
435f1e9  Fix #1483 - use REST to transmit reports over the wire
6b30171  Fixing all broken tests.  Most of them were broken by fileserving changes.
f73e13e  Adding more file tests and fixing conflicting tests
cc12970  Completely refactoring the tidy type.
720dcbe  Cleaning up the tidy type a bit
053d7bf  These changes are all about making sure file data is expired when appropriate.
a8d9976  Catalogs always consider resource data to be expired if not mid-transaction.
8b08439  Properly cleaning up ssl ca configuration during testing
73fa397  Adding caching support to parameters, and using cached attributes for file source and metadata.
0ecbf79  Adding cached attribute support to resources.
29b9794  Allowing a nil expirer for caching classes.
cd09d6b  Refactoring the Cacher interface to always require attribute declaration.
14af971  Changing the Cacher.invalidate method to Cacher.expire.
99a0770  Fixing a critical bug in the Cacher module.
fe0b818  Fixing tests broken by fileserving and other refactoring.
eed37f7  Fixing a test broken by previous refactoring
45c6382  Finishing the refactoring of the resource generation interface.
0840719  Refactoring and clarifying the resource generation methods.
cc04646  Refactoring Catalog#add_resource to correctly handle implicit resources.
a73cad9  Adding SimpleGraph#leaves, which I apparently did not migrate from PGraph
2a685f9  Removing mention of obsolete edgelist_class from GRATR.
7e20f06  Changing the catalog's relationship graph into a normal graph.
2ba0336  Removing the PGraph class and subsuming it into SimpleGraph.
e92c1cc  Moving Catalog#write_graph to SimpleGraph, where it belongs.
0149e2e  Converting the file 'source' property to a parameter.
35c623e  Removing mid-transaction resources from the catalog.
f4800e8  Adding a method to Checksums to extract the sum type
44fadd1  Aliasing "must_not" just like we alias "must"
a9dbb5d  Deduplicating slashes in the fileserving code
bb6619a  Fixing the augeas type tests to work when augeas is missing
e728873  Reducing the number of calls to terminus() to reduce interference with caching
aa8d091  Switched all value management in props/params to internal classes.
e5b5033  Fixing #1677 - fixing the selinux tests in master.
77d73e0  Changing the meaning of the unused Puppet::Type#parameter method to return an instance rather than a value.
05e1325  Moving a file purging test to rspec
6f7ccff  Fixing #1641 - file recursion now only passes original parameters to child resources.
a4d4444  Removing obsolete methods and tests:     Removing obsolete handleignore method     Removing obsolete FileSource class     Removing a now-obsolete test/unit test     Removing a now-obsolete recursive filebucket test
b4f4866  Making it so (once again) files with sources set can still be deleted (which I think is kinda stupid, but apparently people want it).
caf15c2  Fixing and migrating more file tests.
cccd838  Adding a starting point for spec tests for tidy.
255c9fb  Setting puppetmasterd up to serve all indirected classes.
7fdf2bb  Retrieving the CA certificate before the client certificate.
a00c1f2  Handling the case where a symbol (e.g., :ca) is used for a certificate name.
cf3a11c  Fixing :bindaddress setting to work with the new server subsystem.
a78c971  Fixing CertificateRequest#save to accept arguments.
e70c1a0  Fixing forward-compatibility issues resulting from no global resources
4596d2d  Fixing a test I broke when fixing a reporting bug
9742c26  Fixing resource aliasing to not use global resource aliasing. I'm not really sure why the 0.24.x-style code got merged in, since master's changes should be more recent.
1b517d2  Adding comments to Puppet::Util::Cacher
7a6d9b1  Removing obselete code from the file type.
1b512a9  Merged fsweetser's selinux patch against HEAD
e31df2f  Removing files that git wasn't smart enough to remote during a merge.
ac5db5e  Removing the old, obsolete recursion methods.
a9b7f08  As far as I can tell, recursion is working entirely.
b69c50c  Removing insanely stupid default property behaviour.
45f465b  Source recursion is nearly working.
93fc113  Files now use the Indirector to recurse locally.
bd1163a  Fixing filesets to allow nil ignore values.
5da2606  Recursion using REST seems to almost work.
ee1a85d  Mostly finishing refactoring file recursion to use REST.
7c68fdb  Fixing FileServing::Base so that it can recurse on a single file.
ac41987  Fixing the terminus helper so it correctly catches options passed from clients via REST.
be4c0e7  The file source is now refactored and uses REST.
44c6a52  Removing mention of an obselete class.
8271424  One third done refactoring file[:source] -- retrieve() is done.
98ac24a  Adding a "source" attribute to fileserving instances.
6e43c2d  Aliasing RSpec's :should method to :must.
8b45d13  Adding automatic attribute collection to the new fileserving code.
6ed8dfa  Adding the content writer to the content class.
92e144b  Fixing a test in the module_files terminus
151a54f  Causing format selection to fail intelligently if no suitable format can be picked.
deda646  Removing the last vestiges of the 'puppetmounts' protocol marker.
30dea68  Adding a 'plural?' method to the Indirection::Request class.
40e76fb  Fixing the rest backends for webrick and mongrel so the get the whole request key.
8ea25ef  Refactoring how files in FileServing are named.
550e3d6  Finishing the rename of FileBase => Base.
90e7022  Adding weights to network formats, and sorting them based on the weight.
5a195e0  Renaming FileServing::FileBase to FileServing::Base.
3101ea2  Adding a hackish raw format.
89a3738  Adding suitability as a requirement for a format being supported.
a0bda85  Removing the yaml conversion code from FileContent.
6335b14  Causing the Indirection to fail if a terminus selection hook does not return a value.
1104edb  Correcting whitespace in a test
2f224c9  Spell-correcting a comment
bcd40fb  Cleaning up an exception.
0a05720  FileServing Configurations now expect unqualified files.
237b7b2  Fixing whitespace in docs of some tests.
91b8252  Fixing the fileserving terminus selection hook.
f5ba99f  Special-casing 'file' URIs in the indirection requests.
a215aba  Dividing server/port configuration responsibility between the REST terminus and the indirection request.
d174605  Fixing a test that relied on hash ordering.
7034882  Adding parameter and URL support to the REST terminus.
c819042  Fixing the String format (fixes #1522).
78bc32d  Removing dead-end file work as promised.
a5ab52c  Adding files temporarily, since I've decided this work is a dead-end.
4f275b6  Fixing #1514 - format tests now work again.
025edc5  puppetd now uses the Indirected SSL.
62202bf  Adding 'require' statements as necessary for Puppet::SSL to work.
86a7188  Fixing the SSL::Host#waitforcert method.
a31c578  Adding logging when files are removed.
09ee814  Removing now-obsolete the wait-for-cert module.
cd314fa  Documenting a bit of a test
113d74a  Certificates now work over REST.
2cad30a  Caching the SSL store for the SSL Host.
93fd55f  Enhancing formatting errors with class and format.
6c80e0f  Making all certificates only support the plaintext format.
c464bf2  Adding wait_for_cert functionality to the ssl host class.
c854dbe  Adding a plaintext network format.
818599d  lazy load latest package definitions with yumhelper 2.2
8457856  Fixing a group test that failed after merging 0.24.x
c2c8941  Correctly handling when REST searches return nothing.
186f3cd  Removing an obsolete method from the rest indirector
29d704c  The REST formats are now fully functional, with yaml and marshal support.
c55acee  Adding some support for case insensivity in format names.
8033bd4  Moving validation from FormatHandler to Format.
3405841  Moving functionality out of the FormatHandler into the Format class.
43a6911  Searching again works over REST, including full content-type translation.
1064b5b  Fixing the format_handler tests so that they clean up after themselves.
167831e  Fixing a test I broke while rebasing
e78b1a6  Fixing a test to be order-independent.
352e2d0  Adding rudimentary support for directly managing formats.
55e2944  Adding support for rendering and converting multiple instances.
4632cfd  All error and format handling works over REST except searching.
e3350ca  Drastically simplifying the REST implementation tests.
b3914c3  Removing an apparently-obsolete hook from the handler
739a871  Adding explicit tests for the HTTP::Handler module.
0ce92f1  The REST terminus now uses the content-type and http result codes.
a4170ba  Removing a now-obsolete pending test.
bf5b086  The REST terminus now provides an Accept header with supported formats.
1f15725  Using the FormatHandler in indirected classes automatically.
0e7e16d  Adding a FormatHandler module for managing format conversions.
93eeff5  Fixing the user ldap provider tests
00b7da3  Fixing the new-form version of #1382.
c542dc0  Fixing #1168 for REST -- all ssl classes downcase their names. This is a much cleaner fix than the xmlrpc version, thankfully. :)
eaa6eab  Fixing #1258 -- Removing a Rails idiom.
eb5e422  Fixing #1256 -- CA tests now work with no ~/.puppet.
66c36f0  Fixing another failing test -- the new CA tests correctly clear the cache.
447507c  Fixing #1245 -- ssh_authorized_keys tests work in master.
6f533d1  Fixing #1247 -- no more clear_cache failures.
3cb0d60  Fixing how the mongrel server sets up xmlrpc handlers.
6efe400  Using the new Cacher class for handling cached data.
68d8d0a  Adding a module for handling caching information.
e936ef2  Fixing some broken tests.
1cfb021  The CRL is now automatically used or ignored.
0365184  Removing obsolete tests
3303590  The master and client now successfully speak xmlrpc using the new system.
8fd68e3  Adding pidfile management and daemonization to the Server class.
dd4d868  Fixing the HttpPool module to get rid of an infinite loop.
57c7534  Adding REST terminuses for the SSL-related indirections.
d78b4ba  Adding autosigning to the new CA.
a822ef9  Moving the CA Interface class to a separate file.
38e2dcf  The master is now functionally serving REST and xmlrpc.
6e0d6dd  The REST infrastructure now correctly the SSL certificates.
51ce674  Fixing the webrick integration tests to use the newly-functional SSL code.
62f1f5e  The Certificate Authority now automatically creates a CRL when appropriate.
e57436f  The Settings class now clears the 'used' sections when a value is changed.
137e29f  Moving some http configuration values to the main defaults section, rather than the puppetd section.
a3b8804  The http pool manager now uses new-style certificate management.
e596bc5  Fixing some tests that were insufficiently mocking their configurations.
160f9d9  Fixing a critical problem in how CRLs were saved and moving SSL Store responsibilities to the SSL::Host class.
ce6d578  The SSL::Host class now uses the CA to generate its certificate when appropriate.
67dc268  The CA now initializes itself.
6356c04  Switched puppetmasterd to use the new-style server plumbing.
4c590df  Adding xmlrpc backward compatibility to the new Mongrel code.
31b79fa  Adding xmlrpc support to webrick.
7a876ed  Fixing some whitespace
7267341  Adding configuration support for XMLRPC handlers.
8c9b04d  I think I've now got the Webrick SSL support working. Now I just need to get xmlrpc working alongside REST in both mongrel and webrick.
83519f4  Interim commit, since I want to work but have no network available.
58fb416  Changing the File certificate terminus so that it saves to the :localcacert instead of :cacert.
79ca444  Renaming the 'ca_file' ssl terminus type to 'ca'.
a116d10  Temporarily disabling the revoke/verify test in the CA.
d87e018  Fixing how the CRL is used for certificate verification.
6c539c0  Fixing puppetca so it uses the :local ca setting.
ebdbe48  Added an Interface class to the CA to model puppetca's usage.
934fbba  Making the SSL::Host's destroy method a class method, rather than an instance method.
d4813f1  Adding the last functionality needed for puppetca to use the Indirector.
809fc77  Finishing the interface between the CA and the CRL.
16056a2  Adding inventory support to the new certificate authority.
d498c4a  Adding support within the inventory for real certs or Puppet cert wrappers.
67f9d69  Changing the Inventory class to rebuild when the first cert is added, so it's easier to test.
7cca669  Adding a comment to the inventory class.
98db985  Adding an SSl::Inventory class for managing the ssl inventory.
92a7d76  All SSL terminus classes now force the CA information into the right place.
fb56dea  Switching the SSL::Host class to return Puppet instances.
f7e0990  Setting the expiration date of certificate objects to the expiry of the actual cert.
71db9b5  Adding integration tests for a lot of the SSL code.
e5c4687  Moving the password file handling into the SSL::Key class.
d8bb81e  Moving all of the ca-specific settings to the ca_file terminus classes, rather than the normal :file classes.
cbe5221  Adding SSL::Host-level support for managing the terminus and cache classes.  Also, defaulting to the :file terminus for all of the SSL classes.
c5f0eff  Fixing the CA so it actually automatically generates its certificate.
3d24b12  The certificate authority now uses a Host instance named 'ca'.
daa8cd5  Changing all of the SSL terminus classes to treat CA files specially.
7d2c05e  The 'destroy' method for the ssl_file terminus base class now returns false on missing files, rather than failing.
7555af6  Marking a test as pending, because it's not ready yet.
c19c9d4  Removing all the cases where the ssl host specifies a terminus.  Also, getting rid of some metaprogramming that wasn't really helping.
054e4e4  Making the first pass at using requests instead of specifying the terminus class.  The individual ssl classes now work, but the ssl host class doesn't yet.
6900f97  Adding a :to_text method that will convert the contained thing to readable human text.
174b9c9  Actually signing the certificates in the CA.
546ac97  Adding the first attempt at managing the certificate revocation list.
c98ad25  Adding a :search method to the ssl_file terminus type and the SSL::Host class.
d184b35  Fixing a failing test that had not been updated from previous coding
b9d6479  We have a basically functional CA -- it can sign requests and return certificates.  There's still plenty more work to do, but I'm probably not much more than a day away from redoing puppetca to use this code.
1efed03  Adding tests for the easy bits of the CertificateFactory. I probably am going to skip the tests for the rest, since the code is unlikely to ever change, and it's going to be a royal pain to test.
ee07d0b  Adding tests for the certificate serial numbers
dc5c73b  The certificate authority is now functional and tested.
a776a12  refactoring the cert request test a bit
7641bd4  This is a first pass at the certificate authority. The tests are basically entirely absent still, but the structure is all there.
0f46815  It looks like all of the new ssl classes for managing keys, certificates, and requests now work, including talking to the certificate authority.  Now we just need the authority itself, along with the necessary REST terminii.
00e35bc  Adding he last of the indirection classes for the ssl classes, finally including the certificate requests.
8347b06  The certificate and key are now correctly interacting with the existing cert/key store.  Certificate requests are not yet handled, nor are the ca-specific collections.
50f3c18  Removing obsolete indirection classes
ec5bdf3  The basics for the certificate and certificate request indirection terminii are done.  I need to move most of the test code to a shared behaviour now.
bb87464  Fixing a couple of broken tests.
b0811ad  The new SSL classes basically work, but they're not functionally connected to any kind of indirection.
3970818  Finished the certificate request wrapper class.
4ca6fd3  First stage of cert refactoring:  Private keys kind of work.
ef7d914  Oops; final fix on the integration test failures resulting from my partial support for ssl in webrick.
0ca0ef6  Fixing whitespace problems.
4640a3d  Fixing an integration test of the rest terminus; it was broken by my incomplete cert support in webrick.  I just stubbed out the cert usage for now; once all the cert stuff is done we'll need to go back and unstub it.
d738f31  Adding the necessary tests for webrick to have logging and ssl.  The tests can't be completed until the certificate work is all done.
b49fb68  Fixing the tests in test/ that were broken as a result of the move to no global resources.
5e78151  Fixing tests that were failing as a result of the merge, including removing some now-obsolete code and tests from the Settings class.
bee9aba  Environments are now available as variables in manifests, and specs can be directly executed again.
b225e86  Fixing #1017 -- environment-specific modulepath is no longer ignored.
4ede432  Tidied the man page creation function and created "master" branch man pages
f335dc3  Updated defaults.rb to fix foru error stopping man page creation - links are not as neat as before but puppet.conf.man file will create neatly now.
c751058  Removed remaining elements of old_parse - closing Ticket #990
31e0850  Removed old configuration file behaviour and deprecation warning - closes ticket #990
4165eda  More fixes to the testing.
cfda651  Another round of test-fixes toward eliminating global resource references.  This should have gotten rid of all of them, and now it's just a question of fixing a few hopefully unrelated failing tests.
488c437  Fixing automatic relationships.  I was previously looking them up in the relationship graph, which only stores the vertices, not the resource table.
d8991ab  Updated install.rb to product puppet.conf.man page - updating ticket #198
5a0388f  Disabled new man page creation support
e5888af  Added support for man page creation - requires rst2man.py and writer - closed ticket #198
5bef4a5  Another round of fixes toward making global resources work.
3cc3e0f  Lots o' bug-fixes toward getting rid of global resources. We still have about 60 failing tests, but some of them are the failing directory service tests (probably 20 or so), and most are simple fixes to the tests themselves.
b7b11bd  Fixing a couple of failing tests
aed51b4  Fixed puppet logcheck issues
7aa79e2  Revert "Fixed documentation for code option in defaults.rb"
f2991a2  Revert "Fixed indentation error in pkgdmg.rb documentation"
754129e  Revert "Fixed issue where permissions are incorrectly set on Debian for /var/puppet/run directory"
20628ea  Added patch to ext/logcheck/puppet to fix ticket #978
badf977  Fixed indentation error in pkgdmg.rb documentation
e6547f0  Fixed documentation for code option in defaults.rb
594a5a3  Fixed issue where permissions are incorrectly set on Debian for /var/puppet/run directory
9736b3c  Updated for 0.24.0
99f9047  tweaking spec language; require Puppet::Network::HTTP class since it is referenced by Puppet::Network::Server
b38f538  Moving $PUPPET/spec/lib/autotest up to $PUPPET/autotest as something has changed and it can't be found otherwise.
e1abfac  moving autotest directory to make it possible to run autotest again

0.24.9
======
0dee418  Fixed typo in util.rb
df33cb0  Updated CHANGELOG
a22a088  Updated version to 0.24.9
0aae57f  Backport of tmpfile patch from 0.25.2
9a26421  Brought in lutters parse_commands patch and integrated it into the type. This includes reworking the get and match commands as well. This change introduces a few small changes. These are:
916dd60  Fixed rspec gem at version 1.2.2
57b37e5  Add @options to test run call, for compatibility with more recent rspec versions.
0863a79  Adding #2122 - you can specify the node to test with puppet-test
a43137c  More RST fixes
843cc6e  Fixed RST for functions
6160aaf  In order for ReST formatting to work properly, newlines and indentation of doc strings must be retained.
d125937  Added rake ci:all task
c62c193  Updated to version 0.24.8
aa00bde  Fixing #1631 - adding /sbin and /usr/sbin to PATH
39deaf3  Fixed #2004 - ssh_authorized_key fails if no target is defined
dcf2bf2  Changelog entries for #1629 and #2004
bbcda1d  Fix Bug #1629
69a0f7d  Fix #1807 - make Puppet::Util::Package.versioncmp a module function
081021a  Fix #1829 - Add puppet function versioncmp to compare versions
2b33f80  Fixed install.rb typo
5ab63cd  Updated lib install permissions to 0644

0.24.8
======
02a503f  Updated to version 0.24.8
cbc46de  Fixing #1631 - adding /sbin and /usr/sbin to PATH
9eb377a  Fixed #2004 - ssh_authorized_key fails if no target is defined
1b3fe82  Changelog entries for #1629 and #2004
8a671e5  Fix Bug #1629
ff5b13a  Fix #1807 - make Puppet::Util::Package.versioncmp a module function
991f82c  Fix #1829 - Add puppet function versioncmp to compare versions
d0bf26e  Fixed install.rb typo
4cf7a89  Updated lib install permissions to 0644
2c7e189  Fixes incorrect detail variable in OS X version check, re-patches ralsh to work with Facter values and adds error check for missing password hash files.
73a0757  Fix #1828 - Scope.number? wasn't strict enough and could produce wrong results

0.24.8rc1
=========
84d6637  Fixed #2000 - No default specified for checksum
a3bb201  Fixing change printing when list properties are absent
67fc394  Fixed #2026 - Red Hat ignoring stop method
cf64827  Bring in the documentation changes from the master branch
01bc88c  Added a force option to ensure the change is always applied, and call augeas twice to reduce the chance that data is lost
cedeb79  Backport the fix for #1835
cf48ec0  First cut at the not running if augeas does not change any of the underlieing files
9d36b58  Bug 1948: Added patch by jab to support the correct ins syntax. Updated the test cases as well
61661b1  Fixing #1991 - ldap booleans get converted to booleans
d5850dc  Refactored a method: extracted about five other methods
1c7c8fe  dbfix - fix typo and close another possible inconsistency
c55ac3f  Fix #2010 - add protection code for some storeconfig corruption
a790ee3  Further fix to #1910
9577d3a  Fixing #2013 - prefetching had a mismatch between type and title
719a8df  Fixed to rake tests for reductivelabs build
ac87600  Fixed report reference page
0c16426  Fixing broken 0.24.x tests in test/.
23066c1  Fixing every failing test I can find on the build server.
ec56ddf  This script fixes the most common issues with inconsistent storeconfigs database (including duplicate resources record, duplicate param_values records, dangling records...).
c052ff8  Make puppetd --waitforcert option behave as documented:
e2b4062  Adding a performance optimization to the FileCollection.
fa6494b  Using the FileCollection where appropriate.
373d505  Adding a FileCollection and a lookup module for it.
0e46786   Fixed #1963 - Failing to read /proc/mounts for selinux kills file downloads
4170238  Fixed #2025 - gentoo service provider handle only default init level
8c010e0  Fixed #1910 - updated logcheck
7504b04  Updated useradd.rb managehome confine to include other RH-like distributions
f07d928  Use Puppet.debug instead of own debug flag
25a3f59  Fixing #558 - File checksums no longer refer to 'nosum'
d758f45  Fixing #1871 once and for all - contents are never printed
c0f4943  Minor fix to launchd tests
24d48e6  Fix #1972 - ActiveRecord fixes resulted in broken tests
446989b  Fix spec test for launchd service provider to work with new service status method and add two new status tests.
3ef5849  Fixing a test I broke in commit:"897539e857b0da9145f15648b6aa2ef124ec1a19".
72bd378  Removing a no-longer-valid test.
682dd8b  Fixing password validation to support symbols.
44f97aa  Only backing up within parsedfile when managing files
04af7b4  Fixing a syntax error in the up2date provider
1070b3c  Fixing a test broken by a log demotion
ab84756  Cleaned up variable names to be more sane, clarified error messages and fixed incorrect use of 'value' variable rather than 'member'.
7f41857  Provide dscl -url output support for OS X 10.4 clients using the directoryservice provider.
0bc3c07  Fix launchd service provider so it is backwards compatible with OS X 10.4 as well
2561c8e  Updated Augeas type code
7d72186  Removed site from Puppet VIM syntax
1bc7404  Fixed #1831 - Added sprintf function
336b645  Fixed #1830 - Added regsubst function
2a85551  Bug 1948: Add logic and testing for the command parsing logic
2218611  Updated up2date and service confines to add support for Oracle EL and VM
39a8b28  Fixing #1964 - Facts get loaded from plugins
7cf085c  Adding tests for Puppet::Indirector::Facts::Facter.loadfacts
70ea39a  Adding a post-processor for Nagios names.
4dfa034  Revert "Refixing #1420 - _naginator_name is only used for services"
d5a193a  Fixing #1541 - ParsedFile only backs up files once per transaction
53f15b9  Removing the apparently obsolete netinfo filetype.
4e89156  Migrated FileType tests to spec, and fleshed them out a bit.
cc4d658  Bug #1948: Added patch by jab to support the correct ins syntax. Updated the test cases as well
5e35166  Fixing #961 - closing the http connection after every xmlrpc call
af3f3ae  Refactoring the XMLRPC::Client error-handling
f0ac3ae  Fixed #1959 - Added column protection for environment schema migration
319822a  Fixing #1869 - autoloaded files should never leak exceptions
6b0c1b9  Fixing #1543 - Nagios parse errors no longer kill Puppet
7fd5c7e  Moving the transaction specs to the right path
efb5cc5  Refixing #1420 - _naginator_name is only used for services
32c2be9  Fixed #1884 - exported defines are collected by the exporting host
0e49159  Cleaning up the AST::Resource code a bit
b22d148  Fix #1691 - Realize fails with array of Resource References
6331bfc  Fix #1682 - Resource titles are not flattened as they should
7e036eb  Fix #1922 - Functions squash all arguments into a single hash
535fa89  Fixed #1538 - Yumrepo sets permissions wrongly on files in /etc/yum.repos.d
f7b04df  Fixed #1936 - Added /* */ support to the vim file
671d73c  Prefetching, and thus purging, Nagios resources now works *only* if you use the default configuration file locations.
063871f  Adding some basic tests for the Naginator provider base class
897539e  Removing a redundant instance prefect call.
012efe3  Fixing #1912 - gid still works with no 'should' value.
a9f34af  Fixing the Rakefile to use 'git format-patch'.
db05c00  Fixing #1920 - user passwords no longer allow ':'
aa219e7  Adding README.rst file
1d3f117  Added Reductive Labs build library
f01882d  Change the way the tags and params are handled in rails
b7ab54c  Add methods to return hash instead of objects to params and tags
5c64435  Rails serialization module to help serialize/unserialize some Puppet Objects
b27fccd  Fixed #1852 - Correct behaviour when no SELinux bindings
7403330  Updated Red Hat spec file 0.24.7

0.24.7rc1
=========
84d6637  Fixed #2000 - No default specified for checksum
a3bb201  Fixing change printing when list properties are absent
67fc394  Fixed #2026 - Red Hat ignoring stop method
cf64827  Bring in the documentation changes from the master branch
01bc88c  Added a force option to ensure the change is always applied, and call augeas twice to reduce the chance that data is lost
cedeb79  Backport the fix for #1835
cf48ec0  First cut at the not running if augeas does not change any of the underlieing files
9d36b58  Bug 1948: Added patch by jab to support the correct ins syntax. Updated the test cases as well
61661b1  Fixing #1991 - ldap booleans get converted to booleans
d5850dc  Refactored a method: extracted about five other methods
1c7c8fe  dbfix - fix typo and close another possible inconsistency
c55ac3f  Fix #2010 - add protection code for some storeconfig corruption
a790ee3  Further fix to #1910
9577d3a  Fixing #2013 - prefetching had a mismatch between type and title
719a8df  Fixed to rake tests for reductivelabs build
ac87600  Fixed report reference page
0c16426  Fixing broken 0.24.x tests in test/.
23066c1  Fixing every failing test I can find on the build server.
ec56ddf  This script fixes the most common issues with inconsistent storeconfigs database (including duplicate resources record, duplicate param_values records, dangling records...).
c052ff8  Make puppetd --waitforcert option behave as documented:
e2b4062  Adding a performance optimization to the FileCollection.
fa6494b  Using the FileCollection where appropriate.
373d505  Adding a FileCollection and a lookup module for it.
0e46786   Fixed #1963 - Failing to read /proc/mounts for selinux kills file downloads
4170238  Fixed #2025 - gentoo service provider handle only default init level
8c010e0  Fixed #1910 - updated logcheck
7504b04  Updated useradd.rb managehome confine to include other RH-like distributions
f07d928  Use Puppet.debug instead of own debug flag
25a3f59  Fixing #558 - File checksums no longer refer to 'nosum'
d758f45  Fixing #1871 once and for all - contents are never printed
c0f4943  Minor fix to launchd tests
24d48e6  Fix #1972 - ActiveRecord fixes resulted in broken tests
446989b  Fix spec test for launchd service provider to work with new service status method and add two new status tests.
3ef5849  Fixing a test I broke in commit:"897539e857b0da9145f15648b6aa2ef124ec1a19".
72bd378  Removing a no-longer-valid test.
682dd8b  Fixing password validation to support symbols.
44f97aa  Only backing up within parsedfile when managing files
04af7b4  Fixing a syntax error in the up2date provider
1070b3c  Fixing a test broken by a log demotion
ab84756  Cleaned up variable names to be more sane, clarified error messages and fixed incorrect use of 'value' variable rather than 'member'.
7f41857  Provide dscl -url output support for OS X 10.4 clients using the directoryservice provider.
0bc3c07  Fix launchd service provider so it is backwards compatible with OS X 10.4 as well
2561c8e  Updated Augeas type code
7d72186  Removed site from Puppet VIM syntax
1bc7404  Fixed #1831 - Added sprintf function
336b645  Fixed #1830 - Added regsubst function
2a85551  Bug 1948: Add logic and testing for the command parsing logic
2218611  Updated up2date and service confines to add support for Oracle EL and VM
39a8b28  Fixing #1964 - Facts get loaded from plugins
7cf085c  Adding tests for Puppet::Indirector::Facts::Facter.loadfacts
70ea39a  Adding a post-processor for Nagios names.
4dfa034  Revert "Refixing #1420 - _naginator_name is only used for services"
d5a193a  Fixing #1541 - ParsedFile only backs up files once per transaction
53f15b9  Removing the apparently obsolete netinfo filetype.
4e89156  Migrated FileType tests to spec, and fleshed them out a bit.
cc4d658  Bug #1948: Added patch by jab to support the correct ins syntax. Updated the test cases as well
5e35166  Fixing #961 - closing the http connection after every xmlrpc call
af3f3ae  Refactoring the XMLRPC::Client error-handling
f0ac3ae  Fixed #1959 - Added column protection for environment schema migration
319822a  Fixing #1869 - autoloaded files should never leak exceptions
6b0c1b9  Fixing #1543 - Nagios parse errors no longer kill Puppet
7fd5c7e  Moving the transaction specs to the right path
efb5cc5  Refixing #1420 - _naginator_name is only used for services
32c2be9  Fixed #1884 - exported defines are collected by the exporting host
0e49159  Cleaning up the AST::Resource code a bit
b22d148  Fix #1691 - Realize fails with array of Resource References
6331bfc  Fix #1682 - Resource titles are not flattened as they should
7e036eb  Fix #1922 - Functions squash all arguments into a single hash
535fa89  Fixed #1538 - Yumrepo sets permissions wrongly on files in /etc/yum.repos.d
f7b04df  Fixed #1936 - Added /* */ support to the vim file
671d73c  Prefetching, and thus purging, Nagios resources now works *only* if you use the default configuration file locations.
063871f  Adding some basic tests for the Naginator provider base class
897539e  Removing a redundant instance prefect call.
012efe3  Fixing #1912 - gid still works with no 'should' value.
a9f34af  Fixing the Rakefile to use 'git format-patch'.
db05c00  Fixing #1920 - user passwords no longer allow ':'
aa219e7  Adding README.rst file
1d3f117  Added Reductive Labs build library
f01882d  Change the way the tags and params are handled in rails
b7ab54c  Add methods to return hash instead of objects to params and tags
5c64435  Rails serialization module to help serialize/unserialize some Puppet Objects
b27fccd  Fixed #1852 - Correct behaviour when no SELinux bindings
7403330  Updated Red Hat spec file 0.24.7
8befc18  Updated to version 0.24.7
cf19bd8  Not using a temporary file when locking files for writing.
b966ea0  Modifying the corruption-checking test.
1f34bca  Issue 1804 VDev with the same devices should be in sync
6d5a129  Documentation fixes
45144a1  Fixing #1812 (hopefully) - adding read and write locks to yaml.
2385a78  Preparing to fix #1812 - Moving locking code to a module
2961b83  Fix #1815 - puppetdoc --all crash on resource override
e5c36fd  Fix ZFS autorequire test
da71ad5  Add a unique name to objects so we can determine uniqueness when read back in
4418b34  Fix launchd service test on non-OSX platforms
4b2bdf9  Fix the spec tests to work on other platforms, do the confine around OS X versions more sanely
544a3e1  remove unnecessary mk_resource_methods call
50ac03a  CHANGELOG updates
a0a6d2c  Add a unique name to objects so we can determine uniqueness when read back in
68ffd46  Bug #1803 Zfs should auto require the ancestor file systems
7e2da7e  Refactor #1802 Use 'zfs get -H -o value' instead of parsing output for value
8616d74  Fixing #1800 - tidy now correctly ignores missing files and directories
6075d10  Fixing #1794 - returning sync when it is already initialized
18fe5c3  Fixing #1750 again - All of the properties and now :ensure check replace?
b22303e  Fix rake abort when there is a matching confine
0caa9c5  spec tests for type and provider and some code cleanup to adhere to DRY
0f2fc88  Finished work on rules creation and deletion
ed49153  new better way of doing stdin
05e05bb  finished rights flush, working on rules
1e37230  macauthorization type
4ed73ef  reset macauthorization tree. Initial checkin of new type/provider
5d32cd9  add NetInfo deprecation notice to user and group providers, make the directoryservice user provider the default, remove default for darwin from NetInfo providers
99ab940  Warn that the NetInfo nameservice provider is deprecated. Use directoryservice instead
c4412ec  add some more sanity checks around stdin
7de82c3  add support for stdin to Puppet::Util.execute
edef064  Make ralsh behave more sanely for non-existent objects and property values
9384a4a  Added git changelog task
c398db1  Bug #1780 Fixing meaningless test
278bfe8  Fixing mcx test failures (only happened sometimes).
c4812b8  Need to stub out the defaultprovider call for non Mac platforms
b444e43  remove extraneous comments
49d4d01  Trim down the after block clears to try to make the tests work for the build servers
65d6b49  Updated mcx type and provider with comprehensive spec tests.
fd128d6  Fixing a package test to be *much* faster
cdcbc5b  Fixing splaytime tests
6a4c0d5  Removing debugging from the "resources" type
0c6a151  Fixing a test that fails depending on test execution order
968f5cc  Relicense under GPLv2+
9ab3afb  Hopefully fixing #1703 - using a mutex around the sending of the tagmails
3fe9cc7  Fix #1741 - fix some failing tests on some ruby versions.
3570c71  Fix #1788 - allow rspec rake to run only some tests
1b3a7d8  Fixing the AST constant warnings, using a variable instead of a constant
091b8bf  Fixing #1785 - selinux tests no longer break other tests
c005dcf  Ticket 1780 - Solaris RBAC roles should be autorequired
3eff225  Feature 1696 Add support for branded zones
fa9820b  Bug #1778 - Solaris RBAC profiles should maintain order
f6fa4f7  Bug # 1680 Now you can set the hashed passwords on solaris
0a40668  Feature #1783 - Add ZFS support
047e5d0  Handle password when user is created
88edf66  == is not =
a219c88  Solaris doesn't have a native tool to set hashed passwords
9329c95  type/mcx.rb Feature #1026 - MCX Type
83b3a1e  Simplify launchd service provider and add tests
65a6074   Fixed #1695 - Solaris 10 zone provider doesn't properly handle unknown zone attributes in newer releases
0171e25  Fixing #1749 - Splay now hopefully behaves "better" for small values.
607958c  Fix #1741 - Add inline_template function
cc45c43  Fix #1741 - refactor TemplateWrapper, test for template function
d8c741f  Fix #1741 - Puppet::Parser::Functions rmfunctions and unit test
3c4efa7  Fixes #1773 - no longer check for absolute paths
3a39509  make sure only types that have passwords search for the password
a45c6b1  fix bug with numeric uid/gid in directoryservice provider. doc string cleanups
1f52795  Documentation fix for runit provider
81a91a7  Documentation fix for daemontools provider
4f67a7c  Fixed #1776 - Trivial fix for gentoo service provider
2764ab4  Rename migration so it's still applied
965c08d  Slight denormalisation to store a host's environment as a first class object in the database Fixes: #1392
5742966  Fixing #1743 - defined types get catalogs too.
31ec3e6  Adjusted CI tasks exit codes
3421954  Fixing #1755 - handling fully qualified classes correctly.
a1ac9a5  Added Rake :ci namespace and CI tasks
d978668  Lots of DirectoryService work. New Computer Type. Users now use password hashes. Groups now support setting members as attributes of the group for OS X.
86ce934  launchd service provider
97a8177  Refactoring the thread-safety in Puppet::Util a bit.
78bced1  Fixing #1683 - accessing and changing settings is now thread-safe.
83cebb5  Partially fixing #1772 - fixing selinux tests broken by removal of extraneous 'stat' in :file.
a839fe2  Partially fixing #1772 - fixing tidy code I broke.
5bd27c8  Partially fixing #1772 - broken 'resources' tests.
a3140b2  Manually setting an env var to mark autotest enabled so we see color
bbad983  Removing the included testing gems; you must now install them yourself.
b415848  Fixing #1708 - user groups specified as names are now detected correctly.
9ed382d  Fixed #1767 - Minor fix to emacs mode
27a750d  Revert "Fixing #1755 - File modes (and other strange properties) will now display correctly"
eb0d32a  Fixing #1764 - a property's 'sync' method is never considered a no-op.
e9f858a  Refactoring the file/owner property to be simpler and cleaner.
ed4c405  Fixing #1755 - File modes (and other strange properties) will now display correctly in ralsh and generated manifests.
c65f2b5  Fixed #1668 - puppetca can't clean unsigned certs
1ad33cc  Fix #1759 - Comparison operator was using string comparison for numbers
c96d250  Fixed #1711 - fileserver test fails due to incorrect mocking
8523a48  Fixed #1751 - Mac OS X DirectoryService nameservice provider support for plist output and password hash fil
d32d7f3  Fixed #1752 - Add an optional argument to Puppet::Util.execute to determine     whether stderr and stdout are combined in the output
4396740  Fix the init service type to cope with an array for defpath and if defpath does not exist
3c870d8  Added versionable feature to the RPM provider
f62d04d  Fixing broken tests resulting from the fix to #1747
030c791  Moved RRD feature from util/metric.rb to feature/base.rb
dc192b0  Manifest documentation generation
2c05a0a  Move function existance test to parser evaluation
064fb00  Add a doc attribute to AST nodes and fill it with the last seen comments
724a6f6  RSpec tests for the doc system (covers AST.doc, lexer and parser)
b8ed667  Fixed #1735 and #1747 - Fixes to confine system
6be5ac8  CHANGELOG updates
0ca5025  Fixed #1718 - Added preseed to apt uninstall and purge
01976ca  Include spec directory in packages
c98f7a5  Fixing the provider's confine subsystem so the logs are more useful.
6426a29  Removed extra 'end' from yum.rb
1e81739  Fix bug #1746: Sync SELinux file attributes after file contents created/modified
cebadd9  Fix bug #1681: Add filesystem type check to test for per-file SELinux context support
60455e7  Quiet debug when no default SELinux context found for one of the components
71a9e60  Fixes relating to transition to native SELinux bindings
3a5dcab  Refactoring of SELinux functions to use native Ruby SELinux interface
d5e19f1  Fixed #1739 - Added uninstall functionality to yum provider
bf5be00  Fix #1737 - part2 - Fix display of "options"
e032034  Fix #1737 - ssh_authorized_keys should be able to parse options containing commas
e33d087  Fix #1740 - Daemontools and Runit is not ReST compliant
dfc0554  Fixed #1730 - Edited file/ensure.rb docs for clarity
6d7b5ef  Fixes #1672 - unsafe crontab handling in Solaris Signed-off-by: Martin Englund <martin@englund.nu>
083077d  Fixing the augeas type tests to work when augeas is missing
0a3d34d  Fixes #1714 - yumhelper handling with yum 2.2.x is broken
7b70e85  Fixed #1721 - puppet.conf documentation incorrectly lists signals that affect the daemons
781a685  Fixing a test I broke when fixing a reporting bug
f063517  Added unit tests for the augeas type and provider
2d37f09  Fix #1402 - Allow multiline comments
9f30306  Fix #857 - Multiple class of the same name don't append code
649a9e0  Fixed augeas examples in type
56f3be6  Fixed #1710 - Spurious output in test run
4806c51  Fixing #1669 - The dump parameter can now be changed on mounts.
c7ccc4b  Fix #1682 - ASTArray should flatten product of evaluation of its children
c906afd  Fixing #1667 - regex automatic value documentation is now readable.
9fd1756  Split Augeas up into a provider and a type.
e542f8c  Fixed #1692 - k5login fails to set mode when file is created
57e791b  Fixing #1660 - Adding specifically supported values for tidy recursion.
42cac73  Fixing #1698 - all logs again show up in the report.
6ab4f1b  Fixed #1661 - Type reference: tidy should specify manditory parameters
2459106  Removing all mention of EPM, RPM, or Sun packages.
9ecbd63  Fixed #1104 - Classes and nodes should set $name variables
bc8cdb1  Beginning provider split, need help on the voodoo
6539f55  Updated Red Hat spec file for 0.24.6 and removed conf/debian directory.
cacafeb  Added augeas type and feature

0.24.6
======
b2c1149  Updated to version 0.24.6
5ba54d2  Updated to version 0.24.6
22024bc  Improve the inline documentation for SELinux types and parameters
f216237  Fixes #1663 - added Symbol check and additional test
81c3b72  Fix SELinux test to succeed when Puppet debug mode is enabled
f7516a7  Fix regression caused by switch to Puppet's execute() functions
c09d0cc  Solaris RBAC Attributes
6d05cbc  Fix #936 - Allow trailing comma in array definition
ec2b461  Fix #1115 - part2 - fix tests and add all_tags
356d8ca  Fixed #1662 - Configuration Reference still references 'section'
b53509b  Fixed #1460 - enhance redhat puppetmaster init.d script to easy start puppetmaster as a mongrel cluster
8a4e2e9  Fixed #1663 - Regression relating to facter fact naming from 0.24.5
e6f99f9  Fix #636 - Allow extraneous comma in function argument list
a74ec60  Fixing tests I broke when trying to fix the Providers reference.
d4df361  Use fully qualified paths when calling binaries, adjust chcon call to use Puppet's execute() function.
dedf0cd  Setting SELinux contexts with chcon should not dereference symbolic links
7f5ded1  Fixed #1646 - service puppet status does not work as non-root on redhat system
00d5fe4  Fix #1115 - Allow checking tags/classes from ERb templates
f5fb2d3  Fixed #1649 - OS X package creation script should be more selective about cleaning out prior versions
b0fd2e0  Fixing #1647 - puppetdoc's 'providers' report works again.
157c0dd  Fix 1642 (always warning) and improve unit tests to cover when to warn and not
65eafb7  lazy load latest package definitions with yumhelper 2.2
eff6ce0  Revert "Added last part of #1633 patch - update to util/metrics.rb"
c5d1a4f  Added last part of #1633 patch - update to util/metrics.rb
0fff7d7  Fixing some tests that were broken in 2fba85af
2afbd0d  Fixing a test that was failing as a result of the fix to #1491
b0c01da  Adding an additional option for the fix in ff36832e, skipping missing cert dirs
aea5582  Removing a gid test for users, since it is a bad test and has mostly been replaced in rspec
65d3040  Fixing a test that was broken in ee579641
b08002e  Fixing some tests that were broken in the fix for #1633
2bf0ba5  Fixing a test that was failing because i-have-no-idea
952ebb8  Fixing a test that was failing because of the change to retrieve() in ee579641
a5fe87f  Fixing a file source test that was failing because missing sources is now a failure
53b7d42  Fixing the broken tests resulting from the fix for #1551.
5ec6b07  Adding warnings when example groups are skipped.
54abe70  Moving some test/ package tests to rspec integration tests and disabling a gem test that hangs forever for me.
85d3ae0  Cleanup selboolean and selmodule unit tests to pass on non-SELinux systems
a562ce5  Add unit test coverage for Puppet::Util::SELinux and fix problems found by tests
2b4aa0c  Fixed #1639 - uninitialized constant Puppet::Type::User::ProviderUseradd
4265825  Fix #1636 - part2 - correct some client errors.
9c31db9  Add failing test for plugin with file and recurse
2853447  Fix several small regressions in plugins mount
2153bae  Fixing #1640 - file groups now no longer get set on every run (this was a regression caused by other work I did).
80e5c11  Incremented CHANGELOG to 0.24.6
996ac46  Fix scenario when SELinux support tools exist, but SELinux is disabled
d803096  Add new set of unit tests for selmodule type
a3f34f9  Removal of redundant lines from unit test
307260f  Remove old selboolean unit tests and fix permissions on new tests
2ebd34e  Rewrote seboolean unit tests to provide better coverage
4df51ea  New and improved tests for file type SELinux contexts
253d4df  Fix regression when templatedir doesn't exist.
c7a6ef2  Fix #1202 - Collection attribute matching doesn't parse arrays
3281f2b  Fixed #1633 - Added support for --detailed-exits to bin/puppet which causes puppet to produce different exit codes depending on whether there were changes or failures in the transaction.
0b1e60f  Adding an array indexer method to Puppet::Util::Metric as requested in #1633.
765db30  Adding partial spec tests for Puppet::Util::Metric.
fb14e91  Fixed #1473 - Rescue Timeout::Error in xmlrpc clients
7275d7c  Fxied #1354 - yum provider problems with RHEL 3
0c297be  Fix #1109 - allow empty if or else branches
5268487  Fixed documentation, typo and added CHANGELOG entry
990e8e3  Fix #1530: Correctly parse ssh type 1 keys
06edac4  Fixed additional environments tests
79bb1f2  Rspec Tests for #381. Moved part of the old resource reference tests to rspec.
750e9ab  Fix #381 - Allow multiple resource overrides or references
782181e  Minor test fix for #1614
614326a  Fixing #1098 - Multiline strings now correctly increment the line count
1c6d57e  Doing some simple refactorings on Puppet::Log
a774443  Fixing #1089 - Log messages are now tagged with the log level, making it easier to match messages in the 'tagmail' report.
db7f108  Adding rspec tests for the Puppet::Util::Log class.
d2c8998  Fixed #981 - Removed 'Adding aliases' info message
d098a90  Fix failing tests dependent on /etc/user_attr file existing
6bcfd9f  Fixing #947 - pluginsync no longer fails poorly when no plugins exist
67136f1  Fixing the Node class to no longer validate environments since #1614 removed that validation.
a4110a3  Add SELinux context reset after file writes in Puppet::Util::FileType
250239e  Add new support for :selrange SELinux file property
c831482  Add detected defaults for existing SELinux file properties
772e9b2  Refactor SELinux commands to utility module
8153181  Clean up of SELinux rspec tests so all pass
e77ddc1  Merged fsweetser's selinux patch against HEAD
7272d49  Fixed #1613 - The client environment will be substituted when looking up settings.
1a9b567  Fixing #1614 - Environments no longer have to be listed out.
397c841  Fixed #1628 - Changed node search to use certname rather than Facter hostname
9d174c4  Updated puppet binary documentation
6a0b334  Fixed error message typo
655f378  Adding a rake task for sending emails to the dev list
d39bab9  Fixing package provider tests to use the new Transaction::Change interface
e32256a  Migrating the apt and dpkg tests to rspec.
ddda80a  Update change log with RBAC roles
d1abb86  Add role support to user type and an implemention
2fba85a  Some small clarifying refactors and change to objectadd to allow subclasses of with a uid not need to be a single class us use modify
4a863c3  Adding user_attr util to parse attributes on solaris
93f952a  Fixed #1586 - Specifying "fully qualified" package names in Gentoo
8620775  Fixed #791 - You should now be able to create and find a user/group in one transaction.
63ad845  Refactoring and adding tests to the file group property.
7da4152  Modified the group and zone resource types to no longer call 'currentpropvalues' as a means of setting all values to absent. There should be no behaviour change from this change.
ee57964  Modified the behaviour of resource-level 'retrieve' -- it only calls 'retrieve' on each property if the resource exists.
0fb4693  Updating changelog for #1622
2afc4f5  Adding tests for the user retrieve method
679fede  Removing commented code from the user type from about 2005
2480654  The Netinfo and DirectoryService providers can now create user and group simultaneously.
4c998fe  Fixing #1622 - The user type only looks up groups when necessary.
6bc56ae  Aliasing the rspec 'should' method to 'must' so it does not conflict with the RAL 'should' method.
b9c75cd  Rewriting the user tests, in preparation for enhancing them
99de920  Fixed #1620 - Add 'sles' to Puppet confines when 'suse' is used
4cf9710  Add parser for arbitrary expressions
cfa230a  Add arithmetic operators to AST
850e0ba  Add not operator to AST
9cdecfe  Add comparison operators (< > == != <= >=) to AST
8372dc4  Add boolean operators to AST
e6698c2  Add warning and forcibly set to :md5 fixing #1564
af8c706  Fix metadata class for cases when checksum_type set
860bdb1  Fixed #1603 - Added support for running Puppet inside a Rack application
b2f0d87  Fix ticket 1596 in new fileset code, use tmpdir in fileserver tests.
a30ecf2  Make fileserver use fileset for recursion and handle dangling links by ignoring them fixing #1544
3b80763  Add tests for FileServer::Mount list for #1544
3749267  Fixed #1610 - Raise "Filebucketed" messages to Notice priority
f792b64  Added a number of confines to package providers
074abd4  Fixed #1609 - Added confines for the Gentoo, FreeBSD and SMF (Solaris) service providers
2da6d19  Fixed #1608 - Added ubuntu to defaultfor for apt provider
aa629ec  Fixed #1607 - Added ubuntu to defaultfor for Debian service provider
774c0f9  Fixed #1588 - Fixed puppetca --clean --all
98e79f8  Fixed #1472 -- defined, exported resources in the current compile now get expanded correctly.
0040bc8  Fixed #1045 - Multiple metaparams all get added to resources.
8d5ded0  Removing some code in Parameter that is unnecessary.
5fbdc49  Fixed #1595 - Internally, Property#retrieve is no longer called when no 'should' value is available for a resource.
c16a5ae  Only apply splay the first run
27f0c7d  fix failing hpux user specs
7a3a38f  Add rspec unit test for the append operator
16793d2  Add an append (+=) variable operator:
7f8abbd  Bug #1550 - Rework to avoid regressing rspec tests, add new rspec tests for templatedir as a path
0905734  Allow a templatedir to be colon separated.
11b0848  Fixed #1500 - puppetrun host regression
3b1d6e2  Fixed #1579 and #1580 - errors in the Puppet RPM spec file
77f4fb6  Fixed #1521 -- ldap user and group are now used with the default connection when available.
a1a670b  Fixed #1572 -- file purging now fails if remote sources do not exist.
dd4f654  Fixing #1576 - moving all of the Puppet::Type code back into type.rb.
923fd89  Fixed issues with file descriptors leaking into subprocesses
cab5d85  Fixed #1571 - Puppet::Util::binary returns incorrect results
a7306e1  Fixed #1553 - Puppet and Facter cannot both install the plist module into two different locations
758505b  Fixed #1568 - createpackage.sh
7ce902d  Adjusted hpuxuseradd user provider to confine to HP-UX and fixed HP-UX user provider path regression
8f1336f  Fixed #1566 - changed password property of the user type
d4d3213  Fixed debug messages in package type - thanks to Todd Zullinger for this fix
b88df5a  Sync with latest Fedora/EPEL specfile
0705dfb  Fixes #1455 - Adds HP-UX support for user type
e15d316  Fixes #1551 puppetmaster.freshness xmlrpc call returns incorrect type
8fe0338  Fixes #1554 - Fix exception for undefined hostname
81cc9bf  Fixed #1533 - changed permissions for man directory
41dc1fa  Runit service provider
aae0793  Daemontools service provider
29ae879  Fixes tests broken by 95aa085
b50e718  Fixed #1488 - Moved individual functions out of functions.rb into the lib/puppet/parser/functions directory. New functions should be created in this directory.
5fb5091  Fixed #1457 - case insensitive match for error
ded94f7  Removed spec color option for buildbot
415663b  Added simple rake task for running unit tests
557be9d  Added spec Rake task
0d118a5  Fix leaking LoadedFile when adding templates to be watched
67387e2  Fixed #1506 - Removed storeconfig duplicate indexes
7accb89  id column is autogenerated by rails as a primary key, there is no need to create an additional index on this column. This changeset contains the new schema and a migration.
c5fb092  Removed reference to namespaces from --genconfig documentation
1729de1  Updates to ext/puppetlast to support multiple hosts
b6609ee  Fixed #1508 - Add HP-UX package provider.
3e482a2  Updating the authors list for the gem spec
2ec4e29  Fix #1502 - abysmal storeconfig performance - part2
9272df4  Fix #1052 - abysmal storeconfig performance - part1
f48a0ae  Fix #1510 - storeconfig fails with rails 2.1
b1ad596  Add the -P/--ping option to puppetrun, fixes #1501
6676b6b  Fixes #1274 - allow class names to start with numbers
d02f95c  Fixed #1394 - Added stored configuration clearing script to /ext
fb8cc53  Fixed #1442 - replaced use of Facter for report titling with certname
18dda20  Fixed $1456 - add proxy configuration to yum repo
ab4cb6a  Fixing #1447 -- Replacing Puppet::PackageError with Puppet::Error.
8a0cb16  Added tests for TemplateWrapper's use of Scope#to_hash.
3ae7eca  Fixing an ldap connectivity test
d3393b4  Added CHANEGLOG entry for removal of interface type
bfcdfe8  fix terrible error with overwriting permissions
0147570  Fixed #1457 - removed confine warning
fecdfbc  A working script to create an OS X pkg out of the Puppet repository
6a2e71d  Fixed #1441 - Updated console colours
404450a  Add testing for the changes to resolve redmine #1427, where Kernel methods shadow variables that the puppet template should otherwise see.  Specific changes:
03c76de  Expose all puppet variables as instance member variables of the template wrapper. This helps resolve redmine #1427, by providing a safe mechanism to access variables.
13069ec  Ensure that we consistently use either string #{} interpolation or String.% interpolation, not both, to avoid issues where a #{} interpolated value contains a % character.
